#include "StdAfx.h"
#include "..\MMD_String.h"
#include "VMD_Header.h"

namespace MMD {

	namespace VMD {

		Header::Header(void)
		{
			ModelName = gcnew MMD::String("");
			ModelName->SetLength(20);
		}

		Header::Header(System::String^ strModelName)
		{
			ModelName = gcnew MMD::String(strModelName);
			ModelName->SetLength(20);
		}

		Header^ Header::Copy()
		{
			Header^ header = gcnew Header();

			header->ModelName = ModelName->Copy();
			header->BoneLength = BoneLength;
			header->MorphLength = MorphLength;

			return header;
		}

	}//VMD

}//MMD
