#include "StdAfx.h"
#include "VPD.h"

using namespace System::Text;
using namespace System::Windows::Forms;

namespace MMD {

	namespace VPD {

		Item::Item(void)
		{
			Poses = gcnew ArrayList();
			ModelName = gcnew MMD::String("");//(ĂȂƂz肵)
		}

		Item^ Item::Copy()
		{
			Item^ item = gcnew Item();

			item->FileName = FileName;
			item->ModelName = ModelName->Copy();
			item->Poses = gcnew ArrayList();
			for (int i = 0; i < Poses->Count; i++) {
				item->Poses->Add(safe_cast<MMD::Pose^>(Poses[i])->Copy());
			}

			return item;
		}

		bool Item::Open() {//VPDt@CǍ(߂l: true=, false=s)

			Poses = gcnew ArrayList();//RNV̏

			bool ret = false;
			//StreamReader^ din = File::OpenText(FileName);
			// ms-help://MS.VSCC.v90/MS.MSDNQTR.v90.ja/dv_vccore/html/3296fd59-a83a-40d4-bd4a-6096cc13101b.htm uC++ ̃t@C I/O v
			//u@ : eLXg t@Cǂݍ vms-help://MS.VSCC.v90/MS.MSDNQTR.v90.ja/dv_vccore/html/80551c01-d769-4b6d-8db7-fd53bde21b62.htm
			//ɏĂTv́AFile::OpenText() ́Auǂݎp̊ UTF-8 GR[hꂽeLXg t@CJ܂BvȂ̂ŗvӁB

			try {
				StreamReader^ din = gcnew StreamReader(FileName, Encoding::GetEncoding("Shift_JIS"));
				System::String^ str;

				try {
					MMD::Pose^ pose;

					Regex^ rxBoneBegin = gcnew Regex("^Bone\\d+{(.+)$");//{[Jn
					Regex^ rxBoneEnd = gcnew Regex("^}$");//{[I
					Regex^ rxTrans = gcnew Regex("^\\s+([0-9\\.\\-]+),([0-9\\.\\-]+),([0-9\\.\\-]+);");//ړ
					Regex^ rxRot = gcnew Regex("^\\s+([0-9\\.\\-]+),([0-9\\.\\-]+),([0-9\\.\\-]+),([0-9\\.\\-]+);");//]

					//Ƃ肠AG[`FbNƂ܂薳̕ŁB
					while ((str = din->ReadLine()) != nullptr) {
						if (rxBoneBegin->IsMatch(str)) {//{[Jn
							if (pose != nullptr) {//{[Ǎ̂Ƃ
								throw(safe_cast<System::String^>("t@Č`Ⴂ܂B"));
							} else {
								MatchCollection^ matches = rxBoneBegin->Matches(str);
								pose = gcnew MMD::Pose();
								pose->Name = gcnew MMD::String(matches[0]->Groups[1]->Captures[0]->Value);//{[
							}
						} else if (rxBoneEnd->IsMatch(str)) {//{[I
							if (pose == nullptr) {//{[ǍłȂƂ
								throw(safe_cast<System::String^>("t@Č`Ⴂ܂B"));
							} else {
								Poses->Add(pose);
								pose = nullptr;
							}
						} else if (rxTrans->IsMatch(str)) {//ړ
							if (pose == nullptr) {//{[ǍłȂƂ
								throw(safe_cast<System::String^>("t@Č`Ⴂ܂B"));
							} else {
								MatchCollection^ matches = rxTrans->Matches(str);
								pose->Trans.X = Single::Parse(matches[0]->Groups[1]->Captures[0]->Value);//X
								pose->Trans.Y = Single::Parse(matches[0]->Groups[2]->Captures[0]->Value);//Y
								pose->Trans.Z = Single::Parse(matches[0]->Groups[3]->Captures[0]->Value);//Z
							}
						} else if (rxRot->IsMatch(str)) {//]
							if (pose == nullptr) {//{[ǍłȂƂ
								throw(safe_cast<System::String^>("t@Č`Ⴂ܂B"));
							} else {
								MatchCollection^ matches = rxRot->Matches(str);
								pose->Rot.X = Single::Parse(matches[0]->Groups[1]->Captures[0]->Value);//X
								pose->Rot.Y = Single::Parse(matches[0]->Groups[2]->Captures[0]->Value);//Y
								pose->Rot.Z = Single::Parse(matches[0]->Groups[3]->Captures[0]->Value);//Z
								pose->Rot.W = Single::Parse(matches[0]->Groups[4]->Captures[0]->Value);//W
							}
						}

					}
					ret = true;
				} catch (System::String^ strError) {
					MessageBox::Show(strError, "error");
				}
				din->Close();
			} catch (Exception^ e) {
				if (dynamic_cast<FileNotFoundException^>(e))
					MessageBox::Show("t@C܂B\n" + dynamic_cast<FileNotFoundException^>(e)->FileName, "error");
				else
					MessageBox::Show("t@CǍɖ肪܂B\n" + e->ToString(), "error");
			}

			return ret;
		}

	}//VPD

}//MMD
