#include "StdAfx.h"
#include "Edit_DeleteTempo.h"
#include "..\SMFView.h"

namespace MetMotMk {

	namespace Edit {

		DeleteTempo::DeleteTempo(System::Windows::Forms::Form^ form, TimeLine^ timeline,
						int track, int listIndex, int tempoIndex, SMF::Event^ ev, SMF::Position^ pos)
		{
			Name = "e|폜";
			m_form = form;
			m_timeline = timeline;//TimeLineւ̎Q
			m_track = track;//gbN
			m_listIndex = listIndex;//Xgr[̃CfbNX
			m_tempoIndex = tempoIndex;//e|`FWe[ũCfbNX
			m_ev = ev;//MIDICxgf[^
			m_pos = pos;//ʒu
			m_tc = safe_cast<SMF::TempoChange^>(m_timeline->smf->TempoChanges[m_tempoIndex]);//e|`FW
		}

		System::Void DeleteTempo::Do() {//̎s
			SMFView^ frm = safe_cast<SMFView^>(m_form);
			frm->RemoveEvent(m_track, m_listIndex);
			m_timeline->smf->TempoChanges->RemoveAt(m_tempoIndex);
			m_timeline->smf->CalcFrameAtTempoTable();//t[̍ČvZ
		}

		System::Void DeleteTempo::Undo() {//ɖ߂
			SMFView^ frm = safe_cast<SMFView^>(m_form);
			frm->InsertEvent(m_track, m_listIndex, m_ev);
			m_timeline->smf->TempoChanges->Insert(m_tempoIndex, m_tc);
			m_timeline->smf->CalcFrameAtTempoTable();//t[̍ČvZ
		}
	}//Edit

}//MetMotMk
