#include "StdAfx.h"
#include "Edit_ModelRename.h"
#include "..\TimeLineForm.h"

namespace MetMotMk {

	namespace Edit {

		ModelRename::ModelRename(System::Windows::Forms::Form^ form, TimeLine^ timeline, Model^ model, System::String^ old_name, System::String^ new_name)
		{
			Name = "fύX";
			m_form = form;
			m_timeline = timeline;//TimeLineւ̎Q
			m_model = model;//fւ̎Q
			m_old_name = old_name;//ύXO̖O
			m_new_name = new_name;//ύX̖O
		}

		System::Void ModelRename::Do() {//̎s
			m_timeline->Changed = true;
			m_model->Name = gcnew MMD::String(m_new_name);
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->UpdateTimeLine();
		}

		System::Void ModelRename::Undo() {//ɖ߂
			m_timeline->Changed = true;
			m_model->Name = gcnew MMD::String(m_old_name);
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->UpdateTimeLine();
		}

	}//Edit

}//MetMotMk
