#include "StdAfx.h"
#include "Edit_PatternDelete.h"
#include "..\TimeLineForm.h"

namespace MetMotMk {

	namespace Edit {

		PatternDelete::PatternDelete(void)
		{
		}

		PatternDelete::PatternDelete(System::Windows::Forms::Form^ form, TimeLine^ timeline, SelectedPatterns^ selectedPatterns)
		{
			Name = "p^[̍폜";
			m_form = form;
			m_timeline = timeline;//TimeLineւ̎Q
			m_selectedPatterns = selectedPatterns->Copy();//Ip^[
			selectedPatterns->Clear();//IԂ͂̒iKŃNAĂB
		}

		System::Void PatternDelete::Do() {//̎s
			for (int i = 0; i < m_selectedPatterns->Count; i++) {
				Pattern^ pat = m_selectedPatterns->GetPatternAt(i);
				pat->Model->Patterns->Remove(pat);
			}
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->UpdateTimeLine();
		}

		System::Void PatternDelete::Undo() {//ɖ߂
			for (int i = 0; i < m_selectedPatterns->Count; i++) {
				Pattern^ pat = m_selectedPatterns->GetPatternAt(i);
				pat->Model->Patterns->Add(pat);
			}
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->UpdateTimeLine();
		}

	}//Edit

}//MetMotMk
