#include "StdAfx.h"
#include "Model.h"

namespace MetMotMk {

	Model::Model(void)
	{
		Patterns = gcnew ArrayList();
	}

	System::Void Model::OnTopChanged(int new_Top) {//TopύXɂȂƂ
		for (int i = 0; i < Patterns->Count; i++) {
			Pattern^ pat = safe_cast<Pattern^>(Patterns[i]);
			pat->Top = pat->Top + new_Top - m_Top;
		}
	}

	System::Void Model::SaveVMD(String^ filename) {//VMDt@Cւ̏o
		//VMDۑpf[^̍쐬
		MMD::VMD::Item^ vmd = gcnew MMD::VMD::Item(Name->ToString());

		//Patterns RNVf[^oAۑp vmd->Bone, vmd->Morph RNVɒǉĂłĂ݂B
		//܂AArrayList ɂׂĒǉĂAۑp^[𓾂B

		for (int m = 0; m < Patterns->Count; m++) {
			Pattern^ pat = safe_cast<Pattern^>(Patterns[m]);
			if (pat->Type == Patterns::POSE) {//|[Yf[^x[X̃p^[̏ꍇ
				for (int p = 0; p < pat->vpd->Poses->Count; p++) {
					MMD::Pose^ pose = safe_cast<MMD::Pose^>(pat->vpd->Poses[p]);

					SMF::Position^ begin = gcnew SMF::Position(pat->Begin->smf);
					begin->GlobalTick = pat->Begin->GlobalTick + pat->Begin->ShiftTick;//VtgtickZ

					SMF::Position^ end = gcnew SMF::Position(pat->End->smf);
					end->GlobalTick = pat->End->GlobalTick + pat->End->ShiftTick;//VtgtickZ
					
					for (int i = 1; i <= pat->Repeat; i++) {
						//Jnʒu
						MMD::VMD::Bone^ bone = gcnew MMD::VMD::Bone();
						bone->SetName(pose->Name->ToString());
						bone->FrameNo = begin->Frame + pat->Begin->ShiftFrame;//Vtgt[Z
						bone->Pose.Trans.X = pose->Trans.X;
						bone->Pose.Trans.Y = pose->Trans.Y;
						bone->Pose.Trans.Z = pose->Trans.Z;
						bone->Pose.Rot.X = pose->Rot.X;
						bone->Pose.Rot.Y = pose->Rot.Y;
						bone->Pose.Rot.Z = pose->Rot.Z;
						bone->Pose.Rot.W = pose->Rot.W;
						vmd->Bone->Add(bone);
						if (!pat->NoLength) {//̏ꍇ
							//Iʒu
							bone = gcnew MMD::VMD::Bone();
							bone->SetName(pose->Name->ToString());
							bone->FrameNo = end->Frame + pat->End->ShiftFrame;//Vtgt[Z
							bone->Pose.Trans.X = pose->Trans.X;
							bone->Pose.Trans.Y = pose->Trans.Y;
							bone->Pose.Trans.Z = pose->Trans.Z;
							bone->Pose.Rot.X = pose->Rot.X;
							bone->Pose.Rot.Y = pose->Rot.Y;
							bone->Pose.Rot.Z = pose->Rot.Z;
							bone->Pose.Rot.W = pose->Rot.W;
							vmd->Bone->Add(bone);
						}
						//JԂ̎̈ʒu
						begin->Add(pat->Step);
						end->Add(pat->Step);
					}
				}
			}
		}

		//VMDt@Cւ̏o
		vmd->Save(filename);		

	}

	System::Void Model::AddPattern(Pattern^ pattern) {//PatternsRNVPatternǉB
		Patterns->Add(pattern);//RNVɒǉ
		pattern->UpdateRectangle();//TCYEʒǔvZ
		pattern->Model = this;//p^[Ƀf֘At
	}

}//MetMotMk
