#include "StdAfx.h"
#include "MMD_String.h"

namespace MMD {

	String::String(System::String^ str)
	{
		m_strString = str;
	}

	String^ String::Copy()
	{
		String^ string;

		if (m_strString == nullptr) {
			string = nullptr;
		} else {
			string = gcnew String(m_strString);
		}

		return string;
	}

	System::Void String::SetLength(int length) {
		m_length = length;
	}

	array<Byte>^ String::GetByte(int length) {//MMDf[^ݗp̃oCgf[^쐬B
		array<Byte>^ ret = gcnew array<Byte>(length);
		array<Byte>^ bytStr = System::Text::Encoding::GetEncoding("Shift_JIS")->GetBytes(m_strString);

		for (int i = 0; i < length; i++) {
			if (i < bytStr->Length) {
				ret[i] = bytStr[i];
			} else if (i == bytStr->Length) {
				ret[i] = 0x00;
			} else {
				ret[i] = 0xfd;
			}
		}

		return ret;
	}

	array<Byte>^ String::GetByte() {//MMDf[^ݗp̃oCgf[^ftHg̃oCgō쐬B
		return GetByte(m_length);
	}

	System::String^ String::ToString() {//System::String^ ւ̕ϊ
		return m_strString;
	}

} //MMD