#include "StdAfx.h"
#include "Edit_AddModel.h"
#include "..\TimeLineForm.h"

namespace MetMotMk {

	namespace Edit {

		AddModel::AddModel(System::Windows::Forms::Form^ form, TimeLine^ timeline, Model^ model) //f̒ǉ
		{
			Name = "fǉ";
			m_form = form;
			m_timeline = timeline;//TimeLineւ̎Q
			m_model = model;//ǉ郂fւ̎Q
		}

		System::Void AddModel::Do() {//̎s
			m_timeline->Models->Add(m_model);
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->ModelLayout();
			frm->UpdateTimeLine();
		}

		System::Void AddModel::Undo() {//ɖ߂
			m_timeline->Models->Remove(m_model);
			m_model->Selected = false;
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			for (int i = 0; i < m_model->Patterns->Count; i++) {
				Pattern^ pat = safe_cast<Pattern^>(m_model->Patterns[i]);
				if (pat->Selected) {
					frm->selectedPatterns->RemovePattern(pat);
				}
			}
			frm->ModelLayout();
			frm->SetModelMenuEnabled(false);
			frm->UpdateTimeLine();
		}

	}//Edit

}//MetMotMk
