#include "StdAfx.h"
#include "Edit_DeleteBeat.h"
#include "..\SMFView.h"

namespace MetMotMk {

	namespace Edit {

		DeleteBeat::DeleteBeat(System::Windows::Forms::Form^ form, TimeLine^ timeline,
						int track, int listIndex, int beatIndex, SMF::Event^ ev, SMF::Position^ pos)
		{
			Name = "q폜";
			m_form = form;
			m_timeline = timeline;//TimeLineւ̎Q
			m_track = track;//gbN
			m_listIndex = listIndex;//Xgr[̃CfbNX
			m_beatIndex = beatIndex;//qύXe[ũCfbNX
			m_ev = ev;//MIDICxgf[^
			m_pos = pos;//ʒu
			m_bc = safe_cast<SMF::BeatChange^>(m_timeline->smf->BeatChanges[m_beatIndex]);//qύX
		}

		System::Void DeleteBeat::Do() {//̎s
			SMFView^ frm = safe_cast<SMFView^>(m_form);
			m_timeline->smf->BeatChanges->RemoveAt(m_beatIndex);
			m_timeline->smf->CalcTickAtBeatTable();//tick̍ČvZ
			//frm->RemoveEvent(m_track, m_listIndex);
			frm->UpdateBeatTable();
			frm->UpdateTimeline();
		}

		System::Void DeleteBeat::Undo() {//ɖ߂
			SMFView^ frm = safe_cast<SMFView^>(m_form);
			m_timeline->smf->BeatChanges->Insert(m_beatIndex, m_bc);
			m_timeline->smf->CalcTickAtBeatTable();//tick̍ČvZ
			//frm->InsertEvent(m_track, m_listIndex, m_ev);
			frm->UpdateBeatTable();
			frm->UpdateTimeline();
		}
	}//Edit

}//MetMotMk
