#include "StdAfx.h"
#include "Edit_DeleteModel.h"
#include "..\TimeLineForm.h"

namespace MetMotMk {

	namespace Edit {

		DeleteModel::DeleteModel(System::Windows::Forms::Form^ form, TimeLine^ timeline, int modelIndex)
		{
			Name = "f폜";
			m_form = form;
			m_timeline = timeline;//TimeLineւ̎Q
			m_modelIndex = modelIndex;//폜郂f̃CfbNX
			m_model = safe_cast<Model^>(timeline->Models[modelIndex]);//폜郂fւ̎Q
		}

		System::Void DeleteModel::Do() {//̎s
			m_timeline->Models->RemoveAt(m_modelIndex);
			m_timeline->Changed = true;
			m_model->Selected = false;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			for (int i = 0; i < m_model->Patterns->Count; i++) {
				Pattern^ pat = safe_cast<Pattern^>(m_model->Patterns[i]);
				if (pat->Selected) {
					frm->selectedPatterns->RemovePattern(pat);
				}
			}
			frm->ModelLayout();
			frm->SetModelMenuEnabled(false);
			frm->UpdateTimeLine();
		}

		System::Void DeleteModel::Undo() {//ɖ߂
			m_timeline->Models->Insert(m_modelIndex, m_model);
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->ModelLayout();
			frm->UpdateTimeLine();
		}

	}//Edit

}//MetMotMk