#include "StdAfx.h"
#include "Edit_InsertTempo.h"
#include "..\SMFView.h"

namespace MetMotMk {

	namespace Edit {

		InsertTempo::InsertTempo(System::Windows::Forms::Form^ form, TimeLine^ timeline,
			int track, int listIndex, int tempoIndex, SMF::Event^ ev, SMF::TempoChange^ tc, SMF::Position^ pos)
		{
			Name = "e|}";
			m_form = form;
			m_timeline = timeline;//TimeLineւ̎Q
			m_track = track;//gbN
			m_listIndex = listIndex;//Xgr[̃CfbNX
			m_tempoIndex = tempoIndex;//e|`FWe[ũCfbNX
			m_ev = ev;//MIDICxgf[^
			m_tc = tc;//e|`FW
			m_pos = pos;//ʒu
		}

		System::Void InsertTempo::Do() {//̎s
			SMFView^ frm = safe_cast<SMFView^>(m_form);
			frm->InsertEvent(m_track, m_listIndex, m_ev);
			m_timeline->smf->TempoChanges->Insert(m_tempoIndex, m_tc);
			m_timeline->smf->CalcFrameAtTempoTable();//t[̍ČvZ
		}

		System::Void InsertTempo::Undo() {//ɖ߂
			SMFView^ frm = safe_cast<SMFView^>(m_form);
			frm->RemoveEvent(m_track, m_listIndex);
			m_timeline->smf->TempoChanges->RemoveAt(m_tempoIndex);
			m_timeline->smf->CalcFrameAtTempoTable();//t[̍ČvZ
		}
	}//Edit

}//MetMotMk
