#include "StdAfx.h"
#include "Edit_ModelResize.h"
#include "..\TimeLineForm.h"

namespace MetMotMk {

	namespace Edit {

		ModelResize::ModelResize(System::Windows::Forms::Form^ form, TimeLine^ timeline, Model^ model, int old_height, int new_height)
		{
			Name = "fgύX";
			m_form = form;
			m_timeline = timeline;//TimeLineւ̎Q
			m_model = model;//fւ̎Q
			m_old_height = old_height;//ύXO̍
			m_new_height = new_height;//ύX̍
		}

		System::Void ModelResize::Do() {//̎s
			m_timeline->Changed = true;
			m_model->Height = m_new_height;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->ModelLayout();
			frm->UpdateTimeLine();
		}

		System::Void ModelResize::Undo() {//ɖ߂
			m_timeline->Changed = true;
			m_model->Height = m_old_height;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->ModelLayout();
			frm->UpdateTimeLine();
		}

	}//Edit

}//MetMotMk
