#include "StdAfx.h"
#include "Edit_OpenVPD.h"
#include "..\TimeLineForm.h"

namespace MetMotMk {

	namespace Edit {

		OpenVPD::OpenVPD(System::Windows::Forms::Form^ form, TimeLine^ timeline, Model^ model, Pattern^ pattern)
		{
			Name = "|[Yf[^Ǎ";
			m_form = form;
			m_timeline = timeline;//TimeLineւ̎Q
			m_model = model;//fւ̎Q
			m_pattern = pattern;//p^[ւ̎Q
		}

		System::Void OpenVPD::Do() {//̎s
			m_model->AddPattern(m_pattern);
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->UpdateTimeLine();
		}

		System::Void OpenVPD::Undo() {//ɖ߂
			m_model->Patterns->Remove(m_pattern);
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			if (m_pattern->Selected) {
				frm->selectedPatterns->RemovePattern(m_pattern);
			}
			frm->UpdateTimeLine();
		}

	}//Edit

}//MetMotMk
