#include "StdAfx.h"
#include "Edit_PatternEdit.h"
#include "..\TimeLineForm.h"

namespace MetMotMk {

	namespace Edit {

		PatternEdit::PatternEdit(System::Windows::Forms::Form^ form, TimeLine^ timeline, Model^ model, int patternIndex, Pattern^ old_pattern, Pattern^ new_pattern)
		{
			Name = "p^[ҏW";
			m_form = form;
			m_timeline = timeline;//TimeLineւ̎Q
			m_model = model;//fւ̎Q
			m_patternIndex = patternIndex;//p^[̃CfbNX
			m_old_pattern = old_pattern->Copy();//ύXÕp^[
			m_new_pattern = new_pattern->Copy();//ύX̃p^[
		}

		System::Void PatternEdit::Do() {//̎s
			safe_cast<Pattern^>(m_model->Patterns[m_patternIndex])->CopyFrom(m_new_pattern);
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->UpdateTimeLine();
		}

		System::Void PatternEdit::Undo() {//ɖ߂
			safe_cast<Pattern^>(m_model->Patterns[m_patternIndex])->CopyFrom(m_old_pattern);
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->UpdateTimeLine();
		}

	}//Edit

}//MetMotMK
