#include "StdAfx.h"
#include "Edit_PatternResize.h"
#include "..\TimeLineForm.h"

namespace MetMotMk {

	namespace Edit {

		PatternResize::PatternResize(System::Windows::Forms::Form^ form, TimeLine^ timeline, int moveX, Pattern^ pattern)
		{
			Name = "p^[̃TCY";
			m_form = form;
			m_timeline = timeline;//TimeLineւ̎Q
			m_moveX = moveX;//TCY
			m_Pattern = pattern;//p^[ւ̎Q
			m_old_Repeat = m_Pattern->Repeat;
			m_new_Width = m_Pattern->Width + m_moveX;
		}

		System::Void PatternResize::Do() {//̎s
			m_Pattern->UpdateRectangle(m_new_Width);//JԂ񐔂ZoB
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->UpdateTimeLine();
		}

		System::Void PatternResize::Undo() {//ɖ߂
			m_Pattern->Repeat = m_old_Repeat;
			m_Pattern->UpdateRectangle();//JԂ񐔂牡ZoB
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->UpdateTimeLine();
		}
	}//Edit

}//MetMotMk
