#include "StdAfx.h"
#include "Edit_ReplaceBeat.h"
#include "..\SMFView.h"

namespace MetMotMk {

	namespace Edit {

		ReplaceBeat::ReplaceBeat(System::Windows::Forms::Form^ form, TimeLine^ timeline,
						int track, int listIndex, int beatIndex,
						SMF::Event^ old_ev, SMF::BeatChange^ old_bc, SMF::Event^ new_ev, SMF::BeatChange^ new_bc, SMF::Position^ pos)
		{
			Name = "qu";
			m_form = form;
			m_timeline = timeline;//TimeLineւ̎Q
			m_track = track;//gbN
			m_listIndex = listIndex;//Xgr[̃CfbNX
			m_beatIndex = beatIndex;//qύXe[ũCfbNX
			m_old_ev = old_ev;//ύXOMIDICxgf[^
			m_old_bc = old_bc;//ύXO̔qύX
			m_pos = pos;//ʒu
			m_new_ev = new_ev;//ύXMIDICxgf[^
			m_new_bc = new_bc;//ύX̔qύX
		}

		System::Void ReplaceBeat::Do() {//̎s
			SMFView^ frm = safe_cast<SMFView^>(m_form);
			m_timeline->smf->BeatChanges[m_beatIndex] = m_new_bc;
			m_timeline->smf->CalcTickAtBeatTable();//tick̍ČvZ
			//frm->ReplaceEvent(m_track, m_listIndex, m_new_ev);
			frm->UpdateBeatTable();
			frm->UpdateTimeline();
		}

		System::Void ReplaceBeat::Undo() {//ɖ߂
			SMFView^ frm = safe_cast<SMFView^>(m_form);
			m_timeline->smf->BeatChanges[m_beatIndex] = m_old_bc;
			m_timeline->smf->CalcTickAtBeatTable();//tick̍ČvZ
			//frm->ReplaceEvent(m_track, m_listIndex, m_old_ev);
			frm->UpdateBeatTable();
			frm->UpdateTimeline();
		}
	}//Edit

}//MetMotMk
