#include "StdAfx.h"
#include "Edit_ReplaceTempo.h"
#include "..\SMFView.h"

namespace MetMotMk {

	namespace Edit {

		ReplaceTempo::ReplaceTempo(System::Windows::Forms::Form^ form, TimeLine^ timeline,
						int track, int listIndex, int tempoIndex,
						SMF::Event^ old_ev, SMF::TempoChange^ old_tc, SMF::Event^ new_ev, SMF::TempoChange^ new_tc, SMF::Position^ pos)
		{
			Name = "e|u";
			m_form = form;
			m_timeline = timeline;//TimeLineւ̎Q
			m_track = track;//gbN
			m_listIndex = listIndex;//Xgr[̃CfbNX
			m_tempoIndex = tempoIndex;//e|`FWe[ũCfbNX
			m_old_ev = old_ev;//ύXOMIDICxgf[^
			m_old_tc = old_tc;//ύXÕe|`FW
			m_pos = pos;//ʒu
			m_new_ev = new_ev;//ύXMIDICxgf[^
			m_new_tc = new_tc;//ύX̃e|`FW
		}

		System::Void ReplaceTempo::Do() {//̎s
			SMFView^ frm = safe_cast<SMFView^>(m_form);
			frm->ReplaceEvent(m_track, m_listIndex, m_new_ev);
			m_timeline->smf->TempoChanges[m_tempoIndex] = m_new_tc;
			m_timeline->smf->CalcFrameAtTempoTable();//t[̍ČvZ
		}

		System::Void ReplaceTempo::Undo() {//ɖ߂
			SMFView^ frm = safe_cast<SMFView^>(m_form);
			frm->ReplaceEvent(m_track, m_listIndex, m_old_ev);
			m_timeline->smf->TempoChanges[m_tempoIndex] = m_old_tc;
			m_timeline->smf->CalcFrameAtTempoTable();//t[̍ČvZ
		}
	}//Edit

}//MetMotMk
