#include "StdAfx.h"
#include "Edit_ReplaceVPD.h"
#include "..\TimeLineForm.h"

namespace MetMotMk {

	namespace Edit {

		ReplaceVPD::ReplaceVPD(System::Windows::Forms::Form^ form, TimeLine^ timeline, Pattern^ pattern, MMD::VPD::Item^ old_vpd, MMD::VPD::Item^ new_vpd)
		{
			Name = "|[Yf[^u";
			m_form = form;
			m_timeline = timeline;//TimeLineւ̎Q
			m_pattern = pattern;//p^[ւ̎Q
			m_old_vpd = old_vpd->Copy();//ύXÕ|[Yf[^
			m_new_vpd = new_vpd->Copy();//ύX̃|[Yf[^
		}

		System::Void ReplaceVPD::Do() {//̎s
			m_pattern->vpd = m_new_vpd->Copy();
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->UpdateTimeLine();
		}

		System::Void ReplaceVPD::Undo() {//ɖ߂
			m_pattern->vpd = m_old_vpd->Copy();
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->UpdateTimeLine();
		}
	}//Edit

}//MetMotMk
