#include "StdAfx.h"
#include "Edit_SetSongLength.h"
#include "..\TimeLineForm.h"

namespace MetMotMk {

	namespace Edit {

		SetSongLength::SetSongLength(System::Windows::Forms::Form^ form, TimeLine^ timeline, int new_maxTick)
		{
			Name = "Ȃ̒̕ύX";
			m_form = form;
			m_timeline = timeline;//TimeLineւ̎Q
			m_old_maxTick = timeline->smf->MaxTick;//ύXŐȂ̒
			m_new_maxTick = new_maxTick;//ύX̋Ȃ̒
		}

		System::Void SetSongLength::Do() {//̎s
			m_timeline->smf->MaxTick = m_new_maxTick;
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->SetPicTimeLineWidth();
			frm->UpdateTimeLine();
			frm->UpdateSongLength();
		}

		System::Void SetSongLength::Undo() {//ɖ߂
			m_timeline->smf->MaxTick = m_old_maxTick;
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->SetPicTimeLineWidth();
			frm->UpdateTimeLine();
			frm->UpdateSongLength();
		}

	}//Edit

}//MetMotMk
