#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;


namespace MetMotMk {

	namespace TimeUnits {
		enum ProjectTimeUnit {
			MINUTES = 0,//Fb
			MEASURES = 1,//
			FRAMES = 2//t[
		};
	}

	/// <summary>
	/// NewProjectDialog ̊Tv
	///
	/// x: ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public ref class NewProjectDialog : public System::Windows::Forms::Form
	{
	public:
		NewProjectDialog(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^ R[hǉ܂
			//

			cmbBeatDD->SelectedIndex = 1;
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~NewProjectDialog()
		{
			if (components)
			{
				delete components;
			}
		}

	public:
		property TimeUnits::ProjectTimeUnit TimeUnit {//Ȃ̒̎Ԃ̒P
			TimeUnits::ProjectTimeUnit get() {
				if (this->radioLengthMinutes->Checked) {
					return TimeUnits::MINUTES;
				} else if (this->radioLengthMeasures->Checked) {
					return TimeUnits::MEASURES;
				} else {
					return TimeUnits::FRAMES;
				}
			}
			void set(TimeUnits::ProjectTimeUnit timeUnit) {
				switch (timeUnit) {
				case TimeUnits::MINUTES:
					this->radioLengthMinutes->Checked = true;
					break;
				case TimeUnits::MEASURES:
					this->radioLengthMeasures->Checked = true;
					break;
				case TimeUnits::FRAMES:
					this->radioLengthFrames->Checked = true;
				}
			}
		}
		property int BeatDD {//q̕
			int get() {
				return m_BeatDD;
			}
		}
		property int BeatNN {//q̕q
			int get() {
				return m_BeatNN;
			}
		}
		property int Tempo {//e|
			int get() {
				return m_Tempo;
			}
		}
		property int Minutes {//Ȃ̒()
			int get() {
				return m_Minutes;
			}
		}
		property int Seconds {//Ȃ̒(b)
			int get() {
				return m_Seconds;
			}
		}
		property int Measures {//Ȃ̒()
			int get() {
				return m_Measures;
			}
		}
		property int Frames {//Ȃ̒(t[)
			int get() {
				return m_Frames;
			}
		}
		property int DeltaTime {//l̕\
			int get() {
				return m_DeltaTime;
			}
		}

	private:
		int m_BeatDD;
		int m_BeatNN;
		int m_Tempo;
		int m_Minutes;
		int m_Seconds;
		int m_Measures;
		int m_Frames;
		int m_DeltaTime;

	private: System::Windows::Forms::NumericUpDown^  updownBeatNN;
	private: System::Windows::Forms::Label^  lblBeatNN;
	private: System::Windows::Forms::ComboBox^  cmbBeatDD;
	private: System::Windows::Forms::Label^  lblBeatDD;
	private: System::Windows::Forms::Label^  lblBeat;
	private: System::Windows::Forms::Label^  lblTempo;

	private: System::Windows::Forms::NumericUpDown^  updownTempo;

	private: System::Windows::Forms::GroupBox^  groupLength;
	private: System::Windows::Forms::RadioButton^  radioLengthFrames;

	private: System::Windows::Forms::RadioButton^  radioLengthMeasures;


	private: System::Windows::Forms::RadioButton^  radioLengthMinutes;
	private: System::Windows::Forms::Label^  lblMinutes;
	private: System::Windows::Forms::TextBox^  txtMinutes;
	private: System::Windows::Forms::Label^  lblMeasures;
	private: System::Windows::Forms::TextBox^  txtMeasures;


	private: System::Windows::Forms::Label^  lblSeconds;
	private: System::Windows::Forms::TextBox^  txtSeconds;
	private: System::Windows::Forms::Label^  lblFrames;
	private: System::Windows::Forms::TextBox^  txtFrames;
	private: System::Windows::Forms::Button^  btnOk;
	private: System::Windows::Forms::Button^  btnCancel;
private: System::Windows::Forms::PictureBox^  pic4Onpu;
private: System::Windows::Forms::Label^  lblEQ;
private: System::Windows::Forms::Label^  lblDeltaTime;
private: System::Windows::Forms::TextBox^  txtDeltaTime;

	protected: 

	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(NewProjectDialog::typeid));
			this->updownBeatNN = (gcnew System::Windows::Forms::NumericUpDown());
			this->lblBeatNN = (gcnew System::Windows::Forms::Label());
			this->cmbBeatDD = (gcnew System::Windows::Forms::ComboBox());
			this->lblBeatDD = (gcnew System::Windows::Forms::Label());
			this->lblBeat = (gcnew System::Windows::Forms::Label());
			this->lblTempo = (gcnew System::Windows::Forms::Label());
			this->updownTempo = (gcnew System::Windows::Forms::NumericUpDown());
			this->groupLength = (gcnew System::Windows::Forms::GroupBox());
			this->txtFrames = (gcnew System::Windows::Forms::TextBox());
			this->txtMeasures = (gcnew System::Windows::Forms::TextBox());
			this->lblFrames = (gcnew System::Windows::Forms::Label());
			this->lblMeasures = (gcnew System::Windows::Forms::Label());
			this->lblSeconds = (gcnew System::Windows::Forms::Label());
			this->txtSeconds = (gcnew System::Windows::Forms::TextBox());
			this->lblMinutes = (gcnew System::Windows::Forms::Label());
			this->txtMinutes = (gcnew System::Windows::Forms::TextBox());
			this->radioLengthFrames = (gcnew System::Windows::Forms::RadioButton());
			this->radioLengthMeasures = (gcnew System::Windows::Forms::RadioButton());
			this->radioLengthMinutes = (gcnew System::Windows::Forms::RadioButton());
			this->btnOk = (gcnew System::Windows::Forms::Button());
			this->btnCancel = (gcnew System::Windows::Forms::Button());
			this->pic4Onpu = (gcnew System::Windows::Forms::PictureBox());
			this->lblEQ = (gcnew System::Windows::Forms::Label());
			this->lblDeltaTime = (gcnew System::Windows::Forms::Label());
			this->txtDeltaTime = (gcnew System::Windows::Forms::TextBox());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownBeatNN))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownTempo))->BeginInit();
			this->groupLength->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pic4Onpu))->BeginInit();
			this->SuspendLayout();
			// 
			// updownBeatNN
			// 
			this->updownBeatNN->Location = System::Drawing::Point(149, 16);
			this->updownBeatNN->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) {1, 0, 0, 0});
			this->updownBeatNN->Name = L"updownBeatNN";
			this->updownBeatNN->Size = System::Drawing::Size(46, 19);
			this->updownBeatNN->TabIndex = 15;
			this->updownBeatNN->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->updownBeatNN->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) {4, 0, 0, 0});
			// 
			// lblBeatNN
			// 
			this->lblBeatNN->AutoSize = true;
			this->lblBeatNN->Location = System::Drawing::Point(201, 18);
			this->lblBeatNN->Name = L"lblBeatNN";
			this->lblBeatNN->Size = System::Drawing::Size(29, 12);
			this->lblBeatNN->TabIndex = 16;
			this->lblBeatNN->Text = L"q";
			// 
			// cmbBeatDD
			// 
			this->cmbBeatDD->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cmbBeatDD->FormattingEnabled = true;
			this->cmbBeatDD->Items->AddRange(gcnew cli::array< System::Object^  >(6) {L"2", L"4", L"8", L"16", L"32", L"64"});
			this->cmbBeatDD->Location = System::Drawing::Point(54, 15);
			this->cmbBeatDD->Name = L"cmbBeatDD";
			this->cmbBeatDD->Size = System::Drawing::Size(56, 20);
			this->cmbBeatDD->TabIndex = 14;
			// 
			// lblBeatDD
			// 
			this->lblBeatDD->AutoSize = true;
			this->lblBeatDD->Location = System::Drawing::Point(116, 18);
			this->lblBeatDD->Name = L"lblBeatDD";
			this->lblBeatDD->Size = System::Drawing::Size(27, 12);
			this->lblBeatDD->TabIndex = 14;
			this->lblBeatDD->Text = L"";
			// 
			// lblBeat
			// 
			this->lblBeat->AutoSize = true;
			this->lblBeat->Location = System::Drawing::Point(13, 18);
			this->lblBeat->Name = L"lblBeat";
			this->lblBeat->Size = System::Drawing::Size(31, 12);
			this->lblBeat->TabIndex = 13;
			this->lblBeat->Text = L"q:";
			// 
			// lblTempo
			// 
			this->lblTempo->AutoSize = true;
			this->lblTempo->Location = System::Drawing::Point(13, 56);
			this->lblTempo->Name = L"lblTempo";
			this->lblTempo->Size = System::Drawing::Size(35, 12);
			this->lblTempo->TabIndex = 17;
			this->lblTempo->Text = L"e|:";
			// 
			// updownTempo
			// 
			this->updownTempo->Location = System::Drawing::Point(94, 52);
			this->updownTempo->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) {1000, 0, 0, 0});
			this->updownTempo->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) {1, 0, 0, 0});
			this->updownTempo->Name = L"updownTempo";
			this->updownTempo->Size = System::Drawing::Size(51, 19);
			this->updownTempo->TabIndex = 20;
			this->updownTempo->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->updownTempo->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) {120, 0, 0, 0});
			// 
			// groupLength
			// 
			this->groupLength->Controls->Add(this->txtFrames);
			this->groupLength->Controls->Add(this->txtMeasures);
			this->groupLength->Controls->Add(this->lblFrames);
			this->groupLength->Controls->Add(this->lblMeasures);
			this->groupLength->Controls->Add(this->lblSeconds);
			this->groupLength->Controls->Add(this->txtSeconds);
			this->groupLength->Controls->Add(this->lblMinutes);
			this->groupLength->Controls->Add(this->txtMinutes);
			this->groupLength->Controls->Add(this->radioLengthFrames);
			this->groupLength->Controls->Add(this->radioLengthMeasures);
			this->groupLength->Controls->Add(this->radioLengthMinutes);
			this->groupLength->Location = System::Drawing::Point(15, 118);
			this->groupLength->Name = L"groupLength";
			this->groupLength->Size = System::Drawing::Size(215, 112);
			this->groupLength->TabIndex = 1;
			this->groupLength->TabStop = false;
			this->groupLength->Text = L"Ȃ̒";
			// 
			// txtFrames
			// 
			this->txtFrames->Enabled = false;
			this->txtFrames->Location = System::Drawing::Point(35, 80);
			this->txtFrames->MaxLength = 7;
			this->txtFrames->Name = L"txtFrames";
			this->txtFrames->Size = System::Drawing::Size(55, 19);
			this->txtFrames->TabIndex = 11;
			this->txtFrames->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->txtFrames->KeyPress += gcnew System::Windows::Forms::KeyPressEventHandler(this, &NewProjectDialog::txtFrames_KeyPress);
			// 
			// txtMeasures
			// 
			this->txtMeasures->Enabled = false;
			this->txtMeasures->Location = System::Drawing::Point(35, 48);
			this->txtMeasures->MaxLength = 5;
			this->txtMeasures->Name = L"txtMeasures";
			this->txtMeasures->Size = System::Drawing::Size(36, 19);
			this->txtMeasures->TabIndex = 8;
			this->txtMeasures->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->txtMeasures->KeyPress += gcnew System::Windows::Forms::KeyPressEventHandler(this, &NewProjectDialog::txtMeasures_KeyPress);
			// 
			// lblFrames
			// 
			this->lblFrames->AutoSize = true;
			this->lblFrames->Location = System::Drawing::Point(96, 83);
			this->lblFrames->Name = L"lblFrames";
			this->lblFrames->Size = System::Drawing::Size(42, 12);
			this->lblFrames->TabIndex = 12;
			this->lblFrames->Text = L"t[";
			// 
			// lblMeasures
			// 
			this->lblMeasures->AutoSize = true;
			this->lblMeasures->Location = System::Drawing::Point(77, 52);
			this->lblMeasures->Name = L"lblMeasures";
			this->lblMeasures->Size = System::Drawing::Size(29, 12);
			this->lblMeasures->TabIndex = 9;
			this->lblMeasures->Text = L"";
			// 
			// lblSeconds
			// 
			this->lblSeconds->AutoSize = true;
			this->lblSeconds->Location = System::Drawing::Point(142, 18);
			this->lblSeconds->Name = L"lblSeconds";
			this->lblSeconds->Size = System::Drawing::Size(17, 12);
			this->lblSeconds->TabIndex = 6;
			this->lblSeconds->Text = L"b";
			// 
			// txtSeconds
			// 
			this->txtSeconds->Location = System::Drawing::Point(100, 15);
			this->txtSeconds->MaxLength = 5;
			this->txtSeconds->Name = L"txtSeconds";
			this->txtSeconds->Size = System::Drawing::Size(36, 19);
			this->txtSeconds->TabIndex = 5;
			this->txtSeconds->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->txtSeconds->KeyPress += gcnew System::Windows::Forms::KeyPressEventHandler(this, &NewProjectDialog::txtSeconds_KeyPress);
			// 
			// lblMinutes
			// 
			this->lblMinutes->AutoSize = true;
			this->lblMinutes->Location = System::Drawing::Point(77, 19);
			this->lblMinutes->Name = L"lblMinutes";
			this->lblMinutes->Size = System::Drawing::Size(17, 12);
			this->lblMinutes->TabIndex = 4;
			this->lblMinutes->Text = L"";
			// 
			// txtMinutes
			// 
			this->txtMinutes->Location = System::Drawing::Point(35, 15);
			this->txtMinutes->MaxLength = 5;
			this->txtMinutes->Name = L"txtMinutes";
			this->txtMinutes->Size = System::Drawing::Size(36, 19);
			this->txtMinutes->TabIndex = 3;
			this->txtMinutes->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->txtMinutes->KeyPress += gcnew System::Windows::Forms::KeyPressEventHandler(this, &NewProjectDialog::txtMinutes_KeyPress);
			// 
			// radioLengthFrames
			// 
			this->radioLengthFrames->AutoSize = true;
			this->radioLengthFrames->Location = System::Drawing::Point(15, 83);
			this->radioLengthFrames->Name = L"radioLengthFrames";
			this->radioLengthFrames->Size = System::Drawing::Size(14, 13);
			this->radioLengthFrames->TabIndex = 10;
			this->radioLengthFrames->UseVisualStyleBackColor = true;
			this->radioLengthFrames->CheckedChanged += gcnew System::EventHandler(this, &NewProjectDialog::radioLengthFrames_CheckedChanged);
			// 
			// radioLengthMeasures
			// 
			this->radioLengthMeasures->AutoSize = true;
			this->radioLengthMeasures->Location = System::Drawing::Point(15, 51);
			this->radioLengthMeasures->Name = L"radioLengthMeasures";
			this->radioLengthMeasures->Size = System::Drawing::Size(14, 13);
			this->radioLengthMeasures->TabIndex = 7;
			this->radioLengthMeasures->UseVisualStyleBackColor = true;
			this->radioLengthMeasures->CheckedChanged += gcnew System::EventHandler(this, &NewProjectDialog::radioLengthMeasures_CheckedChanged);
			// 
			// radioLengthMinutes
			// 
			this->radioLengthMinutes->AutoSize = true;
			this->radioLengthMinutes->Checked = true;
			this->radioLengthMinutes->Location = System::Drawing::Point(16, 18);
			this->radioLengthMinutes->Name = L"radioLengthMinutes";
			this->radioLengthMinutes->Size = System::Drawing::Size(14, 13);
			this->radioLengthMinutes->TabIndex = 2;
			this->radioLengthMinutes->TabStop = true;
			this->radioLengthMinutes->UseVisualStyleBackColor = true;
			this->radioLengthMinutes->CheckedChanged += gcnew System::EventHandler(this, &NewProjectDialog::radioLengthMinutes_CheckedChanged);
			// 
			// btnOk
			// 
			this->btnOk->DialogResult = System::Windows::Forms::DialogResult::OK;
			this->btnOk->Location = System::Drawing::Point(75, 236);
			this->btnOk->Name = L"btnOk";
			this->btnOk->Size = System::Drawing::Size(70, 22);
			this->btnOk->TabIndex = 23;
			this->btnOk->Text = L"OK(&O)";
			this->btnOk->UseVisualStyleBackColor = true;
			this->btnOk->Click += gcnew System::EventHandler(this, &NewProjectDialog::btnOk_Click);
			// 
			// btnCancel
			// 
			this->btnCancel->DialogResult = System::Windows::Forms::DialogResult::Cancel;
			this->btnCancel->Location = System::Drawing::Point(151, 236);
			this->btnCancel->Name = L"btnCancel";
			this->btnCancel->Size = System::Drawing::Size(79, 22);
			this->btnCancel->TabIndex = 24;
			this->btnCancel->Text = L"LZ(&C)";
			this->btnCancel->UseVisualStyleBackColor = true;
			this->btnCancel->Click += gcnew System::EventHandler(this, &NewProjectDialog::btnCancel_Click);
			// 
			// pic4Onpu
			// 
			this->pic4Onpu->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"pic4Onpu.Image")));
			this->pic4Onpu->Location = System::Drawing::Point(54, 52);
			this->pic4Onpu->Name = L"pic4Onpu";
			this->pic4Onpu->Size = System::Drawing::Size(16, 16);
			this->pic4Onpu->SizeMode = System::Windows::Forms::PictureBoxSizeMode::StretchImage;
			this->pic4Onpu->TabIndex = 13;
			this->pic4Onpu->TabStop = false;
			// 
			// lblEQ
			// 
			this->lblEQ->AutoSize = true;
			this->lblEQ->Location = System::Drawing::Point(73, 56);
			this->lblEQ->Name = L"lblEQ";
			this->lblEQ->Size = System::Drawing::Size(17, 12);
			this->lblEQ->TabIndex = 19;
			this->lblEQ->Text = L"";
			// 
			// lblDeltaTime
			// 
			this->lblDeltaTime->AutoSize = true;
			this->lblDeltaTime->Location = System::Drawing::Point(16, 87);
			this->lblDeltaTime->Name = L"lblDeltaTime";
			this->lblDeltaTime->Size = System::Drawing::Size(105, 12);
			this->lblDeltaTime->TabIndex = 21;
			this->lblDeltaTime->Text = L"l̕\F";
			// 
			// txtDeltaTime
			// 
			this->txtDeltaTime->Location = System::Drawing::Point(127, 84);
			this->txtDeltaTime->Name = L"txtDeltaTime";
			this->txtDeltaTime->Size = System::Drawing::Size(47, 19);
			this->txtDeltaTime->TabIndex = 22;
			this->txtDeltaTime->Text = L"240";
			this->txtDeltaTime->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->txtDeltaTime->KeyPress += gcnew System::Windows::Forms::KeyPressEventHandler(this, &NewProjectDialog::txtDeltaTime_KeyPress);
			// 
			// NewProjectDialog
			// 
			this->AcceptButton = this->btnOk;
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->CancelButton = this->btnCancel;
			this->ClientSize = System::Drawing::Size(246, 269);
			this->Controls->Add(this->txtDeltaTime);
			this->Controls->Add(this->lblDeltaTime);
			this->Controls->Add(this->lblEQ);
			this->Controls->Add(this->pic4Onpu);
			this->Controls->Add(this->btnCancel);
			this->Controls->Add(this->btnOk);
			this->Controls->Add(this->groupLength);
			this->Controls->Add(this->updownTempo);
			this->Controls->Add(this->lblTempo);
			this->Controls->Add(this->lblBeat);
			this->Controls->Add(this->lblBeatDD);
			this->Controls->Add(this->cmbBeatDD);
			this->Controls->Add(this->lblBeatNN);
			this->Controls->Add(this->updownBeatNN);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedDialog;
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = L"NewProjectDialog";
			this->ShowInTaskbar = false;
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterParent;
			this->Text = L"VKvWFNg";
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownBeatNN))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownTempo))->EndInit();
			this->groupLength->ResumeLayout(false);
			this->groupLength->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pic4Onpu))->EndInit();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

	private:
		System::Void btnOk_Click(System::Object^  sender, System::EventArgs^  e) {//[OK]{^NbN
			try {
				//l̊i[
				m_BeatDD = Int32::Parse(cmbBeatDD->Text);
				m_BeatNN = int(updownBeatNN->Value);
				m_Tempo = int(updownTempo->Value);

				if (txtDeltaTime->Text->Length > 0) {
					m_DeltaTime = Int32::Parse(txtDeltaTime->Text);
				} else {
					throw(safe_cast<String^>("l̕\͂ĂB"));
				}

				if (this->radioLengthMinutes->Checked) {//Ebw
					if (txtMinutes->Text->Length > 0) {
						m_Minutes = Int32::Parse(txtMinutes->Text);
					} else {
						m_Minutes = 0;
					}
					if (txtSeconds->Text->Length > 0) {
						m_Seconds = Int32::Parse(txtSeconds->Text);
					} else {
						m_Seconds = 0;
					}
					if (m_Minutes + m_Seconds == 0) {//{ m_Minutes * 60 + m_Seconds == 0 AG[`FbN邾Ȃ炱łB
						txtMinutes->Focus();
						throw(safe_cast<String^>("Ȃ̒͂ĂB"));
					}
				} else if (this->radioLengthMeasures->Checked) {//ߎw
					if (txtMeasures->Text->Length > 0) {
						m_Measures = Int32::Parse(txtMeasures->Text);
					} else {
						m_Measures = 0;
					}
					if (m_Measures == 0) {
						txtMeasures->Focus();
						throw(safe_cast<String^>("Ȃ̒͂ĂB"));
					}
				} else {//t[w
					if (txtFrames->Text->Length > 0) {
						m_Frames = Int32::Parse(txtFrames->Text);
					} else {
						m_Frames = 0;
					}
					if (m_Frames == 0) {
						txtFrames->Focus();
						throw(safe_cast<String^>("Ȃ̒͂ĂB"));
					}
				}

				Hide();
			} catch (String^ err) {
				MessageBox::Show(err, "̓G[");
				this->DialogResult = System::Windows::Forms::DialogResult::None;//vpeB[ DialogResult=OK ɂĂƂ́AȂƕĂ܂B
			}
		}

	private:
		System::Void radioLengthMinutes_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {//Ȃ̒𕪁EbŎw
			txtMinutes->Enabled = true;
			txtSeconds->Enabled = true;
			txtMeasures->Enabled = false;
			txtFrames->Enabled = false;
		}

	private:
		System::Void radioLengthMeasures_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {//Ȃ̒߂Ŏw
			txtMinutes->Enabled = false;
			txtSeconds->Enabled = false;
			txtMeasures->Enabled = true;
			txtFrames->Enabled = false;
		}

	private:
		System::Void radioLengthFrames_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {//Ȃ̒t[Ŏw
			txtMinutes->Enabled = false;
			txtSeconds->Enabled = false;
			txtMeasures->Enabled = false;
			txtFrames->Enabled = true;
		}

	private:
		System::Void txtMinutes_KeyPress(System::Object^  sender, System::Windows::Forms::KeyPressEventArgs^  e) {//
			//l͂̂݋
			if (e->KeyChar >= ' ' && e->KeyChar < '0' || e->KeyChar > '9' ) {
				e->KeyChar = 0;
			}
		}

	private:
		System::Void txtSeconds_KeyPress(System::Object^  sender, System::Windows::Forms::KeyPressEventArgs^  e) {//b
			//l͂̂݋
			if (e->KeyChar >= ' ' && e->KeyChar < '0' || e->KeyChar > '9') {
				e->KeyChar = 0;
			}
		}

	private:
		System::Void txtMeasures_KeyPress(System::Object^  sender, System::Windows::Forms::KeyPressEventArgs^  e) {//
			//l͂̂݋
			if (e->KeyChar >= ' ' && e->KeyChar < '0' || e->KeyChar > '9') {
				e->KeyChar = 0;
			}
		}

	private:
		System::Void txtFrames_KeyPress(System::Object^  sender, System::Windows::Forms::KeyPressEventArgs^  e) {//t[
			//l͂̂݋
			if (e->KeyChar >= ' ' && e->KeyChar < '0' || e->KeyChar > '9') {
				e->KeyChar = 0;
			}
		}

	private:
		System::Void btnCancel_Click(System::Object^  sender, System::EventArgs^  e) {//[LZ]{^NbN
			Hide();
		}

	private:
		System::Void txtDeltaTime_KeyPress(System::Object^  sender, System::Windows::Forms::KeyPressEventArgs^  e) {//l̕\
			//l͂̂݋
			if (e->KeyChar >= ' ' && e->KeyChar < '0' || e->KeyChar > '9') {
				e->KeyChar = 0;
			}
		}
};
}
