#pragma once

#include "..\Pattern.h"

namespace MetMotMk {

	namespace Option {

		public ref class PatternColor
		{
		public:
			PatternColor(void);

			PatternColor^ Copy();

			MetMotMk::Patterns::Type Type;//p^[̃^Cv
			property System::Drawing::Color FontColor {//tHgF
				System::Drawing::Color get() {
					return m_FontColor;
				}
				void set(System::Drawing::Color new_FontColor) {
					m_FontColor = new_FontColor;
					m_FontBrush = gcnew System::Drawing::SolidBrush(m_FontColor);
				}
			}
			property System::Drawing::Color ForeColor {//OiF
				System::Drawing::Color get() {
					return m_ForeColor;
				}
				void set(System::Drawing::Color new_ForeColor) {
					m_ForeColor = new_ForeColor;
					m_ForeBrush = gcnew System::Drawing::SolidBrush(m_ForeColor);
				}
			}
			property System::Drawing::Color BackColor {//wiF
				System::Drawing::Color get() {
					return m_BackColor;
				}
				void set(System::Drawing::Color new_BackColor) {
					m_BackColor = new_BackColor;
					m_BackBrush = gcnew System::Drawing::SolidBrush(m_BackColor);
				}
			}
			property System::Drawing::SolidBrush^ FontBrush {//tHgFBrush
				System::Drawing::SolidBrush^ get() {
					return m_FontBrush;
				}
				void set(System::Drawing::SolidBrush^ new_FontBrush) {
					m_FontBrush = new_FontBrush;
					m_FontColor = m_FontBrush->Color;
				}
			}
			property System::Drawing::SolidBrush^ ForeBrush {//OiFBrush
				System::Drawing::SolidBrush^ get() {
					return m_ForeBrush;
				}
				void set(System::Drawing::SolidBrush^ new_ForeBrush) {
					m_ForeBrush = new_ForeBrush;
					m_ForeColor = m_ForeBrush->Color;
				}
			}
			property System::Drawing::SolidBrush^ BackBrush {//wiFBrush
				System::Drawing::SolidBrush^ get() {
					return m_BackBrush;
				}
				void set(System::Drawing::SolidBrush^ new_BackBrush) {
					m_BackBrush = new_BackBrush;
					m_BackColor = m_BackBrush->Color;
				}
			}

		private:
			System::Drawing::Color m_FontColor;//tHgF
			System::Drawing::Color m_ForeColor;//OiF
			System::Drawing::Color m_BackColor;//wiF
			System::Drawing::SolidBrush^ m_FontBrush;//tHgFBrush
			System::Drawing::SolidBrush^ m_ForeBrush;//OiFBrush
			System::Drawing::SolidBrush^ m_BackBrush;//wiFBrush
		};

	}//Option

}//MetMotMk
