#include "StdAfx.h"
#include "Option_Version.h"

namespace MetMotMk {

	namespace Option {

		Version::Version(void)
		{
			Frequency = VersionCheck::NONE;//o[W`FbN̕px
			LastCheckDate = System::DateTime::Now;//ԍŋ߂̃o[W`FbN
			NextCheckDate = System::DateTime::Now;//o[W`FbN
			NextDay = 1;//`FbNꍇ̓t
			NextDayOfWeek = DayOfWeek::Sunday;//T`FbNꍇ̗j 0 (DayOfWeek::Sunday) ` 6 (DayOfWeek::Saturday) 
			ProxySetting = Proxy::NONE;//vLVݒ
			ProxyHost = "";//vLVT[o[̃zXg
			ProxyPort = 8080;//vLVT[o[̃|[gԍ
		}

		Version^ Version::Copy() {
			Version^ version = gcnew Version();

			//Rs[
			version->Frequency = this->Frequency;
			version->LastCheckDate = this->LastCheckDate;
			version->NextCheckDate = this->NextCheckDate;
			version->NextDay = this->NextDay;
			version->NextDayOfWeek = this->NextDayOfWeek;
			version->ProxySetting = this->ProxySetting;
			version->ProxyHost = this->ProxyHost;
			version->ProxyPort = this->ProxyPort;

			return version;
		}

		System::Void Version::UpdateNextCheckDate() {//`FbN̍XV
			//o[W`FbN̍XV
			DateTime date = DateTime::Now;
			if (Frequency == Option::VersionCheck::EVERY_DAY) {
				//`FbN𗂓ɐݒ
				date = date.AddDays(1.0);//()ZVCX^XԂ
				NextCheckDate = DateTime(date.Year, date.Month, date.Day);
			} else if (Frequency == Option::VersionCheck::EVERY_WEEK) {
				int DoW = (int)date.DayOfWeek;
				int nextDoW = (int)NextDayOfWeek;
				if (nextDoW <= DoW) {//̗j̗jÔƂ
					nextDoW += 7;//1TԌɐݒ
				}
				date = date.AddDays((double)(nextDoW - DoW));//()ZVCX^XԂ
				NextCheckDate = DateTime(date.Year, date.Month, date.Day);
			} else if (Frequency == Option::VersionCheck::EVERY_MONTH) {
				int day = NextCheckDate.Day;
				int nextDay = NextDay;
				if (nextDay <= day) {//́uv́uvȂꍇB
					date = date.AddMonths(1);//1i߂B//()ZVCX^XԂ
				}
				NextCheckDate = DateTime(date.Year, date.Month, nextDay);//uvwɐݒB
			}
		}

	}//Option

}//MetMotMk
