#pragma once

#include "PatternBuffer.h"
//#include "Model.h"
#include "TimeLine.h"
#include "..\SMF\SMF.h"
#include "..\SMF\SMF_Position.h"
#include "..\MMD\MMD_String.h"
#include "..\MMD\VPD\VPD.h"
#include "..\MMD\VMD\VMD.h"

namespace MetMotMk {

/*
	^CCɓ\tp^[B(́u[V()v)
*/

	ref class Model;//ݎQƂ̂߂ɕKv
	//ref class TimeLine;

	namespace Patterns {
		public enum Type {//ĩ^Cv
			ALL = -1,//Sw(̏ŁAS^Cṽp^[ɑ΂ďƂɎw肷B)
			POSE = 0,//|[Yf[^^p^[
			MOTION = 1,//[V^p^[(\)
			CONTAINER = 2,//^p^[(\)(p^[̃Rei)
			MIDI = 3,//MIDICxg^p^[; MIDICxg[Vɕϊ郋[(\)
			SHORTCUT = 4,//V[gJbg^p^[(JnʒuȊOAQƌ̃p^[𗘗p)(\)
			LIPSYNC = 5,//bvVN^p^[(Ђ炪Ȃ\tČ𓮂)(\)
			COMMENT = 6//Rg(̃RgeLXg̎lp`)
		};
	}

	public ref class Pattern : public MetMotMk::Rectangle
	{
	public:
		Pattern(void);

		Pattern^ Copy();//g̕쐬B
		System::Void CopyFrom(Pattern^);//Ɏw肳ꂽp^[̓eɃRs[B
		System::Void UpdateRectangle();//`TCYEʒu̍ČvZ
		System::Void UpdateRectangle(int);//p^[̉JԂ񐔂̍ČvZ(width=gEk̕\)
		System::Void UpdateScaledRectangle();//gEkꂽ`TCYEʒu̍ČvZ(kڂςƂ̂ݎs)

		//ϐ
		TimeLine^ timeline;
		bool Selected;//true=IAfalse=I
		MMD::String^ ModelName;
		Model^ Model;//̃p^[̑郂f
		MetMotMk::Patterns::Type Type;//ĩ^Cv
		SMF::Position^ Begin;//p^[Jnʒu(|[Yp̍)
		SMF::Position^ End;//p^[Iʒu(|[Yp̍)
		bool NoLength;//true=|[Y̎ԃ[
		int Repeat;//JԂ
		SMF::Position^ Step;//JԂ
		MMD::VPD::Item^ vpd;//MMD|[Yf[^(VPD)
		MMD::VMD::Item^ vmd;//MMD[Vf[^(VMD)
		PatternBuffer^ Patterns;//(ڍז)p^[f[^(p^[̃Rei)
		Rectangle^ CloseRect;//p^[ĂƂ̋`̑傫(͑̃^Cṽp^[Ɠɂ)
		Rectangle^ OpenRect;//p^[JĂƂ̋`̑傫

		property int Left {//`̍̉ʒu
			int get() {
				return m_ScaledLeft;//gEk̒lԂB
			}
			void set(int new_Left) {
				m_Left = new_Left;
				m_Right = m_Left + m_Width;//Left ςꍇ Width Œ Right ςB(EɈړ)
			}
		}
		property int Width {//`̉
			int get() {
				return m_ScaledWidth;//gEk̒lԂB
			}
			void set(int new_Width) {
				m_Width = new_Width;
				m_Right = m_Left + m_Width;//Width ςꍇ Left Œ Right ςB()
			}
		}
		property int Right {//`̉Ẻʒu
			int get() {
				return m_ScaledRight;//gEk̒lԂB
			}
			void set(int new_Right) {
				m_Right = new_Right;
				m_Width = m_Right - m_Left;//Right ςꍇ Left Œ Width ςB()
			}
		}

	protected:
		int m_ScaledLeft;//{ꂽLeftl
		int m_ScaledWidth;//{ꂽWidthl
		int m_ScaledRight;//{ꂽRightl
	};

}//MetMotMk
