#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

#include "TimeLine.h"
#include "Pattern.h"
#include "Option\Option_Config.h"

namespace MetMotMk {

	/// <summary>
	/// PoseDataDialog ̊Tv
	///
	/// x: ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public ref class PoseDataDialog : public System::Windows::Forms::Form
	{
	public:
		PoseDataDialog(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^ R[hǉ܂
			//
			InitPoseDataListView();//lvwPoseDatȁ
			btnReload->Enabled = false;
			btnOk->Enabled = false;
			pattern = gcnew Pattern();
			pattern->Type = MetMotMk::Patterns::POSE;//|[Yf[^x[X̃p^[
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~PoseDataDialog()
		{
			if (components)
			{
				delete components;
			}
		}

	//ϐ
	public:
		property TimeLine^ timeline {
			TimeLine^ get() {
				return m_timeline;
			}
			void set(TimeLine^ new_timeline) {
				m_timeline = new_timeline;
				pattern->Begin = gcnew SMF::Position(m_timeline->smf);
				pattern->End = gcnew SMF::Position(m_timeline->smf);
				pattern->Step = gcnew SMF::Position();
			}
		}
		Pattern^ pattern;
		Option::Config^ config;

	private:
		TimeLine^ m_timeline;

	public:
		//OQƂRg[(̃_CAOɊւĂ͊ÕRg[̎QƂ͔p~ɂ邩)
		property System::Windows::Forms::TextBox^  txtVPDFileControl {
			System::Windows::Forms::TextBox^ get () {
				return txtVPDFile;
			}
		}
		property System::Windows::Forms::NumericUpDown^  updownBeginMeasureControl {
			System::Windows::Forms::NumericUpDown^ get () {
				return updownBeginMeasure;
			}
		}
		property System::Windows::Forms::NumericUpDown^  updownBeginBeatControl {
			System::Windows::Forms::NumericUpDown^ get () {
				return updownBeginBeat;
			}
		}
		property System::Windows::Forms::NumericUpDown^  updownBeginTickControl {
			System::Windows::Forms::NumericUpDown^ get () {
				return updownBeginTick;
			}
		}
		property System::Windows::Forms::Label^  lblBeginTickControl {
			System::Windows::Forms::Label^ get () {
				return lblBeginTick;
			}
		}
		property System::Windows::Forms::TextBox^  txtBeginShiftTickControl {
			System::Windows::Forms::TextBox^ get () {
				return txtBeginShiftTick;
			}
		}
		property System::Windows::Forms::TextBox^  txtBeginShiftFrameControl {
			System::Windows::Forms::TextBox^ get () {
				return txtBeginShiftFrame;
			}
		}

		property System::Windows::Forms::CheckBox^  checkNoLengthControl {
			System::Windows::Forms::CheckBox^ get () {
				return checkNoLength;
			}
		}

		property System::Windows::Forms::NumericUpDown^  updownEndMeasureControl {
			System::Windows::Forms::NumericUpDown^ get () {
				return updownEndMeasure;
			}
		}
		property System::Windows::Forms::NumericUpDown^  updownEndBeatControl {
			System::Windows::Forms::NumericUpDown^ get () {
				return updownEndBeat;
			}
		}
		property System::Windows::Forms::NumericUpDown^  updownEndTickControl {
			System::Windows::Forms::NumericUpDown^ get () {
				return updownEndTick;
			}
		}
		property System::Windows::Forms::Label^  lblEndTickControl {
			System::Windows::Forms::Label^ get () {
				return lblEndTick;
			}
		}
		property System::Windows::Forms::TextBox^  txtEndShiftFrameControl {
			System::Windows::Forms::TextBox^ get () {
				return txtEndShiftFrame;
			}
		}
		property System::Windows::Forms::TextBox^  txtEndShiftTickControl {
			System::Windows::Forms::TextBox^ get () {
				return txtEndShiftTick;
			}
		}

		property System::Windows::Forms::NumericUpDown^  updownRepeatMeasureControl {
			System::Windows::Forms::NumericUpDown^ get () {
				return updownRepeatMeasure;
			}
		}
		property System::Windows::Forms::NumericUpDown^  updownRepeatBeatControl {
			System::Windows::Forms::NumericUpDown^ get () {
				return updownRepeatBeat;
			}
		}
		property System::Windows::Forms::NumericUpDown^  updownRepeatTickControl {
			System::Windows::Forms::NumericUpDown^ get () {
				return updownRepeatTick;
			}
		}
		property System::Windows::Forms::Label^  lblRepeatTickControl {
			System::Windows::Forms::Label^ get () {
				return lblRepeatTick;
			}
		}
		property System::Windows::Forms::TextBox^  txtRepeatControl {
			System::Windows::Forms::TextBox^ get () {
				return txtRepeat;
			}
		}



	private: System::Windows::Forms::Label^  lblVPDFile;
private: System::Windows::Forms::TextBox^  txtVPDFile;
	protected: 

	private: System::Windows::Forms::OpenFileDialog^  openFileDialog1;
	private: System::Windows::Forms::Button^  btnOpenVPDFile;
	private: System::Windows::Forms::Label^  lblPoseData;
	private: System::Windows::Forms::ListView^  lvwPoseData;


	private: System::Windows::Forms::Label^  lblBeginTick;

	private: System::Windows::Forms::NumericUpDown^  updownBeginTick;

	private: System::Windows::Forms::Label^  lblBeginBeat;

	private: System::Windows::Forms::NumericUpDown^  updownBeginBeat;

	private: System::Windows::Forms::Label^  lblBeginMeasure;
	private: System::Windows::Forms::NumericUpDown^  updownBeginMeasure;

	private: System::Windows::Forms::TextBox^  txtBeginShiftTick;
	private: System::Windows::Forms::Label^  lblBeginShiftTick;
	private: System::Windows::Forms::TextBox^  txtBeginShiftFrame;
	private: System::Windows::Forms::Label^  lblBeginShiftFrame;
	private: System::Windows::Forms::Label^  lblEndTick;
	private: System::Windows::Forms::NumericUpDown^  updownEndTick;
	private: System::Windows::Forms::Label^  lblEndBeat;
	private: System::Windows::Forms::NumericUpDown^  updownEndBeat;
	private: System::Windows::Forms::Label^  lblEndMeasure;
	private: System::Windows::Forms::NumericUpDown^  updownEndMeasure;
	private: System::Windows::Forms::Label^  lblEndShiftFrame;
	private: System::Windows::Forms::TextBox^  txtEndShiftFrame;
	private: System::Windows::Forms::Label^  lblEndShiftTick;
	private: System::Windows::Forms::TextBox^  txtEndShiftTick;
	private: System::Windows::Forms::Label^  lblRepeatTick;


	private: System::Windows::Forms::NumericUpDown^  updownRepeatTick;

	private: System::Windows::Forms::Label^  lblRepeatBeat;

	private: System::Windows::Forms::NumericUpDown^  updownRepeatBeat;

	private: System::Windows::Forms::Label^  lblRepeatMeasure;

	private: System::Windows::Forms::NumericUpDown^  updownRepeatMeasure;

	private: System::Windows::Forms::GroupBox^  groupBegin;
	private: System::Windows::Forms::GroupBox^  groupEnd;
	private: System::Windows::Forms::GroupBox^  groupRepeat;
	private: System::Windows::Forms::Label^  lblRepeatTimes;
	private: System::Windows::Forms::Label^  lblRepeatInterval;


	private: System::Windows::Forms::TextBox^  txtRepeat;
	private: System::Windows::Forms::Button^  btnCancel;
	private: System::Windows::Forms::Button^  btnOk;
	private: System::Windows::Forms::CheckBox^  checkNoLength;
private: System::Windows::Forms::Button^  btnReload;




	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			this->lblVPDFile = (gcnew System::Windows::Forms::Label());
			this->txtVPDFile = (gcnew System::Windows::Forms::TextBox());
			this->openFileDialog1 = (gcnew System::Windows::Forms::OpenFileDialog());
			this->btnOpenVPDFile = (gcnew System::Windows::Forms::Button());
			this->lblPoseData = (gcnew System::Windows::Forms::Label());
			this->lvwPoseData = (gcnew System::Windows::Forms::ListView());
			this->lblBeginTick = (gcnew System::Windows::Forms::Label());
			this->updownBeginTick = (gcnew System::Windows::Forms::NumericUpDown());
			this->lblBeginBeat = (gcnew System::Windows::Forms::Label());
			this->updownBeginBeat = (gcnew System::Windows::Forms::NumericUpDown());
			this->lblBeginMeasure = (gcnew System::Windows::Forms::Label());
			this->updownBeginMeasure = (gcnew System::Windows::Forms::NumericUpDown());
			this->txtBeginShiftTick = (gcnew System::Windows::Forms::TextBox());
			this->lblBeginShiftTick = (gcnew System::Windows::Forms::Label());
			this->txtBeginShiftFrame = (gcnew System::Windows::Forms::TextBox());
			this->lblBeginShiftFrame = (gcnew System::Windows::Forms::Label());
			this->lblEndTick = (gcnew System::Windows::Forms::Label());
			this->updownEndTick = (gcnew System::Windows::Forms::NumericUpDown());
			this->lblEndBeat = (gcnew System::Windows::Forms::Label());
			this->updownEndBeat = (gcnew System::Windows::Forms::NumericUpDown());
			this->lblEndMeasure = (gcnew System::Windows::Forms::Label());
			this->updownEndMeasure = (gcnew System::Windows::Forms::NumericUpDown());
			this->lblEndShiftFrame = (gcnew System::Windows::Forms::Label());
			this->txtEndShiftFrame = (gcnew System::Windows::Forms::TextBox());
			this->lblEndShiftTick = (gcnew System::Windows::Forms::Label());
			this->txtEndShiftTick = (gcnew System::Windows::Forms::TextBox());
			this->lblRepeatTick = (gcnew System::Windows::Forms::Label());
			this->updownRepeatTick = (gcnew System::Windows::Forms::NumericUpDown());
			this->lblRepeatBeat = (gcnew System::Windows::Forms::Label());
			this->updownRepeatBeat = (gcnew System::Windows::Forms::NumericUpDown());
			this->lblRepeatMeasure = (gcnew System::Windows::Forms::Label());
			this->updownRepeatMeasure = (gcnew System::Windows::Forms::NumericUpDown());
			this->groupBegin = (gcnew System::Windows::Forms::GroupBox());
			this->groupEnd = (gcnew System::Windows::Forms::GroupBox());
			this->groupRepeat = (gcnew System::Windows::Forms::GroupBox());
			this->lblRepeatTimes = (gcnew System::Windows::Forms::Label());
			this->lblRepeatInterval = (gcnew System::Windows::Forms::Label());
			this->txtRepeat = (gcnew System::Windows::Forms::TextBox());
			this->btnCancel = (gcnew System::Windows::Forms::Button());
			this->btnOk = (gcnew System::Windows::Forms::Button());
			this->checkNoLength = (gcnew System::Windows::Forms::CheckBox());
			this->btnReload = (gcnew System::Windows::Forms::Button());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownBeginTick))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownBeginBeat))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownBeginMeasure))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownEndTick))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownEndBeat))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownEndMeasure))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownRepeatTick))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownRepeatBeat))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownRepeatMeasure))->BeginInit();
			this->groupBegin->SuspendLayout();
			this->groupEnd->SuspendLayout();
			this->groupRepeat->SuspendLayout();
			this->SuspendLayout();
			// 
			// lblVPDFile
			// 
			this->lblVPDFile->AutoSize = true;
			this->lblVPDFile->Location = System::Drawing::Point(397, 10);
			this->lblVPDFile->Name = L"lblVPDFile";
			this->lblVPDFile->Size = System::Drawing::Size(79, 12);
			this->lblVPDFile->TabIndex = 0;
			this->lblVPDFile->Text = L"VPDt@C(&F):";
			// 
			// txtVPDFile
			// 
			this->txtVPDFile->Location = System::Drawing::Point(399, 25);
			this->txtVPDFile->Name = L"txtVPDFile";
			this->txtVPDFile->Size = System::Drawing::Size(216, 19);
			this->txtVPDFile->TabIndex = 1;
			this->txtVPDFile->TextChanged += gcnew System::EventHandler(this, &PoseDataDialog::txtVPDFile_TextChanged);
			// 
			// openFileDialog1
			// 
			this->openFileDialog1->FileName = L"openFileDialog1";
			// 
			// btnOpenVPDFile
			// 
			this->btnOpenVPDFile->Location = System::Drawing::Point(621, 25);
			this->btnOpenVPDFile->Name = L"btnOpenVPDFile";
			this->btnOpenVPDFile->Size = System::Drawing::Size(66, 19);
			this->btnOpenVPDFile->TabIndex = 2;
			this->btnOpenVPDFile->Text = L"Q(&B)...";
			this->btnOpenVPDFile->UseVisualStyleBackColor = true;
			this->btnOpenVPDFile->Click += gcnew System::EventHandler(this, &PoseDataDialog::btnOpenVPDFile_Click);
			// 
			// lblPoseData
			// 
			this->lblPoseData->AutoSize = true;
			this->lblPoseData->Location = System::Drawing::Point(12, 9);
			this->lblPoseData->Name = L"lblPoseData";
			this->lblPoseData->Size = System::Drawing::Size(81, 12);
			this->lblPoseData->TabIndex = 3;
			this->lblPoseData->Text = L"|[Yf[^(&D):";
			// 
			// lvwPoseData
			// 
			this->lvwPoseData->FullRowSelect = true;
			this->lvwPoseData->GridLines = true;
			this->lvwPoseData->Location = System::Drawing::Point(12, 24);
			this->lvwPoseData->Name = L"lvwPoseData";
			this->lvwPoseData->Size = System::Drawing::Size(381, 303);
			this->lvwPoseData->TabIndex = 4;
			this->lvwPoseData->UseCompatibleStateImageBehavior = false;
			this->lvwPoseData->View = System::Windows::Forms::View::Details;
			// 
			// lblBeginTick
			// 
			this->lblBeginTick->AutoSize = true;
			this->lblBeginTick->Location = System::Drawing::Point(227, 20);
			this->lblBeginTick->Name = L"lblBeginTick";
			this->lblBeginTick->Size = System::Drawing::Size(29, 12);
			this->lblBeginTick->TabIndex = 26;
			this->lblBeginTick->Text = L"/240";
			// 
			// updownBeginTick
			// 
			this->updownBeginTick->Location = System::Drawing::Point(167, 18);
			this->updownBeginTick->Name = L"updownBeginTick";
			this->updownBeginTick->Size = System::Drawing::Size(54, 19);
			this->updownBeginTick->TabIndex = 25;
			this->updownBeginTick->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			// 
			// lblBeginBeat
			// 
			this->lblBeginBeat->AutoSize = true;
			this->lblBeginBeat->Location = System::Drawing::Point(144, 20);
			this->lblBeginBeat->Name = L"lblBeginBeat";
			this->lblBeginBeat->Size = System::Drawing::Size(17, 12);
			this->lblBeginBeat->TabIndex = 24;
			this->lblBeginBeat->Text = L"";
			// 
			// updownBeginBeat
			// 
			this->updownBeginBeat->Location = System::Drawing::Point(102, 18);
			this->updownBeginBeat->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) {1, 0, 0, 0});
			this->updownBeginBeat->Name = L"updownBeginBeat";
			this->updownBeginBeat->Size = System::Drawing::Size(36, 19);
			this->updownBeginBeat->TabIndex = 23;
			this->updownBeginBeat->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->updownBeginBeat->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) {1, 0, 0, 0});
			// 
			// lblBeginMeasure
			// 
			this->lblBeginMeasure->AutoSize = true;
			this->lblBeginMeasure->Location = System::Drawing::Point(67, 20);
			this->lblBeginMeasure->Name = L"lblBeginMeasure";
			this->lblBeginMeasure->Size = System::Drawing::Size(29, 12);
			this->lblBeginMeasure->TabIndex = 22;
			this->lblBeginMeasure->Text = L"";
			// 
			// updownBeginMeasure
			// 
			this->updownBeginMeasure->Location = System::Drawing::Point(6, 18);
			this->updownBeginMeasure->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) {1, 0, 0, 0});
			this->updownBeginMeasure->Name = L"updownBeginMeasure";
			this->updownBeginMeasure->Size = System::Drawing::Size(55, 19);
			this->updownBeginMeasure->TabIndex = 21;
			this->updownBeginMeasure->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->updownBeginMeasure->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) {1, 0, 0, 0});
			this->updownBeginMeasure->ValueChanged += gcnew System::EventHandler(this, &PoseDataDialog::updownBeginMeasure_ValueChanged);
			// 
			// txtBeginShiftTick
			// 
			this->txtBeginShiftTick->Location = System::Drawing::Point(6, 43);
			this->txtBeginShiftTick->Name = L"txtBeginShiftTick";
			this->txtBeginShiftTick->Size = System::Drawing::Size(55, 19);
			this->txtBeginShiftTick->TabIndex = 28;
			this->txtBeginShiftTick->Text = L"0";
			this->txtBeginShiftTick->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			// 
			// lblBeginShiftTick
			// 
			this->lblBeginShiftTick->AutoSize = true;
			this->lblBeginShiftTick->Location = System::Drawing::Point(67, 46);
			this->lblBeginShiftTick->Name = L"lblBeginShiftTick";
			this->lblBeginShiftTick->Size = System::Drawing::Size(60, 12);
			this->lblBeginShiftTick->TabIndex = 29;
			this->lblBeginShiftTick->Text = L"tick炷B";
			// 
			// txtBeginShiftFrame
			// 
			this->txtBeginShiftFrame->Location = System::Drawing::Point(146, 43);
			this->txtBeginShiftFrame->Name = L"txtBeginShiftFrame";
			this->txtBeginShiftFrame->Size = System::Drawing::Size(55, 19);
			this->txtBeginShiftFrame->TabIndex = 30;
			this->txtBeginShiftFrame->Text = L"0";
			this->txtBeginShiftFrame->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			// 
			// lblBeginShiftFrame
			// 
			this->lblBeginShiftFrame->AutoSize = true;
			this->lblBeginShiftFrame->Location = System::Drawing::Point(207, 46);
			this->lblBeginShiftFrame->Name = L"lblBeginShiftFrame";
			this->lblBeginShiftFrame->Size = System::Drawing::Size(78, 12);
			this->lblBeginShiftFrame->TabIndex = 31;
			this->lblBeginShiftFrame->Text = L"t[炷B";
			// 
			// lblEndTick
			// 
			this->lblEndTick->AutoSize = true;
			this->lblEndTick->Location = System::Drawing::Point(227, 20);
			this->lblEndTick->Name = L"lblEndTick";
			this->lblEndTick->Size = System::Drawing::Size(29, 12);
			this->lblEndTick->TabIndex = 37;
			this->lblEndTick->Text = L"/240";
			// 
			// updownEndTick
			// 
			this->updownEndTick->Location = System::Drawing::Point(167, 18);
			this->updownEndTick->Name = L"updownEndTick";
			this->updownEndTick->Size = System::Drawing::Size(54, 19);
			this->updownEndTick->TabIndex = 36;
			this->updownEndTick->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			// 
			// lblEndBeat
			// 
			this->lblEndBeat->AutoSize = true;
			this->lblEndBeat->Location = System::Drawing::Point(144, 20);
			this->lblEndBeat->Name = L"lblEndBeat";
			this->lblEndBeat->Size = System::Drawing::Size(17, 12);
			this->lblEndBeat->TabIndex = 35;
			this->lblEndBeat->Text = L"";
			// 
			// updownEndBeat
			// 
			this->updownEndBeat->Location = System::Drawing::Point(102, 18);
			this->updownEndBeat->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) {1, 0, 0, 0});
			this->updownEndBeat->Name = L"updownEndBeat";
			this->updownEndBeat->Size = System::Drawing::Size(36, 19);
			this->updownEndBeat->TabIndex = 34;
			this->updownEndBeat->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->updownEndBeat->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) {1, 0, 0, 0});
			// 
			// lblEndMeasure
			// 
			this->lblEndMeasure->AutoSize = true;
			this->lblEndMeasure->Location = System::Drawing::Point(67, 20);
			this->lblEndMeasure->Name = L"lblEndMeasure";
			this->lblEndMeasure->Size = System::Drawing::Size(29, 12);
			this->lblEndMeasure->TabIndex = 33;
			this->lblEndMeasure->Text = L"";
			// 
			// updownEndMeasure
			// 
			this->updownEndMeasure->Location = System::Drawing::Point(6, 18);
			this->updownEndMeasure->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) {1, 0, 0, 0});
			this->updownEndMeasure->Name = L"updownEndMeasure";
			this->updownEndMeasure->Size = System::Drawing::Size(55, 19);
			this->updownEndMeasure->TabIndex = 32;
			this->updownEndMeasure->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->updownEndMeasure->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) {1, 0, 0, 0});
			this->updownEndMeasure->ValueChanged += gcnew System::EventHandler(this, &PoseDataDialog::updownEndMeasure_ValueChanged);
			// 
			// lblEndShiftFrame
			// 
			this->lblEndShiftFrame->AutoSize = true;
			this->lblEndShiftFrame->Location = System::Drawing::Point(207, 46);
			this->lblEndShiftFrame->Name = L"lblEndShiftFrame";
			this->lblEndShiftFrame->Size = System::Drawing::Size(78, 12);
			this->lblEndShiftFrame->TabIndex = 41;
			this->lblEndShiftFrame->Text = L"t[炷B";
			// 
			// txtEndShiftFrame
			// 
			this->txtEndShiftFrame->Location = System::Drawing::Point(146, 43);
			this->txtEndShiftFrame->Name = L"txtEndShiftFrame";
			this->txtEndShiftFrame->Size = System::Drawing::Size(55, 19);
			this->txtEndShiftFrame->TabIndex = 40;
			this->txtEndShiftFrame->Text = L"0";
			this->txtEndShiftFrame->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			// 
			// lblEndShiftTick
			// 
			this->lblEndShiftTick->AutoSize = true;
			this->lblEndShiftTick->Location = System::Drawing::Point(67, 46);
			this->lblEndShiftTick->Name = L"lblEndShiftTick";
			this->lblEndShiftTick->Size = System::Drawing::Size(60, 12);
			this->lblEndShiftTick->TabIndex = 39;
			this->lblEndShiftTick->Text = L"tick炷B";
			// 
			// txtEndShiftTick
			// 
			this->txtEndShiftTick->Location = System::Drawing::Point(6, 43);
			this->txtEndShiftTick->Name = L"txtEndShiftTick";
			this->txtEndShiftTick->Size = System::Drawing::Size(55, 19);
			this->txtEndShiftTick->TabIndex = 38;
			this->txtEndShiftTick->Text = L"0";
			this->txtEndShiftTick->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			// 
			// lblRepeatTick
			// 
			this->lblRepeatTick->AutoSize = true;
			this->lblRepeatTick->Location = System::Drawing::Point(227, 20);
			this->lblRepeatTick->Name = L"lblRepeatTick";
			this->lblRepeatTick->Size = System::Drawing::Size(29, 12);
			this->lblRepeatTick->TabIndex = 48;
			this->lblRepeatTick->Text = L"/240";
			// 
			// updownRepeatTick
			// 
			this->updownRepeatTick->Location = System::Drawing::Point(167, 18);
			this->updownRepeatTick->Name = L"updownRepeatTick";
			this->updownRepeatTick->Size = System::Drawing::Size(54, 19);
			this->updownRepeatTick->TabIndex = 47;
			this->updownRepeatTick->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			// 
			// lblRepeatBeat
			// 
			this->lblRepeatBeat->AutoSize = true;
			this->lblRepeatBeat->Location = System::Drawing::Point(144, 20);
			this->lblRepeatBeat->Name = L"lblRepeatBeat";
			this->lblRepeatBeat->Size = System::Drawing::Size(17, 12);
			this->lblRepeatBeat->TabIndex = 46;
			this->lblRepeatBeat->Text = L"";
			// 
			// updownRepeatBeat
			// 
			this->updownRepeatBeat->Location = System::Drawing::Point(102, 18);
			this->updownRepeatBeat->Name = L"updownRepeatBeat";
			this->updownRepeatBeat->Size = System::Drawing::Size(36, 19);
			this->updownRepeatBeat->TabIndex = 45;
			this->updownRepeatBeat->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->updownRepeatBeat->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) {1, 0, 0, 0});
			// 
			// lblRepeatMeasure
			// 
			this->lblRepeatMeasure->AutoSize = true;
			this->lblRepeatMeasure->Location = System::Drawing::Point(67, 20);
			this->lblRepeatMeasure->Name = L"lblRepeatMeasure";
			this->lblRepeatMeasure->Size = System::Drawing::Size(29, 12);
			this->lblRepeatMeasure->TabIndex = 44;
			this->lblRepeatMeasure->Text = L"";
			// 
			// updownRepeatMeasure
			// 
			this->updownRepeatMeasure->Location = System::Drawing::Point(6, 18);
			this->updownRepeatMeasure->Name = L"updownRepeatMeasure";
			this->updownRepeatMeasure->Size = System::Drawing::Size(55, 19);
			this->updownRepeatMeasure->TabIndex = 43;
			this->updownRepeatMeasure->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			// 
			// groupBegin
			// 
			this->groupBegin->Controls->Add(this->updownBeginMeasure);
			this->groupBegin->Controls->Add(this->lblBeginMeasure);
			this->groupBegin->Controls->Add(this->updownBeginBeat);
			this->groupBegin->Controls->Add(this->lblBeginBeat);
			this->groupBegin->Controls->Add(this->updownBeginTick);
			this->groupBegin->Controls->Add(this->lblBeginTick);
			this->groupBegin->Controls->Add(this->txtBeginShiftTick);
			this->groupBegin->Controls->Add(this->lblBeginShiftTick);
			this->groupBegin->Controls->Add(this->txtBeginShiftFrame);
			this->groupBegin->Controls->Add(this->lblBeginShiftFrame);
			this->groupBegin->Location = System::Drawing::Point(399, 50);
			this->groupBegin->Name = L"groupBegin";
			this->groupBegin->Size = System::Drawing::Size(288, 72);
			this->groupBegin->TabIndex = 49;
			this->groupBegin->TabStop = false;
			this->groupBegin->Text = L"Jnʒu(&S)";
			// 
			// groupEnd
			// 
			this->groupEnd->Controls->Add(this->updownEndMeasure);
			this->groupEnd->Controls->Add(this->lblEndMeasure);
			this->groupEnd->Controls->Add(this->updownEndBeat);
			this->groupEnd->Controls->Add(this->lblEndBeat);
			this->groupEnd->Controls->Add(this->updownEndTick);
			this->groupEnd->Controls->Add(this->lblEndTick);
			this->groupEnd->Controls->Add(this->txtEndShiftTick);
			this->groupEnd->Controls->Add(this->lblEndShiftTick);
			this->groupEnd->Controls->Add(this->txtEndShiftFrame);
			this->groupEnd->Controls->Add(this->lblEndShiftFrame);
			this->groupEnd->Location = System::Drawing::Point(399, 150);
			this->groupEnd->Name = L"groupEnd";
			this->groupEnd->Size = System::Drawing::Size(288, 72);
			this->groupEnd->TabIndex = 50;
			this->groupEnd->TabStop = false;
			this->groupEnd->Text = L"Iʒu(&E)";
			// 
			// groupRepeat
			// 
			this->groupRepeat->Controls->Add(this->lblRepeatTimes);
			this->groupRepeat->Controls->Add(this->lblRepeatInterval);
			this->groupRepeat->Controls->Add(this->txtRepeat);
			this->groupRepeat->Controls->Add(this->updownRepeatMeasure);
			this->groupRepeat->Controls->Add(this->lblRepeatMeasure);
			this->groupRepeat->Controls->Add(this->updownRepeatBeat);
			this->groupRepeat->Controls->Add(this->lblRepeatTick);
			this->groupRepeat->Controls->Add(this->lblRepeatBeat);
			this->groupRepeat->Controls->Add(this->updownRepeatTick);
			this->groupRepeat->Location = System::Drawing::Point(399, 228);
			this->groupRepeat->Name = L"groupRepeat";
			this->groupRepeat->Size = System::Drawing::Size(288, 72);
			this->groupRepeat->TabIndex = 51;
			this->groupRepeat->TabStop = false;
			this->groupRepeat->Text = L"JԂ(&K)";
			// 
			// lblRepeatTimes
			// 
			this->lblRepeatTimes->AutoSize = true;
			this->lblRepeatTimes->Location = System::Drawing::Point(118, 46);
			this->lblRepeatTimes->Name = L"lblRepeatTimes";
			this->lblRepeatTimes->Size = System::Drawing::Size(67, 12);
			this->lblRepeatTimes->TabIndex = 51;
			this->lblRepeatTimes->Text = L"JԂB";
			// 
			// lblRepeatInterval
			// 
			this->lblRepeatInterval->AutoSize = true;
			this->lblRepeatInterval->Location = System::Drawing::Point(6, 46);
			this->lblRepeatInterval->Name = L"lblRepeatInterval";
			this->lblRepeatInterval->Size = System::Drawing::Size(39, 12);
			this->lblRepeatInterval->TabIndex = 50;
			this->lblRepeatInterval->Text = L"ƂɁA";
			// 
			// txtRepeat
			// 
			this->txtRepeat->Location = System::Drawing::Point(51, 43);
			this->txtRepeat->Name = L"txtRepeat";
			this->txtRepeat->Size = System::Drawing::Size(61, 19);
			this->txtRepeat->TabIndex = 49;
			this->txtRepeat->Text = L"1";
			this->txtRepeat->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			// 
			// btnCancel
			// 
			this->btnCancel->DialogResult = System::Windows::Forms::DialogResult::Cancel;
			this->btnCancel->Location = System::Drawing::Point(608, 306);
			this->btnCancel->Name = L"btnCancel";
			this->btnCancel->Size = System::Drawing::Size(79, 22);
			this->btnCancel->TabIndex = 53;
			this->btnCancel->Text = L"LZ(&C)";
			this->btnCancel->UseVisualStyleBackColor = true;
			// 
			// btnOk
			// 
			this->btnOk->DialogResult = System::Windows::Forms::DialogResult::OK;
			this->btnOk->Location = System::Drawing::Point(532, 306);
			this->btnOk->Name = L"btnOk";
			this->btnOk->Size = System::Drawing::Size(70, 22);
			this->btnOk->TabIndex = 52;
			this->btnOk->Text = L"OK(&O)";
			this->btnOk->UseVisualStyleBackColor = true;
			this->btnOk->Click += gcnew System::EventHandler(this, &PoseDataDialog::btnOk_Click);
			// 
			// checkNoLength
			// 
			this->checkNoLength->AutoSize = true;
			this->checkNoLength->Location = System::Drawing::Point(399, 128);
			this->checkNoLength->Name = L"checkNoLength";
			this->checkNoLength->Size = System::Drawing::Size(110, 16);
			this->checkNoLength->TabIndex = 54;
			this->checkNoLength->Text = L"|[Y(&Z)";
			this->checkNoLength->UseVisualStyleBackColor = true;
			this->checkNoLength->CheckedChanged += gcnew System::EventHandler(this, &PoseDataDialog::checkNoLength_CheckedChanged);
			// 
			// btnReload
			// 
			this->btnReload->Location = System::Drawing::Point(588, 6);
			this->btnReload->Name = L"btnReload";
			this->btnReload->Size = System::Drawing::Size(99, 19);
			this->btnReload->TabIndex = 55;
			this->btnReload->Text = L"Ǎ/ēǍ(&R)";
			this->btnReload->UseVisualStyleBackColor = true;
			this->btnReload->Click += gcnew System::EventHandler(this, &PoseDataDialog::btnReload_Click);
			// 
			// PoseDataDialog
			// 
			this->AcceptButton = this->btnOk;
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->CancelButton = this->btnCancel;
			this->ClientSize = System::Drawing::Size(699, 339);
			this->Controls->Add(this->btnReload);
			this->Controls->Add(this->checkNoLength);
			this->Controls->Add(this->btnCancel);
			this->Controls->Add(this->btnOk);
			this->Controls->Add(this->groupEnd);
			this->Controls->Add(this->groupRepeat);
			this->Controls->Add(this->groupBegin);
			this->Controls->Add(this->lvwPoseData);
			this->Controls->Add(this->lblPoseData);
			this->Controls->Add(this->btnOpenVPDFile);
			this->Controls->Add(this->txtVPDFile);
			this->Controls->Add(this->lblVPDFile);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedDialog;
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = L"PoseDataDialog";
			this->ShowInTaskbar = false;
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterParent;
			this->Text = L"|[Yf[^ݒ";
			this->Load += gcnew System::EventHandler(this, &PoseDataDialog::PoseDataDialog_Load);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownBeginTick))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownBeginBeat))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownBeginMeasure))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownEndTick))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownEndBeat))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownEndMeasure))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownRepeatTick))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownRepeatBeat))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->updownRepeatMeasure))->EndInit();
			this->groupBegin->ResumeLayout(false);
			this->groupBegin->PerformLayout();
			this->groupEnd->ResumeLayout(false);
			this->groupEnd->PerformLayout();
			this->groupRepeat->ResumeLayout(false);
			this->groupRepeat->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion


	private:
		System::Void InitPoseDataListView() {//lvwPoseDatȁ
			lvwPoseData->Clear();
			lvwPoseData->Columns->Add("{[", 100);
			lvwPoseData->Columns->Add("ړX", 80, System::Windows::Forms::HorizontalAlignment::Right);
			lvwPoseData->Columns->Add("ړY", 80, System::Windows::Forms::HorizontalAlignment::Right);
			lvwPoseData->Columns->Add("ړZ", 80, System::Windows::Forms::HorizontalAlignment::Right);
			lvwPoseData->Columns->Add("]X", 80, System::Windows::Forms::HorizontalAlignment::Right);
			lvwPoseData->Columns->Add("]Y", 80, System::Windows::Forms::HorizontalAlignment::Right);
			lvwPoseData->Columns->Add("]Z", 80, System::Windows::Forms::HorizontalAlignment::Right);
			lvwPoseData->Columns->Add("]W", 80, System::Windows::Forms::HorizontalAlignment::Right);
		}

	private:
		System::Void checkNoLength_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {//|[Ỹ`FbN
			if (checkNoLength->Checked) {//`FbNĂƂ
				groupEnd->Enabled = false;//Iʒu
			} else {//`FbNĂȂƂ
				groupEnd->Enabled = true;//IʒuL
			}
		}

	private:
		System::Void btnOpenVPDFile_Click(System::Object^  sender, System::EventArgs^  e) {//VPDt@CǍ
			openFileDialog1->InitialDirectory = config->Path->MMD_Pose;
			openFileDialog1->FileName = "";
			openFileDialog1->Filter = "Vocaloid Pose Data files|*.vpd|ׂẴt@C|*.*";
			openFileDialog1->Title = "VPDt@C̓Ǎ";
			if(openFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::OK) {
				OpenVPD(openFileDialog1->FileName);
			}
		}

	private:
		System::Void btnReload_Click(System::Object^  sender, System::EventArgs^  e) {//ēǍ
			OpenVPD(txtVPDFile->Text);
		}

	public:
		System::Void OpenVPD(System::String^ filename) {//VPDt@C̓Ǎ
			this->Cursor = Cursors::WaitCursor;

			pattern->vpd->FileName = filename;
			
			if (pattern->vpd->Open()) {//VPDt@CǍ
				DrawVPDListView();
			}

			this->Cursor = Cursors::Default;
		}

	private:
		System::Void DrawVPDListView() {//|[Yf[^̕\
			InitPoseDataListView();//lvwPoseDatȁ

			for (int i = 0; i < pattern->vpd->Poses->Count; i++) {
				MMD::Pose^ pose = safe_cast<MMD::Pose^>(pattern->vpd->Poses[i]);
				lvwPoseData->Items->Add(pose->Name->ToString());
				lvwPoseData->Items[i]->SubItems->Add(pose->Trans.X.ToString());
				lvwPoseData->Items[i]->SubItems->Add(pose->Trans.Y.ToString());
				lvwPoseData->Items[i]->SubItems->Add(pose->Trans.Z.ToString());
				lvwPoseData->Items[i]->SubItems->Add(pose->Rot.X.ToString());
				lvwPoseData->Items[i]->SubItems->Add(pose->Rot.Y.ToString());
				lvwPoseData->Items[i]->SubItems->Add(pose->Rot.Z.ToString());
				lvwPoseData->Items[i]->SubItems->Add(pose->Rot.W.ToString());
			}
			txtVPDFile->Text = pattern->vpd->FileName;
			btnReload->Enabled = true;
			btnOk->Enabled = true;
			this->AcceptButton = btnOk;
			btnOk->Focus();
			groupBegin->Focus();
		}

	private:
		System::Void btnOk_Click(System::Object^  sender, System::EventArgs^  e) {//OK{^
			//̓G[`FbNB
			//|[YJnʒu
			pattern->Begin->Measure = (int)updownBeginMeasure->Value;
			pattern->Begin->Beat = (int)updownBeginBeat->Value;
			pattern->Begin->Tick = (int)updownBeginTick->Value;
			pattern->Begin->ShiftTick = Int32::Parse(txtBeginShiftTick->Text);
			pattern->Begin->ShiftFrame = Int32::Parse(txtBeginShiftFrame->Text);
			//|[YIʒu
			pattern->End->Measure = (int)updownEndMeasure->Value;
			pattern->End->Beat = (int)updownEndBeat->Value;
			pattern->End->Tick = (int)updownEndTick->Value;
			pattern->End->ShiftTick = Int32::Parse(txtEndShiftTick->Text);
			pattern->End->ShiftFrame = Int32::Parse(txtEndShiftFrame->Text);
			//true=Ȃ|[Y
			pattern->NoLength = this->checkNoLength->Checked;
			//|[Y̌JԂԊu
			pattern->Step->Measure = (int)updownRepeatMeasure->Value;
			pattern->Step->Beat = (int)updownRepeatBeat->Value;
			pattern->Step->Tick = (int)updownRepeatTick->Value;
			//|[Y̌JԂ(1=JԂȂ)
			pattern->Repeat = Int32::Parse(txtRepeat->Text);
		}

	private:
		System::Void updownBeginMeasure_ValueChanged(System::Object^  sender, System::EventArgs^  e) {//JnʒȕߕύX
			//
			pattern->Begin->Measure = (int)updownBeginMeasure->Value;
			//
			updownBeginBeat->Maximum = pattern->Begin->MaxBeat;
			if (updownBeginBeat->Value > updownBeginBeat->Maximum) {
				updownBeginBeat->Value = updownBeginBeat->Maximum;
			}
			//tick
			int max = pattern->Begin->DeltaTime;
			lblBeginTick->Text = "/" + max.ToString();//\0`239/240
			max--;//\240 ̏ꍇ́A0`239
			updownBeginTick->Maximum = max;
			if (updownBeginTick->Value > max) {
				updownBeginTick->Value = max;
			}
		}

	private:
		System::Void updownEndMeasure_ValueChanged(System::Object^  sender, System::EventArgs^  e) {//IʒȕߕύX
			//
			pattern->End->Measure = (int)updownEndMeasure->Value;
			//
			updownEndBeat->Maximum = pattern->End->MaxBeat;
			if (updownEndBeat->Value > updownEndBeat->Maximum) {
				updownEndBeat->Value = updownEndBeat->Maximum;
			}
			//tick
			int max = pattern->End->DeltaTime;
			lblEndTick->Text = "/" + max.ToString();//\0`239/240
			max--;//\240 ̏ꍇ́A0`239
			updownEndTick->Maximum = max;
			if (updownEndTick->Value > max) {
				updownEndTick->Value = max;
			}
		}

	private:
		System::Void PoseDataDialog_Load(System::Object^  sender, System::EventArgs^  e) {//tH[[h
			if (pattern->vpd->Poses->Count > 0) {//|[Yf[^ɂĂƂ
				DrawVPDListView();
			}
		}

	private:
		System::Void txtVPDFile_TextChanged(System::Object^  sender, System::EventArgs^  e) {
			if (txtVPDFile->Text == "") {
				this->btnReload->Enabled = false;
			} else {
				this->btnReload->Enabled = true;
			}
		}
};
}
