#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Text;

#include "TimeLine.h"
#include "..\SMF\SMF.h"
#include "..\SMF\SMF_Position.h"
#include "..\Editor\Editor_Operation.h"

//ҏW
#include "Edit\Edit_DeleteTempo.h"
#include "Edit\Edit_DeleteBeat.h"
#include "Edit\Edit_InsertTempo.h"
#include "Edit\Edit_ReplaceTempo.h"
#include "Edit\Edit_InsertBeat.h"
#include "Edit\Edit_ReplaceBeat.h"
#include "Edit\Edit_AddBeat.h"

namespace MetMotMk {

	/// <summary>
	/// SMFView ̊Tv
	///
	/// x: ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public ref class SMFView : public System::Windows::Forms::Form
	{
	public:
		SMFView(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^ R[hǉ܂
			//
			this->menuItemDelete->Enabled = false;
			this->menuItemDeleteEvent->Enabled = false;
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~SMFView()
		{
			if (components)
			{
				delete components;
			}
		}

	public:
		System::Void UpdateTimeline(void);//^CCEBhE̍XV
	private:
		System::Void Exec(Editor::Operation^);//ҏW̎s
		System::Void Undo();//ɖ߂
		System::Void Redo();//蒼
	private: System::Void SetStatusMessage(String^);//Xe[^Xo[ɃbZ[W\
	private: System::Void SetStatusProgressBarMax(int);//Xe[^Xo[̃vOXo[ɍőlݒ
	private: System::Void SetStatusProgressBar(int);//Xe[^Xo[̃vOXo[ɒlݒ
	private: System::Void SetStatusPosition(String^);//Xe[^Xo[ɎԈʒu\
	private: System::Void MergeToolbar();//c[o[̌
	private: System::Void RevertMergeToolbar();//c[o[̌̉

	public:
		TimeLine^ timeline;


	private: System::Windows::Forms::ListView^  lvwEvent;
	private: System::Windows::Forms::ContextMenuStrip^  contextMenuItemEdit;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemDelete;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemEdit;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemDeleteEvent;
	private: System::Windows::Forms::MenuStrip^  menuStripMain;
	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator1;

	private: System::ComponentModel::IContainer^  components;

	protected: 

	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			this->lvwEvent = (gcnew System::Windows::Forms::ListView());
			this->contextMenuItemEdit = (gcnew System::Windows::Forms::ContextMenuStrip(this->components));
			this->menuItemDelete = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemEdit = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemDeleteEvent = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuStripMain = (gcnew System::Windows::Forms::MenuStrip());
			this->toolStripSeparator1 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->contextMenuItemEdit->SuspendLayout();
			this->menuStripMain->SuspendLayout();
			this->SuspendLayout();
			// 
			// lvwEvent
			// 
			this->lvwEvent->ContextMenuStrip = this->contextMenuItemEdit;
			this->lvwEvent->Dock = System::Windows::Forms::DockStyle::Fill;
			this->lvwEvent->FullRowSelect = true;
			this->lvwEvent->GridLines = true;
			this->lvwEvent->Location = System::Drawing::Point(0, 26);
			this->lvwEvent->Name = L"lvwEvent";
			this->lvwEvent->Size = System::Drawing::Size(717, 422);
			this->lvwEvent->TabIndex = 5;
			this->lvwEvent->UseCompatibleStateImageBehavior = false;
			this->lvwEvent->View = System::Windows::Forms::View::Details;
			this->lvwEvent->SelectedIndexChanged += gcnew System::EventHandler(this, &SMFView::lvwEvent_SelectedIndexChanged);
			// 
			// contextMenuItemEdit
			// 
			this->contextMenuItemEdit->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) {this->menuItemDelete});
			this->contextMenuItemEdit->Name = L"contextMenuItemEdit";
			this->contextMenuItemEdit->Size = System::Drawing::Size(147, 26);
			// 
			// menuItemDelete
			// 
			this->menuItemDelete->Name = L"menuItemDelete";
			this->menuItemDelete->ShortcutKeyDisplayString = L"Del";
			this->menuItemDelete->Size = System::Drawing::Size(146, 22);
			this->menuItemDelete->Text = L"폜(&D)";
			this->menuItemDelete->Click += gcnew System::EventHandler(this, &SMFView::menuItemDelete_Click);
			// 
			// menuItemEdit
			// 
			this->menuItemEdit->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->toolStripSeparator1, 
				this->menuItemDeleteEvent});
			this->menuItemEdit->MergeAction = System::Windows::Forms::MergeAction::MatchOnly;
			this->menuItemEdit->MergeIndex = 1;
			this->menuItemEdit->Name = L"menuItemEdit";
			this->menuItemEdit->Size = System::Drawing::Size(61, 22);
			this->menuItemEdit->Text = L"ҏW(&E)";
			// 
			// menuItemDeleteEvent
			// 
			this->menuItemDeleteEvent->Name = L"menuItemDeleteEvent";
			this->menuItemDeleteEvent->ShortcutKeyDisplayString = L"Del";
			this->menuItemDeleteEvent->Size = System::Drawing::Size(152, 22);
			this->menuItemDeleteEvent->Text = L"폜(&D)";
			this->menuItemDeleteEvent->Click += gcnew System::EventHandler(this, &SMFView::menuItemDeleteEvent_Click);
			// 
			// menuStripMain
			// 
			this->menuStripMain->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) {this->menuItemEdit});
			this->menuStripMain->Location = System::Drawing::Point(0, 0);
			this->menuStripMain->Name = L"menuStripMain";
			this->menuStripMain->Size = System::Drawing::Size(717, 26);
			this->menuStripMain->TabIndex = 1;
			this->menuStripMain->Text = L"menuStrip1";
			this->menuStripMain->Visible = false;
			// 
			// toolStripSeparator1
			// 
			this->toolStripSeparator1->Name = L"toolStripSeparator1";
			this->toolStripSeparator1->Size = System::Drawing::Size(149, 6);
			// 
			// SMFView
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(717, 448);
			this->Controls->Add(this->lvwEvent);
			this->Controls->Add(this->menuStripMain);
			this->KeyPreview = true;
			this->MainMenuStrip = this->menuStripMain;
			this->Name = L"SMFView";
			this->Text = L"MIDIf[^";
			this->Activated += gcnew System::EventHandler(this, &SMFView::SMFView_Activated);
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &SMFView::SMFView_FormClosing);
			this->KeyDown += gcnew System::Windows::Forms::KeyEventHandler(this, &SMFView::SMFView_KeyDown);
			this->contextMenuItemEdit->ResumeLayout(false);
			this->menuStripMain->ResumeLayout(false);
			this->menuStripMain->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion


	public:
		System::Void InitEventListview() {
				lvwEvent->Clear();
				lvwEvent->Columns->Add("Trk", 30, System::Windows::Forms::HorizontalAlignment::Right);
				lvwEvent->Columns->Add("", 40, System::Windows::Forms::HorizontalAlignment::Right);
				lvwEvent->Columns->Add("", 30, System::Windows::Forms::HorizontalAlignment::Right);
				lvwEvent->Columns->Add("Tick", 40, System::Windows::Forms::HorizontalAlignment::Right);
				lvwEvent->Columns->Add("Cxg", 130);
				lvwEvent->Columns->Add("Cxg", 50);
				lvwEvent->Columns->Add("p[^", 500);
			}

	public:
		System::Void SetTimeLine(TimeLine ^timeline) {//TimeLine̐ݒ
			this->timeline = timeline;
		}

	public:
		System::Void DrawListview() {//MIDIf[^ƃe|Listviewɕ\
			this->Text = "MIDIf[^";
			if (timeline->smf->Filename != nullptr && timeline->smf->Filename != "") {
				this->Text += " - " + timeline->smf->Filename;
			}
			DrawEventListview();
		}

	private:
		System::Void DrawEventListview() {//MIDIf[^Listviewɕ\
			///*
			int total = 0;
			for (int t = 0; t < timeline->smf->Header.Tracks; t++) {
				total += timeline->smf->Tracks[t]->Events->Count;
			}
			int pv = 50;//i)
			total += pv;
			this->SetStatusProgressBarMax(total);
			//*/

			InitEventListview();
			for (int t = 0; t < timeline->smf->Header.Tracks; t++) {
				for (int i = 0; i < timeline->smf->Tracks[t]->Events->Count; i++, pv++) {
					///*
					if ((pv & 0x3ff) == 0) {
						this->SetStatusProgressBar(pv);
						//this->SetStatusMessage(System::String::Format("{0}/{1}", pv, total));
						//Application::DoEvents();
					}
					//System::Diagnostics::Debug::WriteLineIf(pv % 100 == 0, System::String::Format("{0}/{1}", pv, total));
					//*/
					SMF::Event^ ev = safe_cast<SMF::Event^>(timeline->smf->Tracks[t]->Events[i]);
					SMF::Position^ pos = gcnew SMF::Position(timeline->smf);
					pos->GlobalTick = ev->GlobalTick;
					lvwEvent->Items->Add(t.ToString()->PadLeft(3, ' '));
					AddEventSubItems(lvwEvent->Items->Count - 1, ev, pos);
					/*
					lvwEvent->Items[lvwEvent->Items->Count - 1]->SubItems->Add(pos->Measure.ToString());
					lvwEvent->Items[lvwEvent->Items->Count - 1]->SubItems->Add(pos->Beat.ToString());
					lvwEvent->Items[lvwEvent->Items->Count - 1]->SubItems->Add(pos->Tick.ToString());
					lvwEvent->Items[lvwEvent->Items->Count - 1]->SubItems->Add(ev->Name);
					lvwEvent->Items[lvwEvent->Items->Count - 1]->SubItems->Add(String::Format("{0,2:X2}", ev->status));
					if (0x01 <= ev->status && ev->status <= 0x09) {
						lvwEvent->Items[lvwEvent->Items->Count - 1]->SubItems->Add(encoding->GetString(ev->Data));
					} else {
						lvwEvent->Items[lvwEvent->Items->Count - 1]->SubItems->Add(timeline->smf->ComposeHexDump(ev->Data));
					}
					*/
				}
			}

			///*
			//this->SetStatusProgressBar(0);
			//this->SetStatusMessage("");
			//*/
		}

	private:
		System::Void AddEventSubItems(int index, SMF::Event^ ev, SMF::Position^ pos) {
			Encoding^ encoding = Encoding::GetEncoding("Shift_JIS");
			lvwEvent->Items[index]->SubItems->Add(pos->Measure.ToString());
			lvwEvent->Items[index]->SubItems->Add(pos->Beat.ToString());
			lvwEvent->Items[index]->SubItems->Add(pos->Tick.ToString());
			lvwEvent->Items[index]->SubItems->Add(ev->Name);
			lvwEvent->Items[index]->SubItems->Add(String::Format("{0,2:X2}", ev->status));
			if (0x01 <= ev->status && ev->status <= 0x09) {
				lvwEvent->Items[index]->SubItems->Add(encoding->GetString(ev->Data));
			} else {
				lvwEvent->Items[index]->SubItems->Add(timeline->smf->ComposeHexDump(ev->Data));
			}
		}

	private:
		System::Void ReplaceEventSubItems(int index, SMF::Event^ ev) {
			Encoding^ encoding = Encoding::GetEncoding("Shift_JIS");
			//uȂ̂ŃgbNƃ|WVƁAXe[^X͂̂܂܁B(Cxg͔qƂe|̃p[^̋Lqς)
			lvwEvent->Items[index]->SubItems[4]->Text = ev->Name;
			if (0x01 <= ev->status && ev->status <= 0x09) {
				lvwEvent->Items[index]->SubItems[6]->Text = encoding->GetString(ev->Data);
			} else {
				lvwEvent->Items[index]->SubItems[6]->Text = timeline->smf->ComposeHexDump(ev->Data);
			}
		}

	private:
		System::Void ReplaceEventSubItems(int index, int track, SMF::Event^ ev, SMF::Position^ pos) {//qύXɔ߈ʒuύX̏B(Sڏ)
			Encoding^ encoding = Encoding::GetEncoding("Shift_JIS");
			lvwEvent->Items[index]->SubItems[0]->Text = track.ToString()->PadLeft(3, ' ');
			lvwEvent->Items[index]->SubItems[1]->Text = pos->Measure.ToString();
			lvwEvent->Items[index]->SubItems[2]->Text = pos->Beat.ToString();
			lvwEvent->Items[index]->SubItems[3]->Text = pos->Tick.ToString();
			lvwEvent->Items[index]->SubItems[4]->Text = ev->Name;
			lvwEvent->Items[index]->SubItems[5]->Text = String::Format("{0,2:X2}", ev->status);
			if (0x01 <= ev->status && ev->status <= 0x09) {
				lvwEvent->Items[index]->SubItems[6]->Text = encoding->GetString(ev->Data);
			} else {
				lvwEvent->Items[index]->SubItems[6]->Text = timeline->smf->ComposeHexDump(ev->Data);
			}
		}

	private:
		System::Void SMFView_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e) {
			e->Cancel = true;
			if (e->CloseReason == System::Windows::Forms::CloseReason::UserClosing) {//́~ƂB
				this->Hide();
			}
		}

	private:
		System::Void SMFView_Activated(System::Object^  sender, System::EventArgs^  e) {//tH[ANeBx[g
		}

	private:
		System::Void lvwEvent_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e) {//MIDICxg̃Xgr[SelectedIndexύX
			ListView::SelectedIndexCollection^ indexes = lvwEvent->SelectedIndices;
			if (indexes->Count > 0 && (timeline->smf->Filename == nullptr || timeline->smf->Filename == "")) {
				int i = indexes[0];
				if (lvwEvent->Items[i]->SubItems[5]->Text == "51" || lvwEvent->Items[i]->SubItems[5]->Text == "58") {
					//e|`FW܂͔qύX
					if (lvwEvent->Items[i]->SubItems[1]->Text == "1" && lvwEvent->Items[i]->SubItems[2]->Text == "1"
													&& lvwEvent->Items[i]->SubItems[3]->Text == "0") {//GlobalTick==0 ̃Cxg͍폜ȂB
						this->menuItemDelete->Enabled = false;
						this->menuItemDeleteEvent->Enabled = false;
					} else {
						this->menuItemDelete->Enabled = true;
						this->menuItemDeleteEvent->Enabled = true;
					}
				} else {
					this->menuItemDelete->Enabled = false;
					this->menuItemDeleteEvent->Enabled = false;
				}
			} else {
				this->menuItemDelete->Enabled = false;
				this->menuItemDeleteEvent->Enabled = false;
			}
		}

	private:
		System::Void menuItemDeleteEvent_Click(System::Object^  sender, System::EventArgs^  e) {//MenuStrip̍폜
			if (this->ActiveControl == lvwEvent) {//qEe|폜
				DeleteEvent();
			}
		}
	private:
		System::Void menuItemDelete_Click(System::Object^  sender, System::EventArgs^  e) {//ContextMenuStrip̍폜
			if (this->ActiveControl == lvwEvent) {//qEe|폜
				DeleteEvent();
			}
		}

	private:
		System::Void DeleteEvent() {//MIDICxg̃Xgr[̍폜
			ListView::SelectedIndexCollection^ indexes = lvwEvent->SelectedIndices;
			if (indexes->Count > 0) {
				int index = indexes[0];//}`ZNgɂ͂Ƃ肠ΉȂB
				SMF::Position^ pos = gcnew SMF::Position(timeline->smf);
				pos->Measure = Int32::Parse(lvwEvent->Items[index]->SubItems[1]->Text);
				pos->Beat = Int32::Parse(lvwEvent->Items[index]->SubItems[2]->Text);
				pos->Tick = Int32::Parse(lvwEvent->Items[index]->SubItems[3]->Text);
				if (pos->GlobalTick > 0) {//tick==0 ̃f[^͍폜Ȃ
					int track = Int32::Parse(lvwEvent->Items[index]->SubItems[0]->Text);
					SMF::Event^ ev = safe_cast<SMF::Event^>(timeline->smf->Tracks[track]->Events[index]);
					String^ strStatus = lvwEvent->Items[index]->SubItems[5]->Text;
					/*
					array<String^>^ strData = lvwEvent->Items[index]->SubItems[6]->Text->Split(' ');
					array<Byte>^ bytData = gcnew array<Byte>(strData->Length);
					for (int i = 0; i < strData->Length; i++) {
						bytData[i] = Byte::Parse(strData[i], System::Globalization::NumberStyles::HexNumber);
					}
					*/
					if (strStatus == "51") {//e|̍폜(timeline->smf->TempoChanges 폜)
						for (int i = 0; i < timeline->smf->TempoChanges->Count; i++) {
							SMF::TempoChange^ tc = safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[i]);
							if (tc->Tick == pos->GlobalTick && tc->Track == track) {
								int tempo = (int)System::Math::Round(60.0 * 1000.0 * 1000.0 / tc->Tempo);
								if (ev->Data[0] == ((tempo >> 16) & 0xff) && ev->Data[1] == ((tempo >> 8) & 0xff) && ev->Data[2] == (tempo & 0xff)) {
									Exec(gcnew Edit::DeleteTempo(this, timeline, track, index, i, ev, pos));
									/*
									RemoveEvent(track, index);
									timeline->smf->TempoChanges->RemoveAt(i);
									timeline->smf->CalcFrameAtTempoTable();//t[̍ČvZ
									UpdateTimeline();//^CCEBhE̍XV
									*/
									break;
								}
							}
						}
					} else if (strStatus == "58") {//q̍폜(timneline->smf->BeatChanges 폜)
						for (int i = 0; i < timeline->smf->BeatChanges->Count; i++) {
							SMF::BeatChange^ bc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[i]);
							if (bc->Tick == pos->GlobalTick) {
								if (ev->Data[0] == bc->BeatInfo->nn && (1 << ev->Data[1]) == bc->BeatInfo->dd
												&& ev->Data[2] == bc->BeatInfo->cc && ev->Data[3] == bc->BeatInfo->bb)
								{
									Exec(gcnew Edit::DeleteBeat(this, timeline, track, index, i, ev, pos));
									/*	
									RemoveEvent(track, index);
									timeline->smf->BeatChanges->RemoveAt(i);
									UpdateTimeline();//^CCEBhE̍XV
									*/
									break;
								}
							}
						}
					}
					timeline->Changed = true;

				}
			}
		}

	public:
		System::Void RemoveEvent(int track, int index) {//Cxg̍폜
			//MIDICxg̍폜(timeline->smf->Events 폜)
			//\[g͂Ȃ̂ŁAԂ͓͂B
			//(MIDICxg̑}E폜ł̂́AȂ̔qEe|Ew肵ăvWFNg쐬Ƃ
			//łȂ̂ŁAgbN0Ԃ݂Ȃ̂ňvB̎dlύXŕs邩Ȃ̂ŗv)
			lvwEvent->Items->RemoveAt(index);
			timeline->smf->Tracks[track]->Events->RemoveAt(index);
		}
	
	public:
		System::Void InsertEvent(int track, int index, SMF::Event^ ev) {//Cxg̑}
			SMF::Position^ pos = gcnew SMF::Position(timeline->smf);
			pos->GlobalTick = ev->GlobalTick;
			lvwEvent->Items->Insert(index, track.ToString()->PadLeft(3, ' '));
			AddEventSubItems(index, ev, pos);
			timeline->smf->Tracks[track]->Events->Insert(index, ev);
		}

	public:
		System::Void ReplaceEvent(int track, int index, SMF::Event^ ev) {//Cxg̒u
			SMF::Position^ pos = gcnew SMF::Position(timeline->smf);
			pos->GlobalTick = ev->GlobalTick;
			ReplaceEventSubItems(index, ev);
			timeline->smf->Tracks[track]->Events[index] = ev;
		}

	public:
		System::Void InsertTempo(int track, int index, SMF::TempoChange^ tc) {//e|̑}
			//timeline->smf->TempoChanges->Insert(index, tc);//}
			SMF::Event^ ev = gcnew SMF::Event(tc);
			SMF::Position^ pos = gcnew SMF::Position(timeline->smf);
			pos->GlobalTick = ev->GlobalTick;
			int c = timeline->smf->Tracks[0]->Events->Count;
			for (int i = 0; i < c; i++) {
				SMF::Event^ dat_ev = safe_cast<SMF::Event^>(timeline->smf->Tracks[track]->Events[i]);
				if (dat_ev->GlobalTick > ev->GlobalTick) {
					Exec(gcnew Edit::InsertTempo(this, timeline, track, i, index, ev, tc, pos));
					//InsertEvent(track, i, ev);//Cxg̑}
					break;
				}
			}
		}

	public:
		System::Void ReplaceTempo(int track, int index, SMF::TempoChange^ tc) {//e|̒u
			//timeline->smf->TempoChanges[index] = tc;
			SMF::Event^ ev = gcnew SMF::Event(tc);
			SMF::Position^ pos = gcnew SMF::Position(timeline->smf);
			pos->GlobalTick = ev->GlobalTick;
			int c = timeline->smf->Tracks[0]->Events->Count;
			for (int i = 0; i < c; i++) {
				SMF::Event^ dat_ev = safe_cast<SMF::Event^>(timeline->smf->Tracks[track]->Events[i]);
				if (dat_ev->GlobalTick == ev->GlobalTick && dat_ev->status == ev->status) {
					Exec(gcnew Edit::ReplaceTempo(this, timeline, track, i, index,
								dat_ev, safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[index]), ev, tc, pos));
					//ReplaceEvent(track, i, ev);
					break;
				}
			}
		}

	public:
		System::Void UpdateBeatTable() {//qύXɔMIDICxge[uƃXgr[̍č\z
			int evc = timeline->smf->Tracks[0]->Events->Count;
			//MIDICxge[u甏qύX̍폜(qύX́AgbN=0 ݂̂ɑ݂͂Ȃ̂ŁAgbN=0 ɌB
			for (int i = evc - 1; i >= 0; i--) {
				SMF::Event^ ev = safe_cast<SMF::Event^>(timeline->smf->Tracks[0]->Events[i]);
				if (ev->status == 0x58) {//qύX̂Ƃ
					timeline->smf->Tracks[0]->Events->RemoveAt(i);//폜
				}
			}
			//MIDICxge[uɔqύX}ȂB
			for (int i = 0, evp = 0; i < timeline->smf->BeatChanges->Count; i++) {
				SMF::BeatChange^ bc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[i]);
				SMF::Event^ ev = gcnew SMF::Event(bc);
				for (; evp < evc; evp++) {
					SMF::Event^ dat_ev = safe_cast<SMF::Event^>(timeline->smf->Tracks[0]->Events[evp]);
					if (dat_ev->GlobalTick > ev->GlobalTick) {
						timeline->smf->Tracks[0]->Events->Insert(evp, ev);
						break;
					}
				}
				if (evp == evc) {//}ȂƂ
					timeline->smf->Tracks[0]->Events->Add(ev);
				}
			}
			//MIDICxge[u̓eXgr[ɔfB
			int lvc = 0;
			for (int t = 0; t < timeline->smf->Tracks->Length; t++) {
				for (int i = 0; i < timeline->smf->Tracks[t]->Events->Count; i++, lvc++) {
					SMF::Event^ ev = safe_cast<SMF::Event^>(timeline->smf->Tracks[t]->Events[i]);
					SMF::Position^ pos = gcnew SMF::Position(timeline->smf);
					pos->GlobalTick = ev->GlobalTick;
					if (lvc < lvwEvent->Items->Count) {
						ReplaceEventSubItems(lvc, t, ev, pos);
					} else {
						lvwEvent->Items->Add(t.ToString()->PadLeft(3, ' '));
						AddEventSubItems(lvwEvent->Items->Count - 1, ev, pos);
					}
				}
			}
			while (lvc < lvwEvent->Items->Count) {//ύX̃CxgAύXÕXgr[̍sȂƂB
				lvwEvent->Items->RemoveAt(lvc);
			}
		}

	public:
		System::Void InsertBeat(int track, int index, SMF::BeatChange^ bc) {//q̑}
			SMF::Event^ ev = gcnew SMF::Event(bc);
			SMF::Position^ pos = gcnew SMF::Position(timeline->smf);
			pos->GlobalTick = ev->GlobalTick;
			int c = timeline->smf->Tracks[0]->Events->Count;
			for (int i = 0; i < c; i++) {
				SMF::Event^ dat_ev = safe_cast<SMF::Event^>(timeline->smf->Tracks[track]->Events[i]);
				if (dat_ev->GlobalTick > ev->GlobalTick) {
					Exec(gcnew Edit::InsertBeat(this, timeline, track, i, index, ev, bc, pos));
					break;
				}
			}
		}

	public:
		System::Void AddBeat(int track, SMF::BeatChange^ bc) {//q̒ǉ
			SMF::Event^ ev = gcnew SMF::Event(bc);
			SMF::Position^ pos = gcnew SMF::Position(timeline->smf);
			pos->GlobalTick = ev->GlobalTick;
			int c = timeline->smf->Tracks[0]->Events->Count;
			for (int i = 0; i < c; i++) {
				SMF::Event^ dat_ev = safe_cast<SMF::Event^>(timeline->smf->Tracks[track]->Events[i]);
				if (dat_ev->GlobalTick > ev->GlobalTick) {
					Exec(gcnew Edit::AddBeat(this, timeline, track, i, ev, bc, pos));
					break;
				}
			}
		}

	public:
		System::Void ReplaceBeat(int track, int index, SMF::BeatChange^ bc) {//q̒u
			SMF::Event^ ev = gcnew SMF::Event(bc);
			SMF::Position^ pos = gcnew SMF::Position(timeline->smf);
			pos->GlobalTick = ev->GlobalTick;
			int c = timeline->smf->Tracks[0]->Events->Count;
			for (int i = 0; i < c; i++) {
				SMF::Event^ dat_ev = safe_cast<SMF::Event^>(timeline->smf->Tracks[track]->Events[i]);
				if (dat_ev->GlobalTick == ev->GlobalTick && dat_ev->status == ev->status) {
					Exec(gcnew Edit::ReplaceBeat(this, timeline, track, i, index,
								dat_ev, safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[index]), ev, bc, pos));
					break;
				}
			}
		}

	private:
		System::Void SMFView_KeyDown(System::Object^  sender, System::Windows::Forms::KeyEventArgs^  e) {//V[gJbgL[̏
			if (menuItemDelete->Enabled && e->KeyCode == Keys::Delete) {//Del
				if (this->ActiveControl == lvwEvent) {//qEe|폜
					DeleteEvent();
				}
			//} else if (e->Control && e->KeyCode == Keys::Z) {//Ctrl+Z(ɖ߂)
			//	Undo();
			//} else if (e->Control && e->KeyCode == Keys::Y) {//Ctrl+Y(蒼)
			//	Redo();
			}
		}

	public:
		System::Void SMFView::UpdateSongLength() {//Ȓ̕ύX
			//e|`FWe[u̍Ō̗vfAMaxTick L^ĂgbNԍ
			//oAXgr[YgbÑGhIugbNtickB
			SMF::TempoChange^ tc = safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[timeline->smf->TempoChanges->Count - 1]);	
			SMF::Position^ pos = gcnew SMF::Position(timeline->smf);
			pos->GlobalTick = tc->Tick;
			System::String^ tr = tc->Track.ToString()->PadLeft(3, ' ');

			for (int i = 0; i < lvwEvent->Items->Count; i++ ) {
				if (lvwEvent->Items[i]->SubItems[0]->Text == tr) {//YgbN
					if (lvwEvent->Items[i]->SubItems[5]->Text == "2F") {//GhIugbN
						lvwEvent->Items[i]->SubItems[1]->Text = pos->Measure.ToString();
						lvwEvent->Items[i]->SubItems[2]->Text = pos->Beat.ToString();
						lvwEvent->Items[i]->SubItems[3]->Text = pos->Tick.ToString();
					}
				}
			}
		}

	};
}
