#pragma once

#include "Model.h"
#include "Pattern.h"
#include "TimeLine.h"
#include "SetBeatDialog.h"
#include "SetTempoDialog.h"
#include "PoseDataDialog.h"
#include "SelectedPatterns.h"
#include "Option\Option_Config.h"
#include "..\SMF\SMF.h"
#include "..\SMF\SMF_Position.h"
#include "..\Editor\Editor_Operation.h"
#include "PanCenter.h"

//ҏW
#include "Edit\Edit_DeleteModel.h"
#include "Edit\Edit_AddModel.h"
#include "Edit\Edit_ModelResize.h"
#include "Edit\Edit_ModelRename.h"
#include "Edit\Edit_PatternPaste.h"
#include "Edit\Edit_OpenVPD.h"
#include "Edit\Edit_PatternEdit.h"
#include "Edit\Edit_ReplaceVPD.h"
#include "Edit\Edit_PatternMove.h"
#include "Edit\Edit_PatternDelete.h"
#include "Edit\Edit_PatternCut.h"
#include "Edit\Edit_SetSongLength.h"
#include "Edit\Edit_PatternResize.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;


namespace MetMotMk {

	/// <summary>
	/// TimeLineForm ̊Tv
	///
	/// x: ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public ref class TimeLineForm : public System::Windows::Forms::Form
	{
	public:
		TimeLineForm(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^ R[hǉ܂
			//
			position = gcnew SMF::Position();
			selStartPosition = nullptr;
			selectedPatterns = gcnew SelectedPatterns();
			copyBuffer = gcnew PatternBuffer();
			this->MouseWheel += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::TimeLineForm_MouseWheel);
			this->menuItemDeleteModel->Enabled = false;
			this->menuItemModelNameChange->Enabled = false;
			this->menuItemEditDeleteModel->Enabled = false;
			this->menuItemEditModelNameChange->Enabled = false;
			this->menuItemOpenVPD->Enabled = true;
			this->menuItemFileOpenVPD->Enabled = false;
			this->menuItemMoveToTop->Enabled = false;
			this->menuItemMoveToBottom->Enabled = false;
			this->menuItemViewMoveToTop->Enabled = false;
			this->menuItemViewMoveToBottom->Enabled = false;
			this->menuItemDeletePattern->Enabled = false;
			this->menuItemEditDeletePattern->Enabled = false;
			this->menuItemSaveModelVMD->Enabled = false;
			this->menuItemFileSaveModelVMD->Enabled = false;
			this->menuItemEditPattern->Enabled = false;
			this->menuItemEditEditPattern->Enabled = false;
			this->menuItemCutPattern->Enabled = false;
			this->menuItemCopyPattern->Enabled = false;
			this->menuItemEditCutPattern->Enabled = false;
			this->menuItemEditCopyPattern->Enabled = false;
			this->menuItemPastePattern->Enabled = false;
			this->menuItemEditPastePattern->Enabled = false;
			picTimeLine->AllowDrop = true;//()IDEPictureBox̃vpeB[ɂ͂Ȃ̂ŁAŏFormAllowDropĝƎvB
			this->menuItemSelectPattern->Enabled = false;
			this->menuItemEditSelectPattern->Enabled = false;
			this->menuItemSelectAllPattern->Enabled = false;
			this->menuItemEditSelectAllPattern->Enabled = false;
			this->menuItemSelectPosePattern->Enabled = false;
			this->menuItemEditSelectPosePattern->Enabled = false;
			panCenter = gcnew PanCenter();
			panCenter->Width = 24;
			panCenter->Height = 24;
			panCenter->Left = -10000;
			panCenter->Top = -10000;
			panCenter->Show();
			//panCenter->Hide();

			//
			this->menuItemFileOpenPattern->Enabled = false;
			this->menuItemFileOpenVMD->Enabled = false;
			this->menuItemOpenPattern->Enabled = false;
			this->menuItemOpenVMD->Enabled = false;
			this->menuItemSelectMotionPattern->Enabled = false;
			this->menuItemSelectPatternContainer->Enabled = false;
			this->menuItemSelectLipPattern->Enabled = false;
			this->menuItemSelectMIDIPattern->Enabled = false;
			this->menuItemSelectShortcutPattern->Enabled = false;
			this->menuItemSelectCommentPattern->Enabled = false;
			this->menuItemEditSelectMotionPattern->Enabled = false;
			this->menuItemEditSelectPatternContainer->Enabled = false;
			this->menuItemEditSelectLipPattern->Enabled = false;
			this->menuItemEditSelectMIDIPattern->Enabled = false;
			this->menuItemEditSelectShortcutPattern->Enabled = false;
			this->menuItemEditSelectCommentPattern->Enabled = false;
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~TimeLineForm()
		{
			if (components)
			{
				delete components;
			}
		}

	public:
		property ToolStrip^ toolbar {
			ToolStrip^ get () {
				return toolTimeLine;
			}
		}

	private: System::Windows::Forms::ToolStrip^  toolTimeLine;
	private: System::Windows::Forms::ToolStripButton^  toolBtnZoomOut;
	private: System::Windows::Forms::ToolStripButton^  toolBtnZoomIn;
	protected: 


	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator18;
	private: System::Windows::Forms::ToolStripButton^  toolBtnGrid;
	private: System::Windows::Forms::ToolStripComboBox^  toolCmdGrid;
	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator19;
	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator20;











	public: Option::Config^ config;

	private: System::Void UpdateMIDIData(void);//MIDIf[^EBhE̍XV
	public: System::Void UpdateSongLength(void);//MIDIf[^EBhE̋Ȓ̕\̍XVB
	private: System::Void SaveMetronomeMotion(String^);//gm[̃[V̕ۑB
	private: System::Void SetStatusMessage(String^);//Xe[^Xo[ɃbZ[W\
	private: System::Void SetStatusProgressBarMax(int);//Xe[^Xo[̃vOXo[ɍőlݒ
	private: System::Void SetStatusProgressBar(int);//Xe[^Xo[̃vOXo[ɒlݒ
	private: System::Void SetStatusPosition(String^);//Xe[^Xo[ɎԈʒu\
	private: System::Void MergeToolbar();//c[o[̌
	private: System::Void RevertMergeToolbar();//c[o[̌̉
	private: System::Void Exec(Editor::Operation^);//ҏW̎s
	private: System::Void Undo();//ɖ߂
	private: System::Void Redo();//蒼
	private: System::Void ShowMe();//AvEBhEOɕ\B
	private: System::Void InsertTempo(int, int, SMF::TempoChange^);//e|̑}
	private: System::Void ReplaceTempo(int, int, SMF::TempoChange^);//e|̒u
	private: System::Void InsertBeat(int, int, SMF::BeatChange^);//q̑}
	private: System::Void AddBeat(int, SMF::BeatChange^);//q̒ǉ
	private: System::Void ReplaceBeat(int, int, SMF::BeatChange^);//q̒u
	private: PanCenter^ panCenter;//{^XN[̊_
	private: bool panScrollDrag;//true={^܂܂̃pXN[
	private: bool panScrollFree;//true={^NbNĂ痣čspXN[
	private: bool panScrollReady;//{^^C~OtrueɂāÃCxgDragFree𔻒肷B
	private: System::Drawing::Point panScrollCenterPoint;//pXN[̃Z^[
	private: PictureBox^ ScrollPic;//ModelRiseze()s̃sN`{bNX

	public: double PixelsPerTick;//1tick̃sNZ

	//private: SMF::File^ smf;//smfւ̎QƂ2Ƃ₱̂ō폜
	private: TimeLine^ timeline;
	public: SelectedPatterns^ selectedPatterns;//Iꂽp^[̃RNV(Selected͎ōXV)
	private: Pattern^ selectedPattern;//ŌɃNbNꂽp^[(NbNʁAIԂɂȂ邩IԂɂȂ邩́ÂƂ̏󋵂ɂ)
	private: int selectedPatternIndex;//ŌɃNbNꂽp^[̃CfbNX(炭̃p^[͑Iꂽf̃p^[ł͂)
	public: Model^ selectedModel;//ŌɑIꂽf
	public: int selectedModelIndex;//ŌɑIꂽf̃CfbNX
	private: int mouseDownY;//MouseDownYWl
	private: int mouseDY;//MouseDownƂ̃}EXYWƘgYW̍	
	private: int mouseMoveY;//MouseړYWl
	private: int mouseDownX;//MouseDownXWl
	private: int mouseDX;//MouseDownƂ̃}EXYWƘgXW̍	
	private: int mouseMoveX;//MouseړXWl
	private: bool mouseDown;//true=}EX{^ĂB
	private: bool patternMoving;//true=p^[hbOňړB
	private: bool beginMoving;//true=p^[ړJnAfalse=p^[ړJn
	private: bool selecting;//true=hbOŔ͈͑I𒆁B
	private: bool dding;//true=D&D̈ړB
	private: Point ddPoint;//D&D̍W
	private: SMF::Position^ ddPos;//D&D̎Ԉʒu
	private: SMF::Position^ position;//Iꂽʒu
	private: SMF::Position^ selStartPosition;//͈͑I𒆂̊Jnʒu
	private: int lastTimeLineMouseDownX;//ԍŋ߂Ƀ^CCŃ}EX{^XW
	private: int lastTimeLineMouseDownY;//ԍŋ߂Ƀ^CCŃ}EX{^XW
	private: PictureBox^ picResize;//fg̍ύXĂRg[pPictureBox
	private: PatternBuffer^ copyBuffer;
	private: array<String^>^ ddfiles;//hbOhbṽt@C̔z
	private: int ddScrollCount;//^C}[CxĝтɃJEg_E 0 ɂȂXN[JnB
	private: bool patternResizing;//true=p^[̃TCY

	private: System::Windows::Forms::PictureBox^  picTimeLine;
	private: System::Windows::Forms::PictureBox^  picModelName;

	private: System::Windows::Forms::PictureBox^  picGauge;

	private: System::Windows::Forms::SplitContainer^  splitParent;
	private: System::Windows::Forms::SplitContainer^  splitModelName;
	private: System::Windows::Forms::SplitContainer^  splitTimeLine;
	private: System::Windows::Forms::Button^  btnZoomMinus;
	private: System::Windows::Forms::Button^  btnZoomPlus;
	private: System::Windows::Forms::ContextMenuStrip^  menuModel;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemAddModel;
	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator1;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemModelNameChange;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemDeleteModel;
	private: System::Windows::Forms::TextBox^  txtInputName;
	private: System::Windows::Forms::TextBox^  txtPosition;

	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator2;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemSaveModelVMD;


	private: System::Windows::Forms::ContextMenuStrip^  menuPattern;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemOpenVPD;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemOpenVMD;


	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator3;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemCutPattern;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemCopyPattern;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemPastePattern;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemDeletePattern;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemOpenPattern;
	private: System::Windows::Forms::Label^  lblDeltaTime;
	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator4;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemInsertBeat;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemInsertTempo;
	private: System::Windows::Forms::MenuStrip^  menuTimeLine;

	private: System::Windows::Forms::ToolStripMenuItem^  menuItemFile;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemEdit;


	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator5;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemFileOpenVPD;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemFileOpenVMD;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemFileOpenPattern;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditAddModel;









	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator8;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditDeleteModel;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditModelNameChange;


	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator9;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditInsertBeat;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditInsertTempo;


	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator10;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditCutPattern;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditCopyPattern;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditPastePattern;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditDeletePattern;
private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator6;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemMoveToTop;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemView;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemViewMoveToTop;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemViewMoveToBottom;




private: System::Windows::Forms::ToolStripMenuItem^  menuItemMoveToBottom;
private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator7;
private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator11;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemFileSaveModelVMD;
private: System::Windows::Forms::SaveFileDialog^  saveFileDialog1;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditPattern;

private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator12;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditEditPattern;

private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator13;
private: System::Windows::Forms::Timer^  timerTimeLineDrag;
private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator14;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemSelectPattern;

private: System::Windows::Forms::ToolStripMenuItem^  menuItemSelectAllPattern;


private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator15;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemSelectPosePattern;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemSelectMotionPattern;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemSelectPatternContainer;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemSelectLipPattern;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemSelectMIDIPattern;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemSelectShortcutPattern;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemSelectCommentPattern;
private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator16;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditSelectPattern;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditSelectAllPattern;
private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator17;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditSelectPosePattern;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditSelectMotionPattern;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditSelectPatternContainer;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditSelectLipPattern;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditSelectMIDIPattern;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditSelectShortcutPattern;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditSelectCommentPattern;


	private: System::ComponentModel::IContainer^  components;









	protected: 

	protected: 

	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(TimeLineForm::typeid));
			this->picModelName = (gcnew System::Windows::Forms::PictureBox());
			this->menuModel = (gcnew System::Windows::Forms::ContextMenuStrip(this->components));
			this->menuItemAddModel = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator1 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemDeleteModel = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemModelNameChange = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator2 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemSaveModelVMD = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator14 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemSelectPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemSelectAllPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator15 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemSelectPosePattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemSelectMotionPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemSelectPatternContainer = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemSelectLipPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemSelectMIDIPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemSelectShortcutPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemSelectCommentPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->picTimeLine = (gcnew System::Windows::Forms::PictureBox());
			this->menuPattern = (gcnew System::Windows::Forms::ContextMenuStrip(this->components));
			this->menuItemEditPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator12 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemOpenVPD = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemOpenVMD = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemOpenPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator6 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemMoveToTop = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemMoveToBottom = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator4 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemInsertBeat = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemInsertTempo = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator3 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemCutPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemCopyPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemPastePattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemDeletePattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->picGauge = (gcnew System::Windows::Forms::PictureBox());
			this->splitParent = (gcnew System::Windows::Forms::SplitContainer());
			this->splitModelName = (gcnew System::Windows::Forms::SplitContainer());
			this->lblDeltaTime = (gcnew System::Windows::Forms::Label());
			this->txtPosition = (gcnew System::Windows::Forms::TextBox());
			this->btnZoomMinus = (gcnew System::Windows::Forms::Button());
			this->btnZoomPlus = (gcnew System::Windows::Forms::Button());
			this->txtInputName = (gcnew System::Windows::Forms::TextBox());
			this->splitTimeLine = (gcnew System::Windows::Forms::SplitContainer());
			this->menuTimeLine = (gcnew System::Windows::Forms::MenuStrip());
			this->menuItemFile = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator5 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemFileOpenVPD = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemFileOpenVMD = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemFileOpenPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator11 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemFileSaveModelVMD = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemEdit = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator20 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemEditEditPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator13 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemEditAddModel = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator8 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemEditDeleteModel = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemEditModelNameChange = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator9 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemEditInsertBeat = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemEditInsertTempo = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator10 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemEditCutPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemEditCopyPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemEditPastePattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemEditDeletePattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator16 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemEditSelectPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemEditSelectAllPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator17 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemEditSelectPosePattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemEditSelectMotionPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemEditSelectPatternContainer = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemEditSelectLipPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemEditSelectMIDIPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemEditSelectShortcutPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemEditSelectCommentPattern = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemView = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator7 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemViewMoveToTop = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemViewMoveToBottom = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->saveFileDialog1 = (gcnew System::Windows::Forms::SaveFileDialog());
			this->timerTimeLineDrag = (gcnew System::Windows::Forms::Timer(this->components));
			this->toolTimeLine = (gcnew System::Windows::Forms::ToolStrip());
			this->toolStripSeparator19 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->toolBtnZoomOut = (gcnew System::Windows::Forms::ToolStripButton());
			this->toolBtnZoomIn = (gcnew System::Windows::Forms::ToolStripButton());
			this->toolStripSeparator18 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->toolBtnGrid = (gcnew System::Windows::Forms::ToolStripButton());
			this->toolCmdGrid = (gcnew System::Windows::Forms::ToolStripComboBox());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->picModelName))->BeginInit();
			this->menuModel->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->picTimeLine))->BeginInit();
			this->menuPattern->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->picGauge))->BeginInit();
			this->splitParent->Panel1->SuspendLayout();
			this->splitParent->Panel2->SuspendLayout();
			this->splitParent->SuspendLayout();
			this->splitModelName->Panel1->SuspendLayout();
			this->splitModelName->Panel2->SuspendLayout();
			this->splitModelName->SuspendLayout();
			this->splitTimeLine->Panel1->SuspendLayout();
			this->splitTimeLine->Panel2->SuspendLayout();
			this->splitTimeLine->SuspendLayout();
			this->menuTimeLine->SuspendLayout();
			this->toolTimeLine->SuspendLayout();
			this->SuspendLayout();
			// 
			// picModelName
			// 
			this->picModelName->BackColor = System::Drawing::SystemColors::Window;
			this->picModelName->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->picModelName->ContextMenuStrip = this->menuModel;
			this->picModelName->Location = System::Drawing::Point(0, 0);
			this->picModelName->Name = L"picModelName";
			this->picModelName->Size = System::Drawing::Size(165, 165);
			this->picModelName->TabIndex = 0;
			this->picModelName->TabStop = false;
			this->picModelName->MouseMove += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::picModelName_MouseMove);
			this->picModelName->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::picModelName_MouseDown);
			this->picModelName->Paint += gcnew System::Windows::Forms::PaintEventHandler(this, &TimeLineForm::picModelName_Paint);
			this->picModelName->MouseUp += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::picModelName_MouseUp);
			// 
			// menuModel
			// 
			this->menuModel->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(8) {this->menuItemAddModel, 
				this->toolStripSeparator1, this->menuItemDeleteModel, this->menuItemModelNameChange, this->toolStripSeparator2, this->menuItemSaveModelVMD, 
				this->toolStripSeparator14, this->menuItemSelectPattern});
			this->menuModel->Name = L"menuModel";
			this->menuModel->Size = System::Drawing::Size(281, 132);
			this->menuModel->Opened += gcnew System::EventHandler(this, &TimeLineForm::menuModel_Opened);
			// 
			// menuItemAddModel
			// 
			this->menuItemAddModel->Name = L"menuItemAddModel";
			this->menuItemAddModel->ShortcutKeyDisplayString = L"Ctrl+M";
			this->menuItemAddModel->Size = System::Drawing::Size(280, 22);
			this->menuItemAddModel->Text = L"fǉ";
			this->menuItemAddModel->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemAddModel_Click);
			// 
			// toolStripSeparator1
			// 
			this->toolStripSeparator1->Name = L"toolStripSeparator1";
			this->toolStripSeparator1->Size = System::Drawing::Size(277, 6);
			// 
			// menuItemDeleteModel
			// 
			this->menuItemDeleteModel->Name = L"menuItemDeleteModel";
			this->menuItemDeleteModel->Size = System::Drawing::Size(280, 22);
			this->menuItemDeleteModel->Text = L"f폜";
			this->menuItemDeleteModel->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemDeleteModel_Click);
			// 
			// menuItemModelNameChange
			// 
			this->menuItemModelNameChange->Name = L"menuItemModelNameChange";
			this->menuItemModelNameChange->Size = System::Drawing::Size(280, 22);
			this->menuItemModelNameChange->Text = L"fύX";
			this->menuItemModelNameChange->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemModelNameChange_Click);
			// 
			// toolStripSeparator2
			// 
			this->toolStripSeparator2->Name = L"toolStripSeparator2";
			this->toolStripSeparator2->Size = System::Drawing::Size(277, 6);
			// 
			// menuItemSaveModelVMD
			// 
			this->menuItemSaveModelVMD->Name = L"menuItemSaveModelVMD";
			this->menuItemSaveModelVMD->Size = System::Drawing::Size(280, 22);
			this->menuItemSaveModelVMD->Text = L"̃f̃[Vf[^ۑ...";
			this->menuItemSaveModelVMD->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemSaveModelVMD_Click);
			// 
			// toolStripSeparator14
			// 
			this->toolStripSeparator14->Name = L"toolStripSeparator14";
			this->toolStripSeparator14->Size = System::Drawing::Size(277, 6);
			// 
			// menuItemSelectPattern
			// 
			this->menuItemSelectPattern->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(9) {this->menuItemSelectAllPattern, 
				this->toolStripSeparator15, this->menuItemSelectPosePattern, this->menuItemSelectMotionPattern, this->menuItemSelectPatternContainer, 
				this->menuItemSelectLipPattern, this->menuItemSelectMIDIPattern, this->menuItemSelectShortcutPattern, this->menuItemSelectCommentPattern});
			this->menuItemSelectPattern->Name = L"menuItemSelectPattern";
			this->menuItemSelectPattern->Size = System::Drawing::Size(280, 22);
			this->menuItemSelectPattern->Text = L"̃f̃p^[ׂđI";
			// 
			// menuItemSelectAllPattern
			// 
			this->menuItemSelectAllPattern->Name = L"menuItemSelectAllPattern";
			this->menuItemSelectAllPattern->ShortcutKeyDisplayString = L"Ctrl+A";
			this->menuItemSelectAllPattern->Size = System::Drawing::Size(219, 22);
			this->menuItemSelectAllPattern->Text = L"ׂẴp^[";
			this->menuItemSelectAllPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemSelectAllPattern_Click);
			// 
			// toolStripSeparator15
			// 
			this->toolStripSeparator15->Name = L"toolStripSeparator15";
			this->toolStripSeparator15->Size = System::Drawing::Size(216, 6);
			// 
			// menuItemSelectPosePattern
			// 
			this->menuItemSelectPosePattern->Name = L"menuItemSelectPosePattern";
			this->menuItemSelectPosePattern->Size = System::Drawing::Size(219, 22);
			this->menuItemSelectPosePattern->Text = L"|[Yp^[";
			this->menuItemSelectPosePattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemSelectPosePattern_Click);
			// 
			// menuItemSelectMotionPattern
			// 
			this->menuItemSelectMotionPattern->Name = L"menuItemSelectMotionPattern";
			this->menuItemSelectMotionPattern->Size = System::Drawing::Size(219, 22);
			this->menuItemSelectMotionPattern->Text = L"[Vp^[";
			this->menuItemSelectMotionPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemSelectMotionPattern_Click);
			// 
			// menuItemSelectPatternContainer
			// 
			this->menuItemSelectPatternContainer->Name = L"menuItemSelectPatternContainer";
			this->menuItemSelectPatternContainer->Size = System::Drawing::Size(219, 22);
			this->menuItemSelectPatternContainer->Text = L"p^[";
			this->menuItemSelectPatternContainer->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemSelectPatternContainer_Click);
			// 
			// menuItemSelectLipPattern
			// 
			this->menuItemSelectLipPattern->Name = L"menuItemSelectLipPattern";
			this->menuItemSelectLipPattern->Size = System::Drawing::Size(219, 22);
			this->menuItemSelectLipPattern->Text = L"bvp^[";
			this->menuItemSelectLipPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemSelectLipPattern_Click);
			// 
			// menuItemSelectMIDIPattern
			// 
			this->menuItemSelectMIDIPattern->Name = L"menuItemSelectMIDIPattern";
			this->menuItemSelectMIDIPattern->Size = System::Drawing::Size(219, 22);
			this->menuItemSelectMIDIPattern->Text = L"tp^[";
			this->menuItemSelectMIDIPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemSelectMIDIPattern_Click);
			// 
			// menuItemSelectShortcutPattern
			// 
			this->menuItemSelectShortcutPattern->Name = L"menuItemSelectShortcutPattern";
			this->menuItemSelectShortcutPattern->Size = System::Drawing::Size(219, 22);
			this->menuItemSelectShortcutPattern->Text = L"V[gJbg";
			this->menuItemSelectShortcutPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemSelectShortcutPattern_Click);
			// 
			// menuItemSelectCommentPattern
			// 
			this->menuItemSelectCommentPattern->Name = L"menuItemSelectCommentPattern";
			this->menuItemSelectCommentPattern->Size = System::Drawing::Size(219, 22);
			this->menuItemSelectCommentPattern->Text = L"Rg";
			this->menuItemSelectCommentPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemSelectCommentPattern_Click);
			// 
			// picTimeLine
			// 
			this->picTimeLine->BackColor = System::Drawing::SystemColors::Window;
			this->picTimeLine->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->picTimeLine->ContextMenuStrip = this->menuPattern;
			this->picTimeLine->Location = System::Drawing::Point(0, 0);
			this->picTimeLine->Name = L"picTimeLine";
			this->picTimeLine->Size = System::Drawing::Size(478, 168);
			this->picTimeLine->TabIndex = 1;
			this->picTimeLine->TabStop = false;
			this->picTimeLine->DragOver += gcnew System::Windows::Forms::DragEventHandler(this, &TimeLineForm::picTimeLine_DragOver);
			this->picTimeLine->MouseMove += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::picTimeLine_MouseMove);
			this->picTimeLine->DragDrop += gcnew System::Windows::Forms::DragEventHandler(this, &TimeLineForm::picTimeLine_DragDrop);
			this->picTimeLine->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::picTimeLine_MouseDown);
			this->picTimeLine->Paint += gcnew System::Windows::Forms::PaintEventHandler(this, &TimeLineForm::picTimeLine_Paint);
			this->picTimeLine->DragLeave += gcnew System::EventHandler(this, &TimeLineForm::picTimeLine_DragLeave);
			this->picTimeLine->MouseUp += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::picTimeLine_MouseUp);
			this->picTimeLine->DragEnter += gcnew System::Windows::Forms::DragEventHandler(this, &TimeLineForm::picTimeLine_DragEnter);
			// 
			// menuPattern
			// 
			this->menuPattern->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(16) {this->menuItemEditPattern, 
				this->toolStripSeparator12, this->menuItemOpenVPD, this->menuItemOpenVMD, this->menuItemOpenPattern, this->toolStripSeparator6, 
				this->menuItemMoveToTop, this->menuItemMoveToBottom, this->toolStripSeparator4, this->menuItemInsertBeat, this->menuItemInsertTempo, 
				this->toolStripSeparator3, this->menuItemCutPattern, this->menuItemCopyPattern, this->menuItemPastePattern, this->menuItemDeletePattern});
			this->menuPattern->Name = L"menuPattern";
			this->menuPattern->Size = System::Drawing::Size(209, 292);
			// 
			// menuItemEditPattern
			// 
			this->menuItemEditPattern->Name = L"menuItemEditPattern";
			this->menuItemEditPattern->Size = System::Drawing::Size(208, 22);
			this->menuItemEditPattern->Text = L"p^[ҏW(&E)";
			this->menuItemEditPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditPattern_Click);
			// 
			// toolStripSeparator12
			// 
			this->toolStripSeparator12->Name = L"toolStripSeparator12";
			this->toolStripSeparator12->Size = System::Drawing::Size(205, 6);
			// 
			// menuItemOpenVPD
			// 
			this->menuItemOpenVPD->Name = L"menuItemOpenVPD";
			this->menuItemOpenVPD->Size = System::Drawing::Size(208, 22);
			this->menuItemOpenVPD->Text = L"|[Yf[^Ǎ...";
			this->menuItemOpenVPD->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemOpenVPD_Click);
			// 
			// menuItemOpenVMD
			// 
			this->menuItemOpenVMD->Name = L"menuItemOpenVMD";
			this->menuItemOpenVMD->Size = System::Drawing::Size(208, 22);
			this->menuItemOpenVMD->Text = L"[Vf[^Ǎ...";
			// 
			// menuItemOpenPattern
			// 
			this->menuItemOpenPattern->Name = L"menuItemOpenPattern";
			this->menuItemOpenPattern->Size = System::Drawing::Size(208, 22);
			this->menuItemOpenPattern->Text = L"p^[f[^Ǎ...";
			// 
			// toolStripSeparator6
			// 
			this->toolStripSeparator6->Name = L"toolStripSeparator6";
			this->toolStripSeparator6->Size = System::Drawing::Size(205, 6);
			// 
			// menuItemMoveToTop
			// 
			this->menuItemMoveToTop->Name = L"menuItemMoveToTop";
			this->menuItemMoveToTop->Size = System::Drawing::Size(208, 22);
			this->menuItemMoveToTop->Text = L"őOʂֈړ(&B)";
			this->menuItemMoveToTop->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemMoveToTop_Click);
			// 
			// menuItemMoveToBottom
			// 
			this->menuItemMoveToBottom->Name = L"menuItemMoveToBottom";
			this->menuItemMoveToBottom->Size = System::Drawing::Size(208, 22);
			this->menuItemMoveToBottom->Text = L"Ŕwʂֈړ(&S)";
			this->menuItemMoveToBottom->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemMoveToBottom_Click);
			// 
			// toolStripSeparator4
			// 
			this->toolStripSeparator4->Name = L"toolStripSeparator4";
			this->toolStripSeparator4->Size = System::Drawing::Size(205, 6);
			// 
			// menuItemInsertBeat
			// 
			this->menuItemInsertBeat->Name = L"menuItemInsertBeat";
			this->menuItemInsertBeat->Size = System::Drawing::Size(208, 22);
			this->menuItemInsertBeat->Text = L"q̑}(&B)...";
			this->menuItemInsertBeat->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemInsertBeat_Click);
			// 
			// menuItemInsertTempo
			// 
			this->menuItemInsertTempo->Name = L"menuItemInsertTempo";
			this->menuItemInsertTempo->Size = System::Drawing::Size(208, 22);
			this->menuItemInsertTempo->Text = L"e|̑}(&M)...";
			this->menuItemInsertTempo->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemInsertTempo_Click);
			// 
			// toolStripSeparator3
			// 
			this->toolStripSeparator3->Name = L"toolStripSeparator3";
			this->toolStripSeparator3->Size = System::Drawing::Size(205, 6);
			// 
			// menuItemCutPattern
			// 
			this->menuItemCutPattern->Name = L"menuItemCutPattern";
			this->menuItemCutPattern->ShortcutKeyDisplayString = L"Ctrl+X";
			this->menuItemCutPattern->Size = System::Drawing::Size(208, 22);
			this->menuItemCutPattern->Text = L"Jbg(&T)";
			this->menuItemCutPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemCutPattern_Click);
			// 
			// menuItemCopyPattern
			// 
			this->menuItemCopyPattern->Name = L"menuItemCopyPattern";
			this->menuItemCopyPattern->ShortcutKeyDisplayString = L"Ctrl+C";
			this->menuItemCopyPattern->Size = System::Drawing::Size(208, 22);
			this->menuItemCopyPattern->Text = L"Rs[(&C)";
			this->menuItemCopyPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemCopyPattern_Click);
			// 
			// menuItemPastePattern
			// 
			this->menuItemPastePattern->Name = L"menuItemPastePattern";
			this->menuItemPastePattern->ShortcutKeyDisplayString = L"Ctrl+V";
			this->menuItemPastePattern->Size = System::Drawing::Size(208, 22);
			this->menuItemPastePattern->Text = L"y[Xg(&P)";
			this->menuItemPastePattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemPastePattern_Click);
			// 
			// menuItemDeletePattern
			// 
			this->menuItemDeletePattern->Name = L"menuItemDeletePattern";
			this->menuItemDeletePattern->ShortcutKeyDisplayString = L"Del";
			this->menuItemDeletePattern->Size = System::Drawing::Size(208, 22);
			this->menuItemDeletePattern->Text = L"폜(&D)";
			this->menuItemDeletePattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemDeletePattern_Click);
			// 
			// picGauge
			// 
			this->picGauge->BackColor = System::Drawing::SystemColors::Window;
			this->picGauge->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->picGauge->Location = System::Drawing::Point(-2, 1);
			this->picGauge->Name = L"picGauge";
			this->picGauge->Size = System::Drawing::Size(480, 23);
			this->picGauge->TabIndex = 0;
			this->picGauge->TabStop = false;
			this->picGauge->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::picGauge_MouseDown);
			this->picGauge->Paint += gcnew System::Windows::Forms::PaintEventHandler(this, &TimeLineForm::picGauge_Paint);
			// 
			// splitParent
			// 
			this->splitParent->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->splitParent->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->splitParent->FixedPanel = System::Windows::Forms::FixedPanel::Panel1;
			this->splitParent->IsSplitterFixed = true;
			this->splitParent->Location = System::Drawing::Point(0, 0);
			this->splitParent->Name = L"splitParent";
			// 
			// splitParent.Panel1
			// 
			this->splitParent->Panel1->Controls->Add(this->splitModelName);
			// 
			// splitParent.Panel2
			// 
			this->splitParent->Panel2->Controls->Add(this->splitTimeLine);
			this->splitParent->Size = System::Drawing::Size(736, 290);
			this->splitParent->SplitterDistance = 171;
			this->splitParent->TabIndex = 1;
			this->splitParent->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::splitParent_MouseDown);
			// 
			// splitModelName
			// 
			this->splitModelName->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->splitModelName->Dock = System::Windows::Forms::DockStyle::Fill;
			this->splitModelName->FixedPanel = System::Windows::Forms::FixedPanel::Panel1;
			this->splitModelName->IsSplitterFixed = true;
			this->splitModelName->Location = System::Drawing::Point(0, 0);
			this->splitModelName->Margin = System::Windows::Forms::Padding(0);
			this->splitModelName->Name = L"splitModelName";
			this->splitModelName->Orientation = System::Windows::Forms::Orientation::Horizontal;
			// 
			// splitModelName.Panel1
			// 
			this->splitModelName->Panel1->Controls->Add(this->lblDeltaTime);
			this->splitModelName->Panel1->Controls->Add(this->txtPosition);
			this->splitModelName->Panel1->Controls->Add(this->btnZoomMinus);
			this->splitModelName->Panel1->Controls->Add(this->btnZoomPlus);
			this->splitModelName->Panel1->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::splitModelName_Panel1_MouseDown);
			// 
			// splitModelName.Panel2
			// 
			this->splitModelName->Panel2->ContextMenuStrip = this->menuModel;
			this->splitModelName->Panel2->Controls->Add(this->txtInputName);
			this->splitModelName->Panel2->Controls->Add(this->picModelName);
			this->splitModelName->Panel2->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::splitModelName_Panel2_MouseDown);
			this->splitModelName->Size = System::Drawing::Size(171, 290);
			this->splitModelName->SplitterDistance = 25;
			this->splitModelName->TabIndex = 2;
			this->splitModelName->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::splitModelName_MouseDown);
			// 
			// lblDeltaTime
			// 
			this->lblDeltaTime->AutoSize = true;
			this->lblDeltaTime->Location = System::Drawing::Point(80, 5);
			this->lblDeltaTime->Name = L"lblDeltaTime";
			this->lblDeltaTime->Size = System::Drawing::Size(29, 12);
			this->lblDeltaTime->TabIndex = 3;
			this->lblDeltaTime->Text = L"/240";
			this->lblDeltaTime->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::lblDeltaTime_MouseDown);
			// 
			// txtPosition
			// 
			this->txtPosition->Location = System::Drawing::Point(0, 1);
			this->txtPosition->MaxLength = 10;
			this->txtPosition->Name = L"txtPosition";
			this->txtPosition->Size = System::Drawing::Size(78, 19);
			this->txtPosition->TabIndex = 3;
			this->txtPosition->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->txtPosition->KeyDown += gcnew System::Windows::Forms::KeyEventHandler(this, &TimeLineForm::txtPosition_KeyDown);
			this->txtPosition->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::txtPosition_MouseDown);
			this->txtPosition->KeyPress += gcnew System::Windows::Forms::KeyPressEventHandler(this, &TimeLineForm::txtPosition_KeyPress);
			this->txtPosition->Enter += gcnew System::EventHandler(this, &TimeLineForm::txtPosition_Enter);
			// 
			// btnZoomMinus
			// 
			this->btnZoomMinus->Anchor = static_cast<System::Windows::Forms::AnchorStyles>(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->btnZoomMinus->Location = System::Drawing::Point(122, -2);
			this->btnZoomMinus->Name = L"btnZoomMinus";
			this->btnZoomMinus->Size = System::Drawing::Size(25, 24);
			this->btnZoomMinus->TabIndex = 4;
			this->btnZoomMinus->Text = L"-";
			this->btnZoomMinus->UseVisualStyleBackColor = true;
			this->btnZoomMinus->Visible = false;
			this->btnZoomMinus->Click += gcnew System::EventHandler(this, &TimeLineForm::btnZoomMinus_Click);
			// 
			// btnZoomPlus
			// 
			this->btnZoomPlus->Anchor = static_cast<System::Windows::Forms::AnchorStyles>(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->btnZoomPlus->Location = System::Drawing::Point(144, -2);
			this->btnZoomPlus->Name = L"btnZoomPlus";
			this->btnZoomPlus->Size = System::Drawing::Size(25, 24);
			this->btnZoomPlus->TabIndex = 5;
			this->btnZoomPlus->Text = L"+";
			this->btnZoomPlus->UseVisualStyleBackColor = true;
			this->btnZoomPlus->Visible = false;
			this->btnZoomPlus->Click += gcnew System::EventHandler(this, &TimeLineForm::btnZoomPlus_Click);
			// 
			// txtInputName
			// 
			this->txtInputName->Anchor = System::Windows::Forms::AnchorStyles::None;
			this->txtInputName->BorderStyle = System::Windows::Forms::BorderStyle::None;
			this->txtInputName->Enabled = false;
			this->txtInputName->Location = System::Drawing::Point(10, 184);
			this->txtInputName->MaxLength = 20;
			this->txtInputName->Name = L"txtInputName";
			this->txtInputName->Size = System::Drawing::Size(137, 12);
			this->txtInputName->TabIndex = 6;
			this->txtInputName->Visible = false;
			this->txtInputName->WordWrap = false;
			this->txtInputName->Leave += gcnew System::EventHandler(this, &TimeLineForm::txtInputName_Leave);
			this->txtInputName->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::txtInputName_MouseDown);
			this->txtInputName->KeyPress += gcnew System::Windows::Forms::KeyPressEventHandler(this, &TimeLineForm::txtInputName_KeyPress);
			// 
			// splitTimeLine
			// 
			this->splitTimeLine->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->splitTimeLine->Dock = System::Windows::Forms::DockStyle::Fill;
			this->splitTimeLine->FixedPanel = System::Windows::Forms::FixedPanel::Panel1;
			this->splitTimeLine->IsSplitterFixed = true;
			this->splitTimeLine->Location = System::Drawing::Point(0, 0);
			this->splitTimeLine->Margin = System::Windows::Forms::Padding(0);
			this->splitTimeLine->Name = L"splitTimeLine";
			this->splitTimeLine->Orientation = System::Windows::Forms::Orientation::Horizontal;
			// 
			// splitTimeLine.Panel1
			// 
			this->splitTimeLine->Panel1->Controls->Add(this->picGauge);
			this->splitTimeLine->Panel1->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::splitTimeLine_Panel1_MouseDown);
			// 
			// splitTimeLine.Panel2
			// 
			this->splitTimeLine->Panel2->AutoScroll = true;
			this->splitTimeLine->Panel2->BackColor = System::Drawing::Color::Transparent;
			this->splitTimeLine->Panel2->Controls->Add(this->picTimeLine);
			this->splitTimeLine->Panel2->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &TimeLineForm::splitTimeLine_Panel2_Scroll);
			this->splitTimeLine->Panel2->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::splitTimeLine_Panel2_MouseDown);
			this->splitTimeLine->Size = System::Drawing::Size(561, 290);
			this->splitTimeLine->SplitterDistance = 25;
			this->splitTimeLine->TabIndex = 0;
			this->splitTimeLine->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::splitTimeLine_MouseDown);
			// 
			// menuTimeLine
			// 
			this->menuTimeLine->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(3) {this->menuItemFile, this->menuItemEdit, 
				this->menuItemView});
			this->menuTimeLine->Location = System::Drawing::Point(0, 0);
			this->menuTimeLine->Name = L"menuTimeLine";
			this->menuTimeLine->Size = System::Drawing::Size(736, 26);
			this->menuTimeLine->TabIndex = 5;
			this->menuTimeLine->Text = L"menuStrip1";
			this->menuTimeLine->Visible = false;
			this->menuTimeLine->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::menuTimeLine_MouseDown);
			// 
			// menuItemFile
			// 
			this->menuItemFile->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(6) {this->toolStripSeparator5, 
				this->menuItemFileOpenVPD, this->menuItemFileOpenVMD, this->menuItemFileOpenPattern, this->toolStripSeparator11, this->menuItemFileSaveModelVMD});
			this->menuItemFile->MergeAction = System::Windows::Forms::MergeAction::MatchOnly;
			this->menuItemFile->MergeIndex = 0;
			this->menuItemFile->Name = L"menuItemFile";
			this->menuItemFile->Size = System::Drawing::Size(85, 22);
			this->menuItemFile->Text = L"t@C(&F)";
			// 
			// toolStripSeparator5
			// 
			this->toolStripSeparator5->Name = L"toolStripSeparator5";
			this->toolStripSeparator5->Size = System::Drawing::Size(289, 6);
			// 
			// menuItemFileOpenVPD
			// 
			this->menuItemFileOpenVPD->Name = L"menuItemFileOpenVPD";
			this->menuItemFileOpenVPD->Size = System::Drawing::Size(292, 22);
			this->menuItemFileOpenVPD->Text = L"|[Yf[^Ǎ...";
			this->menuItemFileOpenVPD->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemFileOpenVPD_Click);
			// 
			// menuItemFileOpenVMD
			// 
			this->menuItemFileOpenVMD->Name = L"menuItemFileOpenVMD";
			this->menuItemFileOpenVMD->Size = System::Drawing::Size(292, 22);
			this->menuItemFileOpenVMD->Text = L"[Vf[^Ǎ...";
			// 
			// menuItemFileOpenPattern
			// 
			this->menuItemFileOpenPattern->Name = L"menuItemFileOpenPattern";
			this->menuItemFileOpenPattern->Size = System::Drawing::Size(292, 22);
			this->menuItemFileOpenPattern->Text = L"p^[f[^Ǎ...";
			// 
			// toolStripSeparator11
			// 
			this->toolStripSeparator11->Name = L"toolStripSeparator11";
			this->toolStripSeparator11->Size = System::Drawing::Size(289, 6);
			// 
			// menuItemFileSaveModelVMD
			// 
			this->menuItemFileSaveModelVMD->Name = L"menuItemFileSaveModelVMD";
			this->menuItemFileSaveModelVMD->Size = System::Drawing::Size(292, 22);
			this->menuItemFileSaveModelVMD->Text = L"If̃[Vf[^ۑ...";
			this->menuItemFileSaveModelVMD->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemFileSaveModelVMD_Click);
			// 
			// menuItemEdit
			// 
			this->menuItemEdit->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(17) {this->toolStripSeparator20, 
				this->menuItemEditEditPattern, this->toolStripSeparator13, this->menuItemEditAddModel, this->toolStripSeparator8, this->menuItemEditDeleteModel, 
				this->menuItemEditModelNameChange, this->toolStripSeparator9, this->menuItemEditInsertBeat, this->menuItemEditInsertTempo, this->toolStripSeparator10, 
				this->menuItemEditCutPattern, this->menuItemEditCopyPattern, this->menuItemEditPastePattern, this->menuItemEditDeletePattern, 
				this->toolStripSeparator16, this->menuItemEditSelectPattern});
			this->menuItemEdit->MergeAction = System::Windows::Forms::MergeAction::MatchOnly;
			this->menuItemEdit->MergeIndex = 1;
			this->menuItemEdit->Name = L"menuItemEdit";
			this->menuItemEdit->Size = System::Drawing::Size(61, 22);
			this->menuItemEdit->Text = L"ҏW(&E)";
			// 
			// toolStripSeparator20
			// 
			this->toolStripSeparator20->Name = L"toolStripSeparator20";
			this->toolStripSeparator20->Size = System::Drawing::Size(265, 6);
			// 
			// menuItemEditEditPattern
			// 
			this->menuItemEditEditPattern->Name = L"menuItemEditEditPattern";
			this->menuItemEditEditPattern->Size = System::Drawing::Size(268, 22);
			this->menuItemEditEditPattern->Text = L"p^[ҏW(&E)";
			this->menuItemEditEditPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditEditPattern_Click);
			// 
			// toolStripSeparator13
			// 
			this->toolStripSeparator13->Name = L"toolStripSeparator13";
			this->toolStripSeparator13->Size = System::Drawing::Size(265, 6);
			// 
			// menuItemEditAddModel
			// 
			this->menuItemEditAddModel->Name = L"menuItemEditAddModel";
			this->menuItemEditAddModel->ShortcutKeyDisplayString = L"Ctrl+M";
			this->menuItemEditAddModel->Size = System::Drawing::Size(268, 22);
			this->menuItemEditAddModel->Text = L"fǉ";
			this->menuItemEditAddModel->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditAddModel_Click);
			// 
			// toolStripSeparator8
			// 
			this->toolStripSeparator8->Name = L"toolStripSeparator8";
			this->toolStripSeparator8->Size = System::Drawing::Size(265, 6);
			// 
			// menuItemEditDeleteModel
			// 
			this->menuItemEditDeleteModel->Name = L"menuItemEditDeleteModel";
			this->menuItemEditDeleteModel->Size = System::Drawing::Size(268, 22);
			this->menuItemEditDeleteModel->Text = L"f폜";
			this->menuItemEditDeleteModel->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditDeleteModel_Click);
			// 
			// menuItemEditModelNameChange
			// 
			this->menuItemEditModelNameChange->Name = L"menuItemEditModelNameChange";
			this->menuItemEditModelNameChange->Size = System::Drawing::Size(268, 22);
			this->menuItemEditModelNameChange->Text = L"fύX";
			this->menuItemEditModelNameChange->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditModelNameChange_Click);
			// 
			// toolStripSeparator9
			// 
			this->toolStripSeparator9->Name = L"toolStripSeparator9";
			this->toolStripSeparator9->Size = System::Drawing::Size(265, 6);
			// 
			// menuItemEditInsertBeat
			// 
			this->menuItemEditInsertBeat->Name = L"menuItemEditInsertBeat";
			this->menuItemEditInsertBeat->Size = System::Drawing::Size(268, 22);
			this->menuItemEditInsertBeat->Text = L"q}...";
			this->menuItemEditInsertBeat->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditInsertBeat_Click);
			// 
			// menuItemEditInsertTempo
			// 
			this->menuItemEditInsertTempo->Name = L"menuItemEditInsertTempo";
			this->menuItemEditInsertTempo->Size = System::Drawing::Size(268, 22);
			this->menuItemEditInsertTempo->Text = L"e|}...";
			this->menuItemEditInsertTempo->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditInsertTempo_Click);
			// 
			// toolStripSeparator10
			// 
			this->toolStripSeparator10->Name = L"toolStripSeparator10";
			this->toolStripSeparator10->Size = System::Drawing::Size(265, 6);
			// 
			// menuItemEditCutPattern
			// 
			this->menuItemEditCutPattern->Name = L"menuItemEditCutPattern";
			this->menuItemEditCutPattern->ShortcutKeyDisplayString = L"Ctrl+X";
			this->menuItemEditCutPattern->Size = System::Drawing::Size(268, 22);
			this->menuItemEditCutPattern->Text = L"Jbg(&T)";
			this->menuItemEditCutPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditCutPattern_Click);
			// 
			// menuItemEditCopyPattern
			// 
			this->menuItemEditCopyPattern->Name = L"menuItemEditCopyPattern";
			this->menuItemEditCopyPattern->ShortcutKeyDisplayString = L"Ctrl+C";
			this->menuItemEditCopyPattern->Size = System::Drawing::Size(268, 22);
			this->menuItemEditCopyPattern->Text = L"Rs[(&C)";
			this->menuItemEditCopyPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditCopyPattern_Click);
			// 
			// menuItemEditPastePattern
			// 
			this->menuItemEditPastePattern->Name = L"menuItemEditPastePattern";
			this->menuItemEditPastePattern->ShortcutKeyDisplayString = L"Ctrl+V";
			this->menuItemEditPastePattern->Size = System::Drawing::Size(268, 22);
			this->menuItemEditPastePattern->Text = L"y[Xg(&P)";
			this->menuItemEditPastePattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditPastePattern_Click);
			// 
			// menuItemEditDeletePattern
			// 
			this->menuItemEditDeletePattern->Name = L"menuItemEditDeletePattern";
			this->menuItemEditDeletePattern->ShortcutKeyDisplayString = L"Del";
			this->menuItemEditDeletePattern->Size = System::Drawing::Size(268, 22);
			this->menuItemEditDeletePattern->Text = L"폜(&D)";
			this->menuItemEditDeletePattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditDeletePattern_Click);
			// 
			// toolStripSeparator16
			// 
			this->toolStripSeparator16->Name = L"toolStripSeparator16";
			this->toolStripSeparator16->Size = System::Drawing::Size(265, 6);
			// 
			// menuItemEditSelectPattern
			// 
			this->menuItemEditSelectPattern->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(9) {this->menuItemEditSelectAllPattern, 
				this->toolStripSeparator17, this->menuItemEditSelectPosePattern, this->menuItemEditSelectMotionPattern, this->menuItemEditSelectPatternContainer, 
				this->menuItemEditSelectLipPattern, this->menuItemEditSelectMIDIPattern, this->menuItemEditSelectShortcutPattern, this->menuItemEditSelectCommentPattern});
			this->menuItemEditSelectPattern->Name = L"menuItemEditSelectPattern";
			this->menuItemEditSelectPattern->Size = System::Drawing::Size(268, 22);
			this->menuItemEditSelectPattern->Text = L"If̃p^[ׂđI";
			// 
			// menuItemEditSelectAllPattern
			// 
			this->menuItemEditSelectAllPattern->Name = L"menuItemEditSelectAllPattern";
			this->menuItemEditSelectAllPattern->ShortcutKeyDisplayString = L"Ctrl+A";
			this->menuItemEditSelectAllPattern->Size = System::Drawing::Size(219, 22);
			this->menuItemEditSelectAllPattern->Text = L"ׂẴp^[";
			this->menuItemEditSelectAllPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditSelectAllPattern_Click);
			// 
			// toolStripSeparator17
			// 
			this->toolStripSeparator17->Name = L"toolStripSeparator17";
			this->toolStripSeparator17->Size = System::Drawing::Size(216, 6);
			// 
			// menuItemEditSelectPosePattern
			// 
			this->menuItemEditSelectPosePattern->Name = L"menuItemEditSelectPosePattern";
			this->menuItemEditSelectPosePattern->Size = System::Drawing::Size(219, 22);
			this->menuItemEditSelectPosePattern->Text = L"|[Yp^[";
			this->menuItemEditSelectPosePattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditSelectPosePattern_Click);
			// 
			// menuItemEditSelectMotionPattern
			// 
			this->menuItemEditSelectMotionPattern->Name = L"menuItemEditSelectMotionPattern";
			this->menuItemEditSelectMotionPattern->Size = System::Drawing::Size(219, 22);
			this->menuItemEditSelectMotionPattern->Text = L"[Vp^[";
			this->menuItemEditSelectMotionPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditSelectMotionPattern_Click);
			// 
			// menuItemEditSelectPatternContainer
			// 
			this->menuItemEditSelectPatternContainer->Name = L"menuItemEditSelectPatternContainer";
			this->menuItemEditSelectPatternContainer->Size = System::Drawing::Size(219, 22);
			this->menuItemEditSelectPatternContainer->Text = L"p^[";
			this->menuItemEditSelectPatternContainer->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditSelectPatternContainer_Click);
			// 
			// menuItemEditSelectLipPattern
			// 
			this->menuItemEditSelectLipPattern->Name = L"menuItemEditSelectLipPattern";
			this->menuItemEditSelectLipPattern->Size = System::Drawing::Size(219, 22);
			this->menuItemEditSelectLipPattern->Text = L"bvp^[";
			this->menuItemEditSelectLipPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditSelectLipPattern_Click);
			// 
			// menuItemEditSelectMIDIPattern
			// 
			this->menuItemEditSelectMIDIPattern->Name = L"menuItemEditSelectMIDIPattern";
			this->menuItemEditSelectMIDIPattern->Size = System::Drawing::Size(219, 22);
			this->menuItemEditSelectMIDIPattern->Text = L"tp^[";
			this->menuItemEditSelectMIDIPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditSelectMIDIPattern_Click);
			// 
			// menuItemEditSelectShortcutPattern
			// 
			this->menuItemEditSelectShortcutPattern->Name = L"menuItemEditSelectShortcutPattern";
			this->menuItemEditSelectShortcutPattern->Size = System::Drawing::Size(219, 22);
			this->menuItemEditSelectShortcutPattern->Text = L"V[gJbg";
			this->menuItemEditSelectShortcutPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditSelectShortcutPattern_Click);
			// 
			// menuItemEditSelectCommentPattern
			// 
			this->menuItemEditSelectCommentPattern->Name = L"menuItemEditSelectCommentPattern";
			this->menuItemEditSelectCommentPattern->Size = System::Drawing::Size(219, 22);
			this->menuItemEditSelectCommentPattern->Text = L"Rg";
			this->menuItemEditSelectCommentPattern->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemEditSelectCommentPattern_Click);
			// 
			// menuItemView
			// 
			this->menuItemView->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(3) {this->toolStripSeparator7, 
				this->menuItemViewMoveToTop, this->menuItemViewMoveToBottom});
			this->menuItemView->MergeAction = System::Windows::Forms::MergeAction::MatchOnly;
			this->menuItemView->MergeIndex = 2;
			this->menuItemView->Name = L"menuItemView";
			this->menuItemView->Size = System::Drawing::Size(62, 22);
			this->menuItemView->Text = L"\(&V)";
			// 
			// toolStripSeparator7
			// 
			this->toolStripSeparator7->Name = L"toolStripSeparator7";
			this->toolStripSeparator7->Size = System::Drawing::Size(163, 6);
			// 
			// menuItemViewMoveToTop
			// 
			this->menuItemViewMoveToTop->Name = L"menuItemViewMoveToTop";
			this->menuItemViewMoveToTop->Size = System::Drawing::Size(166, 22);
			this->menuItemViewMoveToTop->Text = L"őOʂֈړ(&B)";
			this->menuItemViewMoveToTop->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemViewMoveToTop_Click);
			// 
			// menuItemViewMoveToBottom
			// 
			this->menuItemViewMoveToBottom->Name = L"menuItemViewMoveToBottom";
			this->menuItemViewMoveToBottom->Size = System::Drawing::Size(166, 22);
			this->menuItemViewMoveToBottom->Text = L"Ŕwʂֈړ(&S)";
			this->menuItemViewMoveToBottom->Click += gcnew System::EventHandler(this, &TimeLineForm::menuItemViewMoveToBottom_Click);
			// 
			// timerTimeLineDrag
			// 
			this->timerTimeLineDrag->Tick += gcnew System::EventHandler(this, &TimeLineForm::timerTimeLineDrag_Tick);
			// 
			// toolTimeLine
			// 
			this->toolTimeLine->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(6) {this->toolStripSeparator19, 
				this->toolBtnZoomOut, this->toolBtnZoomIn, this->toolStripSeparator18, this->toolBtnGrid, this->toolCmdGrid});
			this->toolTimeLine->Location = System::Drawing::Point(0, 0);
			this->toolTimeLine->Name = L"toolTimeLine";
			this->toolTimeLine->Size = System::Drawing::Size(736, 26);
			this->toolTimeLine->TabIndex = 6;
			this->toolTimeLine->Text = L"toolTimeLine";
			this->toolTimeLine->Visible = false;
			this->toolTimeLine->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::toolTimeLine_MouseDown);
			// 
			// toolStripSeparator19
			// 
			this->toolStripSeparator19->Name = L"toolStripSeparator19";
			this->toolStripSeparator19->Size = System::Drawing::Size(6, 26);
			// 
			// toolBtnZoomOut
			// 
			this->toolBtnZoomOut->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			this->toolBtnZoomOut->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolBtnZoomOut.Image")));
			this->toolBtnZoomOut->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->toolBtnZoomOut->MergeIndex = 0;
			this->toolBtnZoomOut->Name = L"toolBtnZoomOut";
			this->toolBtnZoomOut->Size = System::Drawing::Size(23, 23);
			this->toolBtnZoomOut->Text = L"^CCk";
			this->toolBtnZoomOut->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::toolBtnZoomOut_MouseDown);
			this->toolBtnZoomOut->Click += gcnew System::EventHandler(this, &TimeLineForm::toolBtnZoomOut_Click);
			// 
			// toolBtnZoomIn
			// 
			this->toolBtnZoomIn->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			this->toolBtnZoomIn->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolBtnZoomIn.Image")));
			this->toolBtnZoomIn->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->toolBtnZoomIn->MergeIndex = 1;
			this->toolBtnZoomIn->Name = L"toolBtnZoomIn";
			this->toolBtnZoomIn->Size = System::Drawing::Size(23, 23);
			this->toolBtnZoomIn->Text = L"^CCg";
			this->toolBtnZoomIn->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::toolBtnZoomIn_MouseDown);
			this->toolBtnZoomIn->Click += gcnew System::EventHandler(this, &TimeLineForm::toolBtnZoomIn_Click);
			// 
			// toolStripSeparator18
			// 
			this->toolStripSeparator18->MergeIndex = 2;
			this->toolStripSeparator18->Name = L"toolStripSeparator18";
			this->toolStripSeparator18->Size = System::Drawing::Size(6, 26);
			// 
			// toolBtnGrid
			// 
			this->toolBtnGrid->CheckOnClick = true;
			this->toolBtnGrid->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			this->toolBtnGrid->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolBtnGrid.Image")));
			this->toolBtnGrid->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->toolBtnGrid->MergeIndex = 3;
			this->toolBtnGrid->Name = L"toolBtnGrid";
			this->toolBtnGrid->Size = System::Drawing::Size(23, 23);
			this->toolBtnGrid->Text = L"Obhɍ킹";
			this->toolBtnGrid->CheckStateChanged += gcnew System::EventHandler(this, &TimeLineForm::toolBtnGrid_CheckStateChanged);
			this->toolBtnGrid->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::toolBtnGrid_MouseDown);
			// 
			// toolCmdGrid
			// 
			this->toolCmdGrid->AutoSize = false;
			this->toolCmdGrid->Items->AddRange(gcnew cli::array< System::Object^  >(5) {L"4", L"8", L"16", L"32", L"64"});
			this->toolCmdGrid->Name = L"toolCmdGrid";
			this->toolCmdGrid->Size = System::Drawing::Size(80, 26);
			this->toolCmdGrid->TextChanged += gcnew System::EventHandler(this, &TimeLineForm::toolCmdGrid_TextChanged);
			this->toolCmdGrid->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::toolCmdGrid_MouseDown);
			// 
			// TimeLineForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(736, 290);
			this->Controls->Add(this->toolTimeLine);
			this->Controls->Add(this->menuTimeLine);
			this->Controls->Add(this->splitParent);
			this->KeyPreview = true;
			this->Name = L"TimeLineForm";
			this->Text = L"^CC";
			this->Deactivate += gcnew System::EventHandler(this, &TimeLineForm::TimeLineForm_Deactivate);
			this->Shown += gcnew System::EventHandler(this, &TimeLineForm::TimeLineForm_Shown);
			this->Activated += gcnew System::EventHandler(this, &TimeLineForm::TimeLineForm_Activated);
			this->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &TimeLineForm::TimeLineForm_MouseDown);
			this->Move += gcnew System::EventHandler(this, &TimeLineForm::TimeLineForm_Move);
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &TimeLineForm::TimeLineForm_FormClosing);
			this->Resize += gcnew System::EventHandler(this, &TimeLineForm::TimeLineForm_Resize);
			this->KeyDown += gcnew System::Windows::Forms::KeyEventHandler(this, &TimeLineForm::TimeLineForm_KeyDown);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->picModelName))->EndInit();
			this->menuModel->ResumeLayout(false);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->picTimeLine))->EndInit();
			this->menuPattern->ResumeLayout(false);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->picGauge))->EndInit();
			this->splitParent->Panel1->ResumeLayout(false);
			this->splitParent->Panel2->ResumeLayout(false);
			this->splitParent->ResumeLayout(false);
			this->splitModelName->Panel1->ResumeLayout(false);
			this->splitModelName->Panel1->PerformLayout();
			this->splitModelName->Panel2->ResumeLayout(false);
			this->splitModelName->Panel2->PerformLayout();
			this->splitModelName->ResumeLayout(false);
			this->splitTimeLine->Panel1->ResumeLayout(false);
			this->splitTimeLine->Panel2->ResumeLayout(false);
			this->splitTimeLine->ResumeLayout(false);
			this->menuTimeLine->ResumeLayout(false);
			this->menuTimeLine->PerformLayout();
			this->toolTimeLine->ResumeLayout(false);
			this->toolTimeLine->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

	public:
		System::Void SetTimeLine(TimeLine^ timeline) {
			this->timeline = timeline;
			if (timeline->smf->Filename != nullptr && timeline->smf->Filename != "") {//SMFǂݍłꍇ
				this->menuItemInsertBeat->Enabled = false;
				this->menuItemInsertTempo->Enabled = false;
				this->menuItemEditInsertBeat->Enabled = false;
				this->menuItemEditInsertTempo->Enabled = false;
			} else {//SMFǂݍłȂꍇ
				this->menuItemInsertBeat->Enabled = true;
				this->menuItemInsertTempo->Enabled = true;
				this->menuItemEditInsertBeat->Enabled = true;
				this->menuItemEditInsertTempo->Enabled = true;
			}
			//smf = timeline->smf;
			position->smf = timeline->smf;
			position->GlobalTick = 0;
			txtPosition->Text = position->ToString();
			lblDeltaTime->Text = String::Format("/{0:D}", timeline->smf->Header.DeltaTime);
			ModelLayout();//fg̃CAEǧvZ
		}

	public:
		System::Void ModelLayout() {//fg̃CAEǧvZ
			// f̃f[^珑fg̈ʒupicTimeLine̍vZB
			int top = 0;
			for (int i = 0; i < timeline->Models->Count; i++) {
				Model^ model = safe_cast<Model^>(timeline->Models[i]);
				model->Top = top;
				top += model->Height;
			}

			SetPicTimeLineWidth();
			picTimeLine->Height = top;
			picModelName->Height = top;

		}

	public:
		System::Void SetPicTimeLineWidth() {
			PixelsPerTick = timeline->PixelsPerTick();

			picTimeLine->Width = (int)System::Math::Round(timeline->smf->MaxTick * PixelsPerTick * timeline->tickScale);
			picGauge->Width = picTimeLine->Width;
		}

	private:
		System::Void picTimeLine_Paint(System::Object^  sender, System::Windows::Forms::PaintEventArgs^  e) {
			Keys key = Control::ModifierKeys;
			Graphics^ g = e->Graphics;
			System::Drawing::Pen^ myPen;

			int bcp = 0;//ݎgp̔q̔qύXւ̃|C^
			SMF::BeatChange^ bc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[bcp]);//ݎgp̔q̔qύX
			int dt = timeline->smf->Header.DeltaTime * bc->BeatInfo->cc / 24;
			int nextTick;

			//MessageBox::Show(String::Format("qύX̐={0:D}", smf->BeatChanges->Count));

			if (selecting) {//}EXhbOɂÏ̕\
				int left = mouseDownX;
				int right = mouseMoveX;
				if (left > right) {
					int w = left;
					left = right;
					right = w;
				}
				int top = mouseDownY;
				int bottom = mouseMoveY;
				if (top > bottom) {
					int w = top;
					top = bottom;
					bottom = w;
				}
				g->FillRectangle(System::Drawing::Brushes::LightCyan, left, top, right - left, bottom - top);
			}

			if (selStartPosition != nullptr) {//J[\L[ɂÏ̕\
				int left = (int)System::Math::Round(selStartPosition->GlobalTick * timeline->PixelsPerTick());
				int right = (int)System::Math::Round(position->GlobalTick * timeline->PixelsPerTick());
				if (left > right) {
					int w = left;
					left = right;
					right = w;
				}
				g->FillRectangle(System::Drawing::Brushes::LightCyan, left, 0, right - left, picTimeLine->Height);
			}

			if (bcp < timeline->smf->BeatChanges->Count - 1) {//̔qύXƂ
				SMF::BeatChange^ nbc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[bcp + 1]);
				nextTick = nbc->Tick;//̔qύXtick
			} else {//̔qύXƂ
				nextTick = timeline->smf->MaxTick;//Ōtick
			}

			int tick = 0;
			int m = 1;//
			int b = 1;//
			while (tick < timeline->smf->MaxTick) {
				if ((tick - bc->Tick) % (bc->BeatInfo->nn * dt) == 0) {//߂̓̂Ƃ
					myPen = System::Drawing::Pens::Red;
					m++;
					b = 1;
				} else {
					myPen = System::Drawing::Pens::Black;
				}

				int x = (int)System::Math::Round(tick * PixelsPerTick * timeline->tickScale);
				if (x > e->ClipRectangle.Right) {
					break;//`̈̉E𒴂`I
				} else if (x >= e->ClipRectangle.Left) {//`̈̂Ƃ̂ݕ`
					g->DrawLine(myPen, x, 0, x, picTimeLine->Height);//̏c
				}

				//Obh̐
				if (this->toolBtnGrid->CheckState == System::Windows::Forms::CheckState::Checked) {
					double step = (double)(4 << this->toolCmdGrid->SelectedIndex) / 4.0;
					int istep = (int)System::Math::Round(step);
					double grid = (double)timeline->smf->Header.DeltaTime * PixelsPerTick * timeline->tickScale / step;
					for (int i = 1; i < istep; i++) {
						int gx = x + (int)System::Math::Round(grid * (double)i);
						g->DrawLine(System::Drawing::Pens::Gainsboro, gx, 0, gx, picTimeLine->Height);//Obh̏c
					}
				}

				if (tick == nextTick) {//qύX̂Ƃ
					bcp++;
					bc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[bcp]);
					if (bcp < timeline->smf->BeatChanges->Count - 1) {//̔qύXƂ
						SMF::BeatChange^ nbc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[bcp + 1]);
						nextTick = nbc->Tick;//̔qύXtick
					} else {//̔qύXƂ
						nextTick = timeline->smf->MaxTick;//Ōtick
					}
					dt = timeline->smf->Header.DeltaTime * bc->BeatInfo->cc / 24;
				}

				tick += dt;
				b++;
			}

			//ݑIĂ鎞Ԉʒuɏc
			int loc = (int)System::Math::Round((double)position->GlobalTick * (double)picGauge->Width / (double)timeline->smf->MaxTick);
			g->DrawLine(System::Drawing::Pens::Blue, loc, 0, loc, picTimeLine->Height);

			if (selStartPosition != nullptr) {//IJnʒuʒuɏc
				int loc = (int)System::Math::Round((double)selStartPosition->GlobalTick * (double)picGauge->Width / (double)timeline->smf->MaxTick);
				g->DrawLine(System::Drawing::Pens::Blue, loc, 0, loc, picTimeLine->Height);
			}

			//fԂ̋E
			for (int i = 0; i < timeline->Models->Count - 1; i++) {
				Model^ model = safe_cast<Model^>(timeline->Models[i]);
				g->DrawLine(System::Drawing::Pens::Gray, 0, model->Bottom, picTimeLine->Width, model->Bottom);
			}

			//\tp^[̋``
			for (int i = 1; i < timeline->Models->Count; i++) {//gm[
				Model^ model = safe_cast<Model^>(timeline->Models[i]);
				for (int j = 0; j < model->Patterns->Count; j++) {
					Pattern^ pat = safe_cast<Pattern^>(model->Patterns[j]);
					if (pat->Left > e->ClipRectangle.Right || pat->Right < e->ClipRectangle.Left
								|| pat->Top > e->ClipRectangle.Bottom || pat->Bottom < e->ClipRectangle.Top) {
						continue;//`̈ÔƂ`Ȃ
					}
					if (pat->Type == Patterns::POSE) {//|[Yf[^x[X̃p^[̏ꍇ
						Option::PatternColor^ pc = config->Color->GetPatternColor(pat->Type);

						int height = (pat->Bottom <= model->Bottom) ? (pat->Height + 1) : (model->Bottom - pat->Top);
						System::Drawing::Rectangle rect(pat->Left, pat->Top, pat->Width + 1, height);
						g->SetClip(rect);//Rectangle^ rect ł͂ȂāARectangle rect Ȃ̂ŗvӁB

						//|[Y̔wiF
						g->FillRectangle(pc->BackBrush, pat->Left, pat->Top, pat->Width, pat->Height);

						//|[Y̐F
						SMF::Position^ pos = gcnew SMF::Position(timeline->smf);
						pos->GlobalTick = pat->Begin->GlobalTick;//JnʒuZJn
						int length = pat->End->GlobalTick - pat->Begin->GlobalTick;//p^[̎
						int width = (pat->NoLength) ? 4 : (int)System::Math::Round((double)(length * picTimeLine->Width) / (double)timeline->smf->MaxTick);
						for (int i = 0; i < pat->Repeat; i++) {//JԂ̃C^[ỏZ
							int left = (int)System::Math::Round((double)(pos->GlobalTick * picTimeLine->Width) / (double)timeline->smf->MaxTick);
							if (left > e->ClipRectangle.Right) {
								break;//`̈悩oƕ`I
							} else if (left + width >= e->ClipRectangle.Left) {//`̈̂ݕ`
								g->FillRectangle(pc->ForeBrush, left, pat->Top, width, pat->Height);
							}
							pos->Add(pat->Step);
#ifdef PAINT_DEBUG
							//g->DrawString(String::Format("({0},{1},{2})", e->ClipRectangle.Left,left,e->ClipRectangle.Right), picTimeLine->Font, pc->FontBrush,
							//				(float)(left + 3), (float)(pat->Top + 3 + 10 * (i % 2)));
#endif
						}

						//t@C
						g->DrawString(pat->vpd->file->Name
#ifdef PAINT_DEBUG

											/*+ String::Format("({0},{1})", e->ClipRectangle.Left,e->ClipRectangle.Right)*/
#endif
											,
											picTimeLine->Font, pc->FontBrush, (float)(pat->Left + 3), (float)(pat->Top + 3));
						String^ begin_pos = pat->Begin->ToString();
						System::Drawing::SizeF sizeF = g->MeasureString(begin_pos, picTimeLine->Font);
						g->DrawString(begin_pos, picTimeLine->Font, System::Drawing::Brushes::Black,
											(float)(pat->Left + 64) - sizeF.Width, (float)(pat->Bottom) - sizeF.Height);

						//g
						if (pat->Selected) {//IĂp^[̂Ƃ
							g->DrawRectangle(System::Drawing::Pens::Yellow, pat->Left, pat->Top, pat->Width, pat->Height);
						} else {//IĂȂꍇ
							g->DrawRectangle(System::Drawing::Pens::Black, pat->Left, pat->Top, pat->Width, pat->Height);
						}

						g->ResetClip();
					}
				}
			}

			if (mouseDown) {//}EX{^Ăꍇ(fg̍̕ύX)
				g->FillRectangle(System::Drawing::Brushes::LightGreen, 0, mouseMoveY + mouseDY - 3, picTimeLine->Width, 3);
			} else if (patternMoving && beginMoving) {//\tp^[ړ̏ꍇ

				//Ip^[̈ړO̊Jnʒu̎Zo
				SMF::Position^ patPos0 = gcnew SMF::Position(timeline->smf);
				int minTick = (int)System::Math::Round((double)(selectedPatterns->Right * timeline->smf->MaxTick) / (double)picTimeLine->Width);

				//ԍ̃p^[̊Jnʒǔ
				int minTop = selectedPatterns->Top;
				for (int i = 0; i < selectedPatterns->Count; i++) {
					Pattern^ pat = selectedPatterns->GetPatternAt(i);
					if (minTick > pat->Begin->GlobalTick) {
						minTick = pat->Begin->GlobalTick;
					}
				}
				patPos0->GlobalTick = minTick;

				//ړ̃p^[̈ʒu
				int x = mouseMoveX + mouseDX;
				if (x < 0) {
					x = 0;
				}

				//Ip^[̈ړ̊Jnʒu̎Zo
#ifdef PAINT_DEBUG
				double t1,t2;
				int t3,t4;
#endif
				SMF::Position^ patPos = gcnew SMF::Position(timeline->smf);
				patPos->GlobalTick = (int)System::Math::Round((double)(x * timeline->smf->MaxTick) / (double)picTimeLine->Width);
				if ((key & Keys::Control) == Keys::Control) {//Ctrl+NbN̂Ƃ
					patPos->Tick = 0;//tick𔏂̓ɂB
				} else if (this->toolBtnGrid->CheckState == System::Windows::Forms::CheckState::Checked) {//Obhɍ킹
					int grid = (1 << this->toolCmdGrid->SelectedIndex);
					double step = (double)timeline->smf->Header.DeltaTime / (double)grid;
#ifdef PAINT_DEBUG
					t1 = step;
					t2 = 0;
					t3 = patPos->Tick;
#endif
					if (config->Edit->GridClickOnLine) {
						patPos->Tick = (int)System::Math::Round((int)System::Math::Round(patPos->Tick / step) * step);
					} else {
						patPos->Tick = (int)System::Math::Round(int(patPos->Tick / step) * step);
					}
#ifdef PAINT_DEBUG
					t4 = patPos->Tick;
#endif
				}

				int moveTick = patPos->GlobalTick - patPos0->GlobalTick;

				bool multi_model = selectedPatterns->MultiModel();
				for (int i = 0; i < selectedPatterns->Count; i++) {
					Pattern^ pat = selectedPatterns->GetPatternAt(i);

					int left = (int)System::Math::Round((pat->Begin->GlobalTick + moveTick) * timeline->PixelsPerTick() * timeline->tickScale);
					int top = (multi_model) ? pat->Top : (mouseMoveY + mouseDY + pat->Top - selectedPatterns->Top);

					if (left > e->ClipRectangle.Right || left + pat->Width < e->ClipRectangle.Left
								|| top > e->ClipRectangle.Bottom || top + pat->Height < e->ClipRectangle.Top) {
						continue;//`̈ÔƂ`Ȃ
					}

#ifdef PAINT_DEBUG
					g->DrawString(String::Format("(step={0},mod={1},tick={2},grid={3},left={4},moveX={5},DX={6},pat={7},sel={8})", t1, t2, t3, t4, left,
								mouseMoveX, mouseDX, pat->Left, selectedPatterns->Left), picTimeLine->Font, System::Drawing::Brushes::Green,
										(float)(left + 64),
										(float)(top));
#endif
					//ړ̃p^[̘g
					g->DrawRectangle(System::Drawing::Pens::LightGreen, left, top, pat->Width, pat->Height);
				}
				//Ԉʒu\͘g`Ă`B(̏ɗΐԂ̂邽)
				for (int i = 0; i < selectedPatterns->Count; i++) {
					Pattern^ pat = selectedPatterns->GetPatternAt(i);

					int left = (int)System::Math::Round((pat->Begin->GlobalTick + moveTick) * timeline->PixelsPerTick() * timeline->tickScale);
					int top = (multi_model) ? pat->Top : (mouseMoveY + mouseDY + pat->Top - selectedPatterns->Top);

					if (left > e->ClipRectangle.Right || left + pat->Width < e->ClipRectangle.Left
								|| top > e->ClipRectangle.Bottom || top + pat->Height < e->ClipRectangle.Top) {
						continue;//`̈ÔƂ`Ȃ
					}

					//ړ̃p^[̈ʒu̕\̔wi
					g->FillRectangle(System::Drawing::Brushes::LightGreen, left, top + pat->Height - 15, 64, 15);

					SMF::Position^ mov_pos = pat->Begin->Copy();
					mov_pos->GlobalTick += moveTick;
					String^ begin_pos = mov_pos->ToString();
					System::Drawing::SizeF sizeF = g->MeasureString(begin_pos, picTimeLine->Font);
					g->DrawString(begin_pos, picTimeLine->Font, System::Drawing::Brushes::Green,
										(float)(left + 64) - sizeF.Width,
										(float)(top + pat->Height) - sizeF.Height);
					/* (20100311)NbsO@킩Ȃ̂łƂ肠ۗB
					ControlPaint::DrawReversibleFrame(picTimeLine->RectangleToScreen(System::Drawing::Rectangle(mouseMoveX + mouseDX + pat->Left - selectedPatterns->Left,
																		(multi_model) ? pat->Top : (mouseMoveY + mouseDY + pat->Top - selectedPatterns->Top),
																		pat->Width, pat->Height)), Color::FromArgb(0,255,0),FrameStyle::Thick);
					*/
				}
			} else if (patternResizing && beginMoving) {//\tp^[TCY̏ꍇ
					//ړ̃p^[̘g
					g->DrawRectangle(System::Drawing::Pens::LightGreen, selectedPattern->Left, selectedPattern->Top,
														selectedPattern->Width + mouseMoveX - mouseDownX , selectedPattern->Height);
			}

			if (dding) {//D&D̂Ƃ
				if (ddfiles->Length != 1 || !ddfiles[0]->ToUpper()->EndsWith(".VPD")
								|| PatternOver(Patterns::POSE, mouseMoveX, mouseMoveY) == nullptr) {//|[Yf[^ułȂƂ
					SMF::Position^ patPos = ddPos->Copy();
					if ((key & Keys::Control) == Keys::Control) {//Ctrl+NbN̂Ƃ
						patPos->Tick = 0;//tick𔏂̓ɂB
					} else if (this->toolBtnGrid->CheckState == System::Windows::Forms::CheckState::Checked) {//Obhɍ킹
						int grid = (1 << this->toolCmdGrid->SelectedIndex);
						double step = (double)timeline->smf->Header.DeltaTime / (double)grid;
						if (config->Edit->GridClickOnLine) {
							patPos->Tick = (int)System::Math::Round((int)System::Math::Round(patPos->Tick / step) * step);
						} else {
							patPos->Tick = (int)System::Math::Round(int(patPos->Tick / step) * step);
						}
					}

					int left = (int)System::Math::Round(patPos->GlobalTick * timeline->PixelsPerTick() * timeline->tickScale);
					//D&D̃p^[̈ʒu̕\̔wi
					g->FillRectangle(System::Drawing::Brushes::LightGreen, left + 8, ddPoint.Y + 30 - 15, 64 - 8, 15);

					//D&D̃p^[̘g
					g->DrawRectangle(System::Drawing::Pens::LightGreen, left, ddPoint.Y, 64 + 8, 30);

#ifdef PAINT_DEBUG
					g->DrawString(String::Format("count={0}", ddScrollCount), picTimeLine->Font, System::Drawing::Brushes::Green,
										(float)(left + 64),
										(float)(ddPoint.Y));
#endif

					//D&D̃p^[̈ʒu
					String^ begin_pos = patPos->ToString();
					System::Drawing::SizeF sizeF = g->MeasureString(begin_pos, picTimeLine->Font);
					g->DrawString(begin_pos, picTimeLine->Font, System::Drawing::Brushes::Green,
//											(float)(ddPoint.X + 64 - dx) - sizeF.Width,
											(float)(left + 64) - sizeF.Width,
											(float)(ddPoint.Y + 30) - sizeF.Height);
				}
			}

			picGauge->Left = picTimeLine->Left;
			picModelName->Top = picTimeLine->Top;
		}

	private:
		System::Void picModelName_Paint(System::Object^  sender, System::Windows::Forms::PaintEventArgs^  e) {
			Graphics^ g = e->Graphics;
			System::Drawing::Brush^ myBrush;

			for (int i = 0; i < timeline->Models->Count; i++) {
				Model^ model = safe_cast<Model^>(timeline->Models[i]);

				if (model->Selected && !txtInputName->Visible && !mouseDown) {
					//̃fIĂƂAf̕ҏWłȂƂAMouseDownłȂƂB
					g->FillRectangle(System::Drawing::SystemBrushes::Highlight, 0, model->Top + 1, picModelName->Width, model->Height);
					myBrush = System::Drawing::SystemBrushes::HighlightText;
				} else {
					if (i == 0) {//gm[(gݍ݃f̂Ƃ)
						myBrush = System::Drawing::Brushes::LightGray;
					} else {//ʏ탂f̏ꍇ
						myBrush = System::Drawing::SystemBrushes::WindowText;
					}
				}
				//fԂ̋E
				if (i < timeline->Models->Count - 1) {
					g->DrawLine(System::Drawing::Pens::Gray, 0, model->Bottom, picModelName->Width, model->Bottom);
				}

				//f\
				g->DrawString(model->Name->ToString(), picModelName->Font, myBrush, (float)10, (float)(model->Top + 10));

				if (mouseDown) {//}EX{^Ăꍇ
					g->FillRectangle(System::Drawing::Brushes::LightGreen, 0, mouseMoveY + mouseDY - 3, picModelName->Width, 3);
				}
			}

		}


	private:
		System::Void picGauge_Paint(System::Object^  sender, System::Windows::Forms::PaintEventArgs^  e) {
			Graphics^ g = e->Graphics;
			System::Drawing::Brush^ myBrush;

			int bcp = 0;//ݎgp̔q̔qύXւ̃|C^
			SMF::BeatChange^ bc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[bcp]);//ݎgp̔q̔qύX
			int dt = timeline->smf->Header.DeltaTime * bc->BeatInfo->cc / 24;
			int nextTick;

			//MessageBox::Show(String::Format("qύX̐={0:D}", smf->BeatChanges->Count));

			if (bcp < timeline->smf->BeatChanges->Count - 1) {//̔qύXƂ
				SMF::BeatChange^ nbc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[bcp + 1]);
				nextTick = nbc->Tick;//̔qύXtick
			} else {//̔qύXƂ
				nextTick = timeline->smf->MaxTick;//Ōtick
			}

			int tick = dt;
			int m = 1;
			int b = 2;
			while (tick < timeline->smf->MaxTick) {
				if ((tick - bc->Tick) % (bc->BeatInfo->nn * dt) == 0) {//߂̓̂Ƃ
					myBrush = System::Drawing::Brushes::Red;
					m++;
					b = 1;
				} else {
					myBrush = System::Drawing::Brushes::Black;
				}
				String^ beat = String::Format("{0:D}:{1:D}", m, b);
				SizeF sizef = g->MeasureString(beat, picTimeLine->Font);
				double x = tick * PixelsPerTick * timeline->tickScale;
				if (x - 0.5 * sizef.Width > e->ClipRectangle.Right) {
					break;//`̈𒴂`I
				} else if (x + 0.5 * sizef.Width >= e->ClipRectangle.Left) {//`̈̂Ƃ̂ݕ`
					g->DrawString(beat, picTimeLine->Font, myBrush, (float)(x - 0.5 * sizef.Width), (float)8.0);//߁F
				}

				if (tick == nextTick) {//qύX̂Ƃ
					bcp++;
					bc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[bcp]);
					if (bcp < timeline->smf->BeatChanges->Count - 1) {//̔qύXƂ
						SMF::BeatChange^ nbc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[bcp + 1]);
						nextTick = nbc->Tick;//̔qύXtick
					} else {//̔qύXƂ
						nextTick = timeline->smf->MaxTick;//Ōtick
					}
					dt = timeline->smf->Header.DeltaTime * bc->BeatInfo->cc / 24;
				}

				tick += dt;
				b++;
			}
		}

	private:
		System::Void splitTimeLine_Panel2_Scroll(System::Object^  sender, System::Windows::Forms::ScrollEventArgs^  e) {	
			PanScrollStop();
			picGauge->Left = picTimeLine->Left;
			picModelName->Top = picTimeLine->Top;
			picGauge->Refresh();
			picModelName->Refresh();
			picTimeLine->Refresh();
		}

	private:
		System::Void TimeLineForm_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e) {
			e->Cancel = true;
			if (e->CloseReason == System::Windows::Forms::CloseReason::UserClosing) {//́~ƂB
				selectedPatterns->Clear();//IB
				this->Hide();
			}
		}

	private:
		System::Void toolBtnZoomOut_Click(System::Object^  sender, System::EventArgs^  e) {
			ZoomTimeLine(1.0/1.1);
		}

	private:
		System::Void toolBtnZoomIn_Click(System::Object^  sender, System::EventArgs^  e) {
			ZoomTimeLine(1.1);
		}

	private:
		System::Void btnZoomPlus_Click(System::Object^  sender, System::EventArgs^  e) {
			ZoomTimeLine(1.1);
		}

	private:
		System::Void btnZoomMinus_Click(System::Object^  sender, System::EventArgs^  e) {
			ZoomTimeLine(1.0/1.1);
		}

	private:
		System::Void ZoomTimeLine(double zoom) {//^CC̃Y[
			//  |                   S                     |
			//  | left  | \ | E͂ݏo|

			timeline->tickScale *= zoom;
			picTimeLine->Width = (int)System::Math::Round(timeline->smf->MaxTick * PixelsPerTick * timeline->tickScale);

			splitTimeLine->Panel2->AutoScrollPosition = Point((int)System::Math::Round(-splitTimeLine->Panel2->AutoScrollPosition.X * zoom),
																-splitTimeLine->Panel2->AutoScrollPosition.Y);

			picGauge->Left = picTimeLine->Left;
			picModelName->Top = picTimeLine->Top;

			picGauge->Width = (int)System::Math::Round(timeline->smf->MaxTick * PixelsPerTick * timeline->tickScale);

			//Ip^[̘g̍ČvZ
			selectedPatterns->UpdateRectangle();

			//Rs[obt@̘g̍ČvZ
			copyBuffer->UpdateRectangle();

			picTimeLine->Refresh();
			picGauge->Refresh();
		}

	private:
		System::Void TimeLineForm_MouseWheel(System::Object^ sender, System::Windows::Forms::MouseEventArgs^ e) {//}EXzC[
			/* ςꍇ
			int d;
			if (e->Delta > 0) {
				d = -30;
			} else {
				d = 30;
			}
			*/

			splitTimeLine->Panel2->AutoScrollPosition = Point(-splitTimeLine->Panel2->AutoScrollPosition.X,
																-splitTimeLine->Panel2->AutoScrollPosition.Y - e->Delta);

			picGauge->Left = picTimeLine->Left;
			picModelName->Top = picTimeLine->Top;

			picGauge->Width = (int)System::Math::Round(timeline->smf->MaxTick * PixelsPerTick * timeline->tickScale);
			picGauge->Refresh();
		}

	private:
		System::Void menuItemAddModel_Click(System::Object^  sender, System::EventArgs^  e) {
			Model^ model;
			int max = 0;
			int n;
			for (int i = 1; i < timeline->Models->Count; i++) {
				model = safe_cast<Model^>(timeline->Models[i]);
				String^ name = model->Name->ToString();
				if (name->Substring(0, 2) == "VK") {
					n = Int32::Parse(name->Substring(2));
					if (n > max) {
						max = n;
					}
				}
			}

			model = gcnew Model();
			model->Name = gcnew MMD::String(String::Format("VK{0:D}", max + 1));
			//model->Top = 0;//`掞ɎZo
			model->Height = config->Edit->DefaultModelHeight;

			Exec(gcnew Edit::AddModel(this, timeline, model));
			/*
			timeline->Models->Add(model);

			ModelLayout();//fg̃CAEǧvZ

			timeline->Changed = true;
			*/
		}

	private:
		System::Void picModelName_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
			ModelSelect(e->Y, true, true);
			splitTimeLine->Focus();
			//ModelSelect(e->Y, true, true);
		}

	private:
		System::Void menuModel_Opened(System::Object^  sender, System::EventArgs^  e) {
			if (menuModel->SourceControl != picModelName) {//fȊÕ̕NbN̏ꍇ
				menuItemModelNameChange->Enabled = false;
				menuItemDeleteModel->Enabled = false;
			}
		}

	public:
		System::Void SetModelMenuEnabled(bool enabled) {
			this->menuItemDeleteModel->Enabled = enabled;
			this->menuItemModelNameChange->Enabled = enabled;
			this->menuItemEditDeleteModel->Enabled = enabled;
			this->menuItemEditModelNameChange->Enabled = enabled;
		}

	private:
		System::Void menuItemDeleteModel_Click(System::Object^  sender, System::EventArgs^  e) {//IĂ郂f̍폜
			/*
			this->menuItemDeleteModel->Enabled = false;
			this->menuItemModelNameChange->Enabled = false;
			this->menuItemEditDeleteModel->Enabled = false;
			this->menuItemEditModelNameChange->Enabled = false;
			//timeline->Models->RemoveAt(selectedModelIndex);
			*/
			Exec(gcnew Edit::DeleteModel(this, timeline, selectedModelIndex));
			/*
			ModelLayout();//fg̃CAEǧvZ
			timeline->Changed = true;
			picModelName->Refresh();
			picTimeLine->Refresh();
			*/
		}

	private:
		System::Void menuItemModelNameChange_Click(System::Object^  sender, System::EventArgs^  e) {
			picModelName->ContextMenuStrip = nullptr;
			splitModelName->Panel2->ContextMenuStrip = nullptr;
			this->menuItemDeleteModel->Enabled = false;
			this->menuItemModelNameChange->Enabled = false;
			this->menuItemEditDeleteModel->Enabled = false;
			this->menuItemEditModelNameChange->Enabled = false;
			txtInputName->Enabled = true;
			txtInputName->Visible = true;
			txtInputName->Left = 10;
			txtInputName->Top = selectedModel->Top + 10;
			txtInputName->Text = selectedModel->Name->ToString();
			txtInputName->SelectAll();
			txtInputName->Focus();
			picModelName->Refresh();
		}

	private:
		System::Void txtInputName_KeyPress(System::Object^  sender, System::Windows::Forms::KeyPressEventArgs^  e) {
			if (e->KeyChar == (char)Keys::Enter) {//m:EnterL[
				String^ new_name = txtInputName->Text;
				if (new_name != selectedModel->Name->ToString()) {//ύX̂Ƃ
					Exec(gcnew Edit::ModelRename(this, timeline, selectedModel, selectedModel->Name->ToString(), new_name));
					/*
					selectedModel->Name = gcnew MMD::String(new_name);
					timeline->Changed = true;
					*/
				}
				LeaveInputName();
			} else if (e->KeyChar == (char)Keys::Escape) {//LZ:ESCL[
				LeaveInputName();
			}
		}

	private:
		System::Void txtInputName_Leave(System::Object^  sender, System::EventArgs^  e) {
			LeaveInputName();
		}

	private:
		System::Void LeaveInputName() {//f͏Ԃ甲鏈
			this->menuItemDeleteModel->Enabled = true;
			this->menuItemModelNameChange->Enabled = true;
			this->menuItemEditDeleteModel->Enabled = true;
			this->menuItemEditModelNameChange->Enabled = true;
			txtInputName->Enabled = false;
			txtInputName->Visible = false;
			picModelName->ContextMenuStrip = menuModel;
			splitModelName->Panel2->ContextMenuStrip = menuModel;
			picModelName->Refresh();
		}

	private:
		System::Void picModelName_MouseMove(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			ModelResize(picModelName, e->X, e->Y);
		}

	private:
		System::Void picTimeLine_MouseMove(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			ModelResize(picTimeLine, e->X, e->Y);

			//}EXJ[\ʒũ|WVʒu\
			SMF::Position^ pos = gcnew SMF::Position(timeline->smf);
			pos->GlobalTick = (int)System::Math::Round((double)timeline->smf->MaxTick * (double)e->X / (double)picGauge->Width);
			SetStatusPosition(pos->ToString());

		}

	private:
		System::Void ModelResize(PictureBox^ pic, int mouseX, int mouseY) {
			ScrollPic = pic;
			if (!txtInputName->Visible) {//fҏWłȂꍇ
				if (mouseDown) {//}EX{^ĂꍇB
					pic->Cursor = Cursors::HSplit;
					mouseMoveY = mouseY;
					//ModelLayout();//fg̃CAEǧvZł͕sv
					picModelName->Refresh();
					picTimeLine->Refresh();
				} else if (panScrollReady && pic == picTimeLine) {
					if (mouseDownX != mouseX || mouseDownY != mouseY) {//}EXJ[\ړƂ
						mouseMoveX = mouseX;
						mouseMoveY = mouseY;
						//{^܂܂̃pXN[̊Jn
						panScrollReady = false;
						panScrollDrag = true;
						picTimeLine->Cursor = Cursors::NoMove2D;
						timerTimeLineDrag->Enabled = true;
					}
				} else if ((panScrollDrag || panScrollFree) && pic == picTimeLine) {
					mouseMoveX = mouseX;
					mouseMoveY = mouseY;
				} else if (patternMoving || patternResizing || selecting) {//p^[ړAp^[TCYA܂̓hbOɂ͈͑I𒆂̏ꍇB
					if (mouseDownX != mouseX || mouseDownY != mouseY) {
						beginMoving = true;
					}
					if (patternResizing) {
						pic->Cursor = Cursors::SizeWE;
					} else {
						pic->Cursor = Cursors::SizeAll;
					}
					mouseMoveX = mouseX;
					mouseMoveY = mouseY;
					if (selecting) {//I̔
						int left = mouseDownX;
						int right = mouseMoveX;
						if (left > right) {
							int w = left;
							left = right;
							right = w;
						}
						int top = mouseDownY;
						int bottom = mouseMoveY;
						if (top > bottom) {
							int w = top;
							top = bottom;
							bottom = w;
						}
						selectedPatterns->Clear();//IԂ
						for (int i = 1; i < timeline->Models->Count; i++) {//gm[͏
							Model^ model = safe_cast<Model^>(timeline->Models[i]);
							for (int j = 0; j < model->Patterns->Count; j++) {
								Pattern^ pat = safe_cast<Pattern^>(model->Patterns[j]);
								if (pat->Left <= right && pat->Right >= left && pat->Top <= bottom && pat->Bottom >= top) {//GNXv[Ɠ͈̔͑I
									selectedPatterns->AddPattern(pat);
								}
							}
						}
						if (selectedPatterns->Count > 0) {//p^[IĂƂ
							this->menuItemDeletePattern->Enabled = true;
							this->menuItemEditDeletePattern->Enabled = true;
							this->menuItemCutPattern->Enabled = true;
							this->menuItemCopyPattern->Enabled = true;
							this->menuItemEditCutPattern->Enabled = true;
							this->menuItemEditCopyPattern->Enabled = true;
						} else {//p^[IĂȂƂ
							this->menuItemDeletePattern->Enabled = false;
							this->menuItemEditDeletePattern->Enabled = false;
							this->menuItemCutPattern->Enabled = false;
							this->menuItemCopyPattern->Enabled = false;
							this->menuItemEditCutPattern->Enabled = false;
							this->menuItemEditCopyPattern->Enabled = false;
						}
					}
					picModelName->Refresh();
					picTimeLine->Refresh();
				} else {//}EX{^ĂȂꍇ
					Keys key = Control::ModifierKeys;
					bool onSplit = false;
					bool onPattern = false;
					bool onResize = false;
					for (int i = 1; i < timeline->Models->Count; i++) {//gm[͏O
						Model^ model = safe_cast<Model^>(timeline->Models[i]);
						//fgύX
						if (model->Bottom - 5 <= mouseY && mouseY <= model->Bottom + 1) {
							onSplit = true;
							picResize = pic;
							break;
						}
						//p^[ړ
						if (pic == picTimeLine) {//^CĈƂ
							for (int j = model->Patterns->Count - 1; j >= 0; j--) {
								Pattern^ pat = safe_cast<Pattern^>(model->Patterns[j]);
								if (mouseX >= pat->Left && mouseX <= pat->Right && mouseY >= pat->Top && mouseY <= pat->Bottom
											&& model->Top + 1 < mouseY && mouseY < model->Bottom - 5) {
									if (mouseX >= pat->Right - 4 && (key & Keys::Control) != Keys::Control
																&& (key & Keys::Shift) != Keys::Shift) {//p^[̉E[̂Ƃ
										onResize = true;//TCY
									}else {
										onPattern = true;//ړ
									}
									break;
								}
							}
						}
					}
					if (onSplit) {
						pic->Cursor = Cursors::HSplit;
					} else if (onPattern) {
						pic->Cursor = Cursors::SizeAll;
					} else if (onResize) {
						pic->Cursor = Cursors::SizeWE;
					} else {
						pic->Cursor = Cursors::Default;
					}
				}
			}
		}

	private:
		Pattern^ PatternOver(Patterns::Type type, int x, int y) {//(x, y)ǂ̎w肵^Cṽp^[ɂ邩肷B
			Pattern^ ret = nullptr;

			for (int i = 1; i < timeline->Models->Count; i++) {//gm[͏O
				Model^ model = safe_cast<Model^>(timeline->Models[i]);
				for (int j = model->Patterns->Count - 1; j >= 0; j--) {
					Pattern^ pat = safe_cast<Pattern^>(model->Patterns[j]);
					if (x >= pat->Left && x <= pat->Right && y >= pat->Top && y <= pat->Bottom
								&& model->Top < y && y < model->Bottom && pat->Type == type) {
						ret = pat;
						break;
					}
				}
			}

			return ret;
		}

	private:
		System::Void ModelResizeEnd(int mouseY) {
			mouseDown = false;
			picResize->Cursor = Cursors::Default;
			if (mouseDownY != mouseY) {//ύXƂ
				int old_height = selectedModel->Height;
				/*
				selectedModel->Height -= mouseDownY - mouseY;
				if (selectedModel->Height < 30) {//g̍Ȃ肷Ƃ
					selectedModel->Height = 30;//()
				}
				*/
				int new_height = selectedModel->Height - (mouseDownY - mouseY);
				if (new_height < 30) {//g̍Ȃ肷Ƃ
					new_height = 30;//()
				}

				Exec(gcnew Edit::ModelResize(this, timeline, selectedModel, old_height, new_height));
				/*
				ModelLayout();//fg̃CAEǧvZ
				timeline->Changed = true;
				*/
			}
			//picModelName->Refresh();
			//picTimeLine->Refresh();
		}

	private:
		System::Void picModelName_MouseUp(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			if (mouseDown) {//MouseDownƂ
				ModelResizeEnd(e->Y);
			}
		}

	private:
		System::Void picTimeLine_MouseUp(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			Keys key = Control::ModifierKeys;

			//hbOp^C}[I
			timerTimeLineDrag->Enabled = false;

			if (mouseDown) {//MouseDownƂ
				ModelResizeEnd(e->Y);
			}
			if (patternMoving) {//p^[ړƂ
				patternMoving = false;
				beginMoving = false;
				picTimeLine->Cursor = Cursors::Default;
				if (e->X != mouseDownX || e->Y != mouseDownY) {//}EXړƂ
					timeline->Changed = true;

					//͈͑Ip^[̃hbOÖʒu
					int left0 = selectedPatterns->Left;
					int top0 = selectedPatterns->Top;

					//f܂܂邩ǂ̔
					bool multi_model = selectedPatterns->MultiModel();

					//Ip^[̈ړO̊Jnʒu̎Zo
					SMF::Position^ patPos0 = gcnew SMF::Position(timeline->smf);
					int minTick = (int)System::Math::Round((double)(selectedPatterns->Right * timeline->smf->MaxTick) / (double)picTimeLine->Width);

					//fg[ʒuAсAԍ̃p^[̊Jnʒǔ
					int minTop = selectedPatterns->Top;
					for (int i = 0; i < selectedPatterns->Count; i++) {
						Pattern^ pat = selectedPatterns->GetPatternAt(i);
						if (pat->Model->Top < minTop) {
							minTop = pat->Model->Top;
						}
						if (minTick > pat->Begin->GlobalTick) {
							minTick = pat->Begin->GlobalTick;
						}
					}
					patPos0->GlobalTick = minTick;

					selectedPatterns->Left += e->X - mouseDownX;
					if (!multi_model) {//fÎƂ͏cʒu͓Ȃ
						selectedPatterns->Top += e->Y - mouseDownY;
						if (selectedPatterns->Top < minTop) {
							selectedPatterns->Top = minTop;
						}
					}
					if (selectedPatterns->Left < 0) {
						selectedPatterns->Left = 0;
					}
					if (selectedPatterns->Left > picTimeLine->Width - 10) {
						selectedPatterns->Left = picTimeLine->Width - 10;
					}
						
					int moveX = selectedPatterns->Left - left0;
					int moveY = 0;
					if (!multi_model) {//fÎƂ͏cʒu͓Ȃ
						moveY = selectedPatterns->Top - top0;
					}
						
					//Ip^[̈ړ̊Jnʒu̎Zo
					SMF::Position^ patPos = gcnew SMF::Position(timeline->smf);
					patPos->GlobalTick = (int)System::Math::Round((double)(selectedPatterns->Left * timeline->smf->MaxTick) / (double)picTimeLine->Width);
					if ((key & Keys::Control) == Keys::Control) {//Ctrl+NbN̂Ƃ
						patPos->Tick = 0;//tick𔏂̓ɂB
					} else if (this->toolBtnGrid->CheckState == System::Windows::Forms::CheckState::Checked) {//Obhɍ킹
						int grid = (1 << this->toolCmdGrid->SelectedIndex);
						double step = (double)timeline->smf->Header.DeltaTime / (double)grid;
						int tick;
						if (config->Edit->GridClickOnLine) {
							tick = (int)System::Math::Round((int)System::Math::Round(patPos->Tick / step) * step);
						} else {
							tick = (int)System::Math::Round(int(patPos->Tick / step) * step);
						}
						System::Diagnostics::Debug::WriteLine(System::String::Format("MouseUp; tick = {0}", tick));
						patPos->Tick = tick;
					}

					int moveTick = patPos->GlobalTick - patPos0->GlobalTick;

					bool updateSelectedRectangle = false;
					if ((key & Keys::Control) == Keys::Control
								|| this->toolBtnGrid->CheckState == System::Windows::Forms::CheckState::Checked) {//Ctrl+NbN̂ƂA܂̓Obhɍ킹Ƃ
						updateSelectedRectangle = true;//ʒǔvZȂKv
					}

					Exec(gcnew Edit::PatternMove(this, timeline, moveTick, moveY, selectedPatterns, updateSelectedRectangle));
					/*
					for (int i = 0; i < selectedPatterns->Count; i++) {
						Pattern^ pat = selectedPatterns->GetPatternAt(i);
						pat->Top += moveY;
						pat->Begin->GlobalTick += moveTick;
						pat->End->GlobalTick += moveTick;
						pat->UpdateRectangle();//TCYEʒǔvZ
					}
					if (updateSelectedRectangle) {//Ctrl+NbN̂ƂA܂̓Obhɍ킹Ƃ
						selectedPatterns->UpdateRectangle();//ʒǔvZȂKv
					}
					*/
				}

				picModelName->Refresh();
				picTimeLine->Refresh();
			} else if (patternResizing) {//p^[TCYƂ
				patternResizing = false;
				beginMoving = false;
				picTimeLine->Cursor = Cursors::Default;
				if (e->X != mouseDownX || e->Y != mouseDownY) {//}EXړƂ
					timeline->Changed = true;

					Exec(gcnew Edit::PatternResize(this, timeline, e->X - mouseDownX, selectedPattern));

				}

				picModelName->Refresh();
				picTimeLine->Refresh();
			} else if (selecting) {//hbOɂ͈͑I𒆂Ƃ
				selecting = false;
				picModelName->Refresh();
				picTimeLine->Refresh();
			} else if (panScrollDrag) {//{^܂܃pXN[ĂƂ̓}EXXN[I
				panScrollDrag = false;
				panCenter->Hide();
				timerTimeLineDrag->Enabled = false;
				picTimeLine->Cursor = Cursors::Default;
			} else if (panScrollReady) {
				if (e->X == mouseDownX && e->Y == mouseDownY) {//}EXړȂƂ
					panScrollReady = false;
					//{^𗣂ԂŃpXN[̊Jn
					panScrollFree = true;
					timerTimeLineDrag->Enabled = true;
					picTimeLine->Cursor = Cursors::NoMove2D;
				}
			}
		}

	public:
		System::Void PanScrollStop() {//pXN[̏I
			if (panScrollFree || panScrollDrag) {
				panScrollFree = false;
				panScrollDrag = false;
				panCenter->Hide();
				timerTimeLineDrag->Enabled = false;
				picTimeLine->Cursor = Cursors::Default;
			}
		}

	private:
		System::Void SelectPatternMenuUpdate(Model^ model) {//uׂẴp^[Iṽj[̗L
			if (model->Patterns->Count > 0) {//Ȃɂp^[܂܂ꍇ
				this->menuItemSelectPattern->Enabled = true;
				this->menuItemEditSelectPattern->Enabled = true;
				this->menuItemSelectAllPattern->Enabled = true;
				this->menuItemEditSelectAllPattern->Enabled = true;
				int match_count = 0;
				for (int i = 0; i < model->Patterns->Count; i++) {
					Pattern^ pat = safe_cast<Pattern^>(model->Patterns[i]);
					switch (pat->Type) {
					case MetMotMk::Patterns::POSE://|[Yp^[
						if ((match_count & 0x01) == 0) {
							this->menuItemSelectPosePattern->Enabled = true;
							this->menuItemEditSelectPosePattern->Enabled = true;
							match_count |= 0x01;
						}
						break;
					case MetMotMk::Patterns::MOTION://[Vp^[
						if ((match_count & 0x02) == 0) {
							this->menuItemSelectMotionPattern->Enabled = true;
							this->menuItemEditSelectMotionPattern->Enabled = true;
							match_count |= 0x02;
						}
						break;
					case MetMotMk::Patterns::CONTAINER://p^[
						if ((match_count & 0x04) == 0) {
							this->menuItemSelectPatternContainer->Enabled = true;
							this->menuItemEditSelectPatternContainer->Enabled = true;
							match_count |= 0x04;
						}
						break;
					case MetMotMk::Patterns::LIPSYNC://bvp^[
						if ((match_count & 0x08) == 0) {
							this->menuItemSelectLipPattern->Enabled = true;
							this->menuItemEditSelectLipPattern->Enabled = true;
							match_count |= 0x08;
						}
						break;
					case MetMotMk::Patterns::MIDI://tp^[
						if ((match_count & 0x10) == 0) {
							this->menuItemSelectMIDIPattern->Enabled = true;
							this->menuItemEditSelectMIDIPattern->Enabled = true;
							match_count |= 0x10;
						}
						break;
					case MetMotMk::Patterns::SHORTCUT://V[gJbg
						if ((match_count & 0x20) == 0) {
							this->menuItemSelectShortcutPattern->Enabled = true;
							this->menuItemEditSelectShortcutPattern->Enabled = true;
							match_count |= 0x20;
						}
						break;
					case MetMotMk::Patterns::COMMENT://Rg
						if ((match_count & 0x40) == 0) {
							this->menuItemSelectCommentPattern->Enabled = true;
							this->menuItemEditSelectCommentPattern->Enabled = true;
							match_count |= 0x40;
						}
						break;
					}
					if (match_count & 0x7f) {//Sj[XV̂Ƃ
						break;//[v𔲂
					}
				}
			}
		}

	public:
		System::Void ModelSelect(int mouseY) {//fI(}EXɂ郂fI)
			ModelSelect(mouseY, true, false);
		}
		
	public:
		System::Void ModelSelect(int mouseY, bool mouseClick, bool modelClick) {//fI
			if (!txtInputName->Visible) {
				this->menuItemDeleteModel->Enabled = false;
				this->menuItemModelNameChange->Enabled = false;
				this->menuItemEditDeleteModel->Enabled = false;
				this->menuItemEditModelNameChange->Enabled = false;
				this->menuItemFileOpenVPD->Enabled = false;
				this->menuItemOpenVPD->Enabled = false;
				this->menuItemSaveModelVMD->Enabled = false;
				this->menuItemFileSaveModelVMD->Enabled = false;
				this->menuItemSelectPattern->Enabled = false;
				this->menuItemEditSelectPattern->Enabled = false;
				this->menuItemSelectAllPattern->Enabled = false;
				this->menuItemEditSelectAllPattern->Enabled = false;
				this->menuItemSelectPosePattern->Enabled = false;
				this->menuItemEditSelectPosePattern->Enabled = false;
				this->menuItemSelectMotionPattern->Enabled = false;
				this->menuItemEditSelectMotionPattern->Enabled = false;
				this->menuItemSelectPatternContainer->Enabled = false;
				this->menuItemEditSelectPatternContainer->Enabled = false;
				this->menuItemSelectLipPattern->Enabled = false;
				this->menuItemEditSelectLipPattern->Enabled = false;
				this->menuItemSelectMIDIPattern->Enabled = false;
				this->menuItemEditSelectMIDIPattern->Enabled = false;
				this->menuItemSelectShortcutPattern->Enabled = false;
				this->menuItemEditSelectShortcutPattern->Enabled = false;
				this->menuItemSelectCommentPattern->Enabled = false;
				this->menuItemEditSelectCommentPattern->Enabled = false;
				bool selectedModelChanged = false;
				for (int i = 0; i < timeline->Models->Count; i++) {//gm[܂߂
					Model^ model = safe_cast<Model^>(timeline->Models[i]);
					if (model->Top + 1 < mouseY && mouseY < model->Bottom - 5) {
						model->Selected = true;
						if (selectedModel != model) {
							selectedModelChanged = true;
						}
						selectedModel = model;
						selectedModelIndex = i;
						this->menuItemDeleteModel->Enabled = true;
						this->menuItemModelNameChange->Enabled = true;
						this->menuItemEditDeleteModel->Enabled = true;
						this->menuItemEditModelNameChange->Enabled = true;
						if (i > 0) {//gm[ȊO
							//\t
							this->menuItemFileOpenVPD->Enabled = true;
							this->menuItemOpenVPD->Enabled = true;
							//Ifׂ̂Ẵp^[̑I
							SelectPatternMenuUpdate(model);
						}
						this->menuItemSaveModelVMD->Enabled = true;
						this->menuItemFileSaveModelVMD->Enabled = true;
					} else {
						model->Selected = false;
					}
					if (model->Bottom-5 <= mouseY && mouseY <= model->Bottom + 1) {//gm[OƁAIf`ɂȂƂ̂ŁAƂ肠܂߂B
						model->Selected = true;//:  selected ɂĂ邽߂ɁAg̑傫ς郂fgIԂɂȂB
						if (selectedModel != model) {
							selectedModelChanged = true;
						}
						selectedModel = model;
						selectedModelIndex = i;
						if (i > 0) {//gm[łȂƂATCYύX
							mouseDownY = mouseY;
							mouseMoveY = mouseY;
							mouseDY = model->Bottom - mouseDownY;
							mouseDown = true;
							picModelName->Cursor = Cursors::HSplit;
						} else {
							picModelName->Cursor = Cursors::Default;
						}
					} else {
						picModelName->Cursor = Cursors::Default;
					}
				}
				if (modelClick && selectedModelChanged) {//fplNbNŁAIfύXɂȂꍇ
					lastTimeLineMouseDownY = selectedModel->Top + 10;//W̃fgɈڂ
				}
				if (selectedModel != nullptr && !mouseClick) {//}EXNbNłȂÎƂ(J[\L[ɂÎƂ)
					int y = -splitTimeLine->Panel2->AutoScrollPosition.Y;
					if (selectedModel->Top > y + splitTimeLine->Panel2->Height - 30) {//f\̈ɂƂ
						y = selectedModel->Bottom - splitTimeLine->Panel2->Height + 20;
					} else if (selectedModel->Bottom < y + 30 || selectedModel->Top < y) {//f\̈ɂƂ
						y = selectedModel->Top;
					}
					splitTimeLine->Panel2->AutoScrollPosition = Point(-splitTimeLine->Panel2->AutoScrollPosition.X, y);

					picModelName->Top = picTimeLine->Top;

					picTimeLine->Refresh();
				}
				picModelName->Refresh();
			}
		}

	private:
		System::Void picTimeLine_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			Keys key = Control::ModifierKeys;

			selStartPosition = nullptr;//J[\L[ɂ͈͎w̉

			splitTimeLine->Focus();

			lastTimeLineMouseDownX = e->X;
			lastTimeLineMouseDownY = e->Y;

			//fIB
			ModelSelect(e->Y);

			this->menuItemMoveToTop->Enabled = false;
			this->menuItemMoveToBottom->Enabled = false;
			this->menuItemViewMoveToTop->Enabled = false;
			this->menuItemViewMoveToBottom->Enabled = false;
			this->menuItemDeletePattern->Enabled = false;
			this->menuItemEditDeletePattern->Enabled = false;
			this->menuItemSaveModelVMD->Enabled = false;
			this->menuItemFileSaveModelVMD->Enabled = false;
			this->menuItemEditPattern->Enabled = false;
			this->menuItemEditEditPattern->Enabled = false;
			this->menuItemCutPattern->Enabled = false;
			this->menuItemCopyPattern->Enabled = false;
			this->menuItemEditCutPattern->Enabled = false;
			this->menuItemEditCopyPattern->Enabled = false;
			//(ONbNp^[͂܂oĂ)selectedPattern = nullptr;

			mouseDownY = e->Y;
			mouseMoveY = e->Y;
			mouseDownX = e->X;
			mouseMoveX = e->X;

			if (e->Button == System::Windows::Forms::MouseButtons::Middle) {//{^NbN̂Ƃ
				if (panScrollFree || panScrollDrag) {//pXN[̂Ƃ
					panCenter->Hide();
					picTimeLine->Cursor = Cursors::Default;
					panScrollFree = panScrollDrag = false;
				} else {
					panScrollCenterPoint = picTimeLine->PointToScreen(Point(e->X, e->Y));
					System::Drawing::Point p = picTimeLine->PointToScreen(Point(e->X - 12, e->Y - 12));
					panCenter->Width = 24;
					panCenter->Height = 24;
					panCenter->Left = p.X;
					panCenter->Top = p.Y;
					panCenter->Show();
					ShowMe();
					picTimeLine->Cursor = Cursors::NoMove2D;
					panScrollReady = true;
				}
			} else {
				PanScrollStop();
				bool PatternClicked = false;
				patternResizing = false;//true=p^[̃TCY
				for (int i = selectedModel->Patterns->Count - 1; i >= 0; i--) {//p^[̑I
					Pattern^ pat = safe_cast<Pattern^>(selectedModel->Patterns[i]);
					if (e->X >= pat->Left && e->X <= pat->Right && e->Y >= pat->Top && e->Y <= pat->Bottom
								&& selectedModel->Top + 1 < e->Y && e->Y < selectedModel->Bottom - 5) {
						//p^[NbNƂ
						PatternClicked = true;
						bool removeSelectedPattern = false;
						if (e->Button == System::Windows::Forms::MouseButtons::Right) {//ENbN̂Ƃ
							if (pat->Selected) {//̃p^[IԂ̂Ƃ
								//Ȃ
							} else {//̃p^[IԂ̂Ƃ
								//̃p^[݂̂I
								selectedPatterns->Clear();
								selectedPatterns->AddPattern(pat);
							}
							//ŌɃNbNp^[̐ݒ
							selectedPattern = pat;
							selectedPatternIndex  = i;
						} else if (e->Button == System::Windows::Forms::MouseButtons::Left) {//NbN̂Ƃ
							if ((key & Keys::Control) == Keys::Control) {//Ctrl+NbN̂Ƃ
								if (pat->Selected) {//̃p^[IԂ̂Ƃ
									//̃p^[̑I
									selectedPatterns->RemovePattern(pat);
									removeSelectedPattern = true;
									//̃p^[͍ŌɃNbNp^[Aɂ͂ȂB
									//selectedPattern = pat;
									//selectedPatternIndex  = i;
								} else {//̃p^[IԂ̂Ƃ
									//̃p^[Iɉ
									selectedPatterns->AddPattern(pat);
									//ŌɃNbNp^[̐ݒ
									selectedPattern = pat;
									selectedPatternIndex  = i;
								}
							} else if ((key & Keys::Shift) == Keys::Shift) {//Shift+NbN̂Ƃ
								/*
								if (pat->Selected) {//̃p^[IԂ̂Ƃ
									//ONbNp^[AIp^[܂ł͈͑IB
								} else {//̃p^[IԂ̂Ƃ
									//ONbNp^[AIp^[܂ł͈͑IB
								}
								*/
								//ǂ̏ꍇłAONbNp^[AIp^[܂ł͈͑IB
								//(GNXv[[Shift+NbN̑ɏAIׂĉAONbNƂ납
								//Ip^[܂ł͈͑IBIp^[́uŌɃNbNp^[vɂȂB)
								selectedPatterns->Clear();
								//ONbNp^[̓̎ԈʒuANbNp^[̓̎Ԉʒu܂ł͈͑IB
								//fɓn͈͑IB
								int left = selectedPattern->Left;
								int right = pat->Left;
								if (left > right) {//left <= right ɂȂ悤ɓւB
									int w = left;
									left = right;
									right = w;
								}
								int top = selectedPattern->Model->Top;
								int bottom = pat->Model->Top;
								if (top > bottom) {//top <= bottom ɂȂ悤ɓւB
									int w = top;
									top = bottom;
									bottom = w;
								}
								//Sf̑Sp^[ɂāA͈͓ǂ𔻒
								for (int i = 1; i < timeline->Models->Count; i++) {//gm[͏
									Model^ model = safe_cast<Model^>(timeline->Models[i]);
									for (int j = 0; j < model->Patterns->Count; j++) {
										Pattern^ pattern = safe_cast<Pattern^>(model->Patterns[j]);
										if (pattern->Left >= left && pattern->Left <= right) {//p^[̓I͈͓ɂꍇ
											if (pattern->Model->Top >= top && pattern->Model->Top <= bottom) {//fI͈͓ɂꍇ
												selectedPatterns->AddPattern(pattern);//Iɒǉ
											}
										}
									}
								}
							} else {//̑̂Ƃ(ʏ̃NbN̂Ƃ܂)
								if (pat->Selected) {//̃p^[IԂ̂Ƃ
									//Ȃ
								} else {//̃p^[IԂ̂Ƃ
									//IׂĉāÃp^[̂ݑIԂɂB
									selectedPatterns->Clear();
									selectedPatterns->AddPattern(pat);
								}
								//ŌɃNbNp^[̐ݒ
								selectedPattern = pat;
								selectedPatternIndex  = i;
								if (e->X >= pat->Right - 4) {//p^[̉E[Ƀ}EXJ[\Ƃ
									patternResizing = true;//p^[̃TCY
								}
							}
						//} else {//`({^NbNƂ)
						}

						//hbȌ
						mouseDY = selectedPatterns->Top - mouseDownY;
						mouseDX = selectedPatterns->Left - mouseDownX;
						if (removeSelectedPattern) {//Ctrl+NbNɂăp^[IOꍇ
							patternMoving = false;
						} else {//NbNp^[IԂɂƂ
							if (patternResizing) {//p^[̃TCŶƂ
								patternMoving = false;
								beginMoving = false;
								picModelName->Cursor = Cursors::SizeWE;
							} else {
								patternMoving = true;
								beginMoving = false;
								picModelName->Cursor = Cursors::SizeAll;
							}

							//hbOp^C}[Jn
							timerTimeLineDrag->Enabled = true;

							//j[̗L
							this->menuItemMoveToTop->Enabled = true;
							this->menuItemMoveToBottom->Enabled = true;
							this->menuItemViewMoveToTop->Enabled = true;
							this->menuItemViewMoveToBottom->Enabled = true;
							this->menuItemDeletePattern->Enabled = true;
							this->menuItemEditDeletePattern->Enabled = true;
							this->menuItemEditPattern->Enabled = true;
							this->menuItemEditEditPattern->Enabled = true;
							this->menuItemCutPattern->Enabled = true;
							this->menuItemCopyPattern->Enabled = true;
							this->menuItemEditCutPattern->Enabled = true;
							this->menuItemEditCopyPattern->Enabled = true;
						}

						//j[̗L
						this->menuItemSaveModelVMD->Enabled = true;
						this->menuItemFileSaveModelVMD->Enabled = true;

						//[v𔲂
						break;
					}
				}
				if (true || !PatternClicked) {//NbNƂ̃p^[ȂƂA(: Ƀ|WVړ)
					//|WV̈ړ
					int tick = (int)System::Math::Round((double)timeline->smf->MaxTick * (double)e->X / (double)picGauge->Width);
					position->GlobalTick = tick;

					if ((key & Keys::Control) == Keys::Control) {//Ctrl+NbN̂Ƃ
						//NbNʒu𔏂̓ɍ킹B
						position->Tick = 0;
					} else if (this->toolBtnGrid->CheckState == System::Windows::Forms::CheckState::Checked) {//Obhɍ킹B
						int grid = (1 << this->toolCmdGrid->SelectedIndex);
						double step = (double)timeline->smf->Header.DeltaTime / (double)grid;
						if (config->Edit->GridClickOnLine) {
							position->Tick = (int)System::Math::Round((int)System::Math::Round(position->Tick / step) * step);
						} else {
							position->Tick = (int)System::Math::Round(int(position->Tick / step) * step);
						}
					}
					if (!PatternClicked) {//NbNƂ̃p^[ȂƂA
						mouseDownX = lastTimeLineMouseDownX = (int)System::Math::Round(position->GlobalTick * timeline->PixelsPerTick());
					}

					txtPosition->Text = position->ToString();
					lblDeltaTime->Text = String::Format("/{0:D}", timeline->smf->Header.DeltaTime * 4 / position->BeatInfo->dd);
				}
				if (!PatternClicked) {//NbNƂ̃p^[ȂƂA
					selectedPatterns->Clear();//Iׂĉ
					selecting = true;//hbOɂ͈͑IJn
					//hbOp^C}[Jn
					timerTimeLineDrag->Enabled = true;
				}
			}

			picTimeLine->Refresh();
		}

	private:
		System::Void menuItemInsertBeat_Click(System::Object^  sender, System::EventArgs^  e) {//q̑}
			SMF::Position^ pos = gcnew SMF::Position(timeline->smf);
			pos->GlobalTick = timeline->smf->MaxTick - 1;

			SetBeatDialog^ dlg = gcnew SetBeatDialog();
			dlg->updownMeasureControl->Minimum = 1;
			dlg->updownMeasureControl->Maximum = pos->Measure;//Ō̏
			dlg->updownMeasureControl->Value = position->Measure;

			System::Windows::Forms::DialogResult result = dlg->ShowDialog();

			if (result == System::Windows::Forms::DialogResult::OK) {
				bool cancel = false;
				int i;
				pos->Measure = dlg->Measure;//w肳ꂽ
				pos->Beat = 1;
				pos->Tick = 0;

				//qύXe[uւ̑}
				SMF::Beat^ beat = gcnew SMF::Beat();
				beat->SetBeat(dlg->BeatNN, dlg->BeatDD, 24 * 4 / dlg->BeatDD, 8);
				SMF::BeatChange^ bc = gcnew SMF::BeatChange(beat, 0);
				bc->Measure = pos->Measure;
				bc->Tick = pos->GlobalTick;
				int c = timeline->smf->BeatChanges->Count;
				for (i = 0; i < c; i++) {
					SMF::BeatChange^ dat_bc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[i]);
					if (dat_bc->Tick == bc->Tick) {//}̈ʒuɊɔqύX݂Ăꍇ
						if (MessageBox::Show(String::Format("{0:D}ߖڂɊ{1:D}/{2:D}qݒ肳Ă܂B\n"
															+ "{3:D}/{4:D}qɕύX܂H",
															pos->Measure, dat_bc->BeatInfo->nn, dat_bc->BeatInfo->dd,
															bc->BeatInfo->nn, bc->BeatInfo->dd), "qύX̏㏑mF",
															MessageBoxButtons::YesNo) == System::Windows::Forms::DialogResult::Yes) {
							ReplaceBeat(0, i, bc);//qύXu
							//timeline->smf->BeatChanges[i] = bc;//qύXu
						}
						break;
					} else if (dat_bc->Tick > bc->Tick) {
						InsertBeat(0, i, bc);//}
						//timeline->smf->BeatChanges->Insert(i, bc);//}
						break;
					}
				}
				if (i == c) {//}ȂƂ
					AddBeat(0, bc);//ǉ
					//timeline->smf->BeatChanges->Add(bc);//ǉ
				}

			}
			ShowMe();
		}

	private:
		System::Void menuItemInsertTempo_Click(System::Object^  sender, System::EventArgs^  e) {//e|̑}
			SMF::Position^ pos = gcnew SMF::Position(timeline->smf);
			pos->GlobalTick = timeline->smf->MaxTick - 1;

			SetTempoDialog^ dlg = gcnew SetTempoDialog();
			dlg->smf = timeline->smf;
			//
			dlg->updownBeatControl->Maximum = position->BeatInfo->dd;
			dlg->updownBeatControl->Value = position->Beat;
			//tick
			dlg->updownTickControl->Maximum = timeline->smf->Header.DeltaTime * 4 / position->BeatInfo->dd;
			dlg->updownTickControl->Value = position->Tick;//\240̏ꍇA0`239
			dlg->lblTickControl->Text = "/" + dlg->updownTickControl->Maximum.ToString();
			//
			dlg->updownMeasureControl->Maximum = pos->Measure;//Ō̏
			dlg->updownMeasureControl->Value = position->Measure;

			System::Windows::Forms::DialogResult result = dlg->ShowDialog();

			if (result == System::Windows::Forms::DialogResult::OK) {
				int i;
				pos->Measure = dlg->Measure;//w肳ꂽ
				pos->Beat = dlg->Beat;//w肳ꂽ
				pos->Tick = dlg->Tick;//w肳ꂽtick

				//e|ύXe[uւ̑}
				SMF::TempoChange^ tc = gcnew SMF::TempoChange();
				tc->Tick = pos->GlobalTick;
				tc->Track = 0;
				tc->Tempo = dlg->Tempo;//w肳ꂽe|
				int c = timeline->smf->TempoChanges->Count;
				for (i = 0; i < c; i++) {
					SMF::TempoChange^ dat_tc = safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[i]);
					if (dat_tc->Tick == tc->Tick) {//̈ʒuɊɃe|`FW݂ꍇ
						if (MessageBox::Show(String::Format("ʒu{0}ɊɃe|={1:F}ݒ肳Ă܂B\n"
															+ "e|={2:F}ɕύX܂H",
															pos->ToString(), dat_tc->Tempo, tc->Tempo), "e|̏㏑mF",
															MessageBoxButtons::YesNo) == System::Windows::Forms::DialogResult::Yes) {
							ReplaceTempo(0, i, tc);
							//timeline->Changed = true;
						}
						break;
					} else if (dat_tc->Tick > tc->Tick) {
						InsertTempo(0, i, tc);
						//timeline->Changed = true;
						break;
					}
				}
				System::Diagnostics::Debug::Assert(i < c, "zǑ([v͕K break; Ŕ͂B)");
				//timeline->smf->CalcFrameAtTempoTable();//e|e[ũt[̍XV

			}
			ShowMe();
		}

	private:
		System::Void TimeLineForm_Activated(System::Object^  sender, System::EventArgs^  e) {
			splitTimeLine->Focus();
			MergeToolbar();//c[o[̌
		}

	private:
		System::Void TimeLineForm_Deactivate(System::Object^  sender, System::EventArgs^  e) {
			PanScrollStop();
			RevertMergeToolbar();//c[o[̌̉
		}

	public:
		System::Void UpdateTimeLine() {//f[^\Ȃ
			picTimeLine->Refresh();
			picGauge->Refresh();
			picModelName->Refresh();
		}

	private:
		System::Void menuItemEditAddModel_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemAddModel_Click(sender, e);
		}

	private:
		System::Void menuItemEditDeleteModel_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemDeleteModel_Click(sender, e);
		}

	private:
		System::Void menuItemEditModelNameChange_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemModelNameChange_Click(sender, e);
		}

	private:
		System::Void menuItemEditInsertBeat_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemInsertBeat_Click(sender, e);
		}

	private:
		System::Void menuItemEditInsertTempo_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemInsertTempo_Click(sender, e);
		}

	private:
		System::Void menuItemOpenVPD_Click(System::Object^  sender, System::EventArgs^  e) {//VPDǍ
			OpenVPD(sender, e, position);
		}

	private:
		System::Void menuItemFileOpenVPD_Click(System::Object^  sender, System::EventArgs^  e) {
			OpenVPD(sender, e, position);
		}

	private:
		System::Void OpenVPD(System::Object^  sender, System::EventArgs^  e, SMF::Position^ loadPos) {//loadPos̈ʒuɃ|[Yf[^ǂݍނ߂̃_CAO\B
			OpenVPD(sender, e, loadPos, nullptr);
		}

	private:
		System::Void OpenVPD(System::Object^  sender, System::EventArgs^  e, SMF::Position^ loadPos, String^ filename) {//loadPos̈ʒuɃ|[Yf[^ǂݍނ߂̃_CAO\Bt@Cw肾ƎœǂݍށB
			SMF::Position^ pos_last = gcnew SMF::Position(timeline->smf);
			pos_last->GlobalTick = timeline->smf->MaxTick - 1;

			SMF::Position^ pos_end = gcnew SMF::Position(timeline->smf);
			pos_end->GlobalTick = loadPos->GlobalTick + timeline->smf->Header.DeltaTime * 4 / loadPos->BeatInfo->dd;//ftHg=|[Y1̊Ԏ()

			PoseDataDialog^ dlg = gcnew PoseDataDialog();
			dlg->timeline = timeline;
			dlg->config = config;

			if (filename != nullptr) {
				dlg->OpenVPD(filename);
			}

			//|[YJnʒu
			//
			dlg->updownBeginBeatControl->Maximum = loadPos->BeatInfo->dd;
			dlg->updownBeginBeatControl->Value = loadPos->Beat;
			//tick
			dlg->updownBeginTickControl->Maximum = timeline->smf->Header.DeltaTime * 4 / loadPos->BeatInfo->dd;
			dlg->updownBeginTickControl->Value = loadPos->Tick;//\240̏ꍇA0`239
			dlg->lblBeginTickControl->Text = "/" + dlg->updownBeginTickControl->Maximum.ToString();
			//JԂԊu1tick͂Ƃ肠AJnʒu1tickɂ킹B
			dlg->lblRepeatTickControl->Text = "/" + dlg->updownBeginTickControl->Maximum.ToString();
			//
			dlg->updownBeginMeasureControl->Maximum = pos_last->Measure;//Ō̏
			dlg->updownBeginMeasureControl->Value = loadPos->Measure;

			//|[YIʒu
			//
			dlg->updownEndBeatControl->Maximum = pos_end->BeatInfo->dd;
			dlg->updownEndBeatControl->Value = pos_end->Beat;
			//tick
			dlg->updownEndTickControl->Maximum = timeline->smf->Header.DeltaTime * 4 / pos_end->BeatInfo->dd;
			dlg->updownEndTickControl->Value = pos_end->Tick;//\240̏ꍇA0`239
			dlg->lblEndTickControl->Text = "/" + dlg->updownEndTickControl->Maximum.ToString();
			//
			dlg->updownEndMeasureControl->Maximum = pos_last->Measure;//Ō̏
			dlg->updownEndMeasureControl->Value = pos_end->Measure;

			if (dlg->ShowDialog() == System::Windows::Forms::DialogResult::OK) {
				//TODO: VPDf[^\t
				Pattern^ pat = dlg->pattern;

				pat->ModelName = selectedModel->Name->Copy();
				//pat->smf = timeline->smf;
				pat->timeline = timeline;

				//p^[f[^̍Wݒ
				if (sender == menuItemOpenVPD || sender == picTimeLine) {//ENbNj[A܂picTimeLineւD&D
					pat->Top = lastTimeLineMouseDownY;
				} else {//t@Cj[
					pat->Top = selectedModel->Top + 10;//()
				}
				pat->Height = 30;//()

				Exec(gcnew Edit::OpenVPD(this, timeline, selectedModel, pat));
				/*
				selectedModel->AddPattern(pat);

				timeline->Changed = true;

				picTimeLine->Refresh();
				*/
			}
		}

	private:
		System::Void menuItemMoveToTop_Click(System::Object^  sender, System::EventArgs^  e) {//őOʂֈړ
			if (selectedPattern != nullptr) {
				selectedModel->Patterns->RemoveAt(selectedPatternIndex);
				selectedModel->AddPattern(selectedPattern);
				selectedPatternIndex = selectedModel->Patterns->Count - 1;
				timeline->Changed = true;
				picTimeLine->Refresh();
			}
		}

	private:
		System::Void menuItemMoveToBottom_Click(System::Object^  sender, System::EventArgs^  e) {//Ŕwʂֈړ
			if (selectedPattern != nullptr) {
				selectedModel->Patterns->RemoveAt(selectedPatternIndex);
				selectedModel->Patterns->Insert(0, selectedPattern);
				selectedPatternIndex = 0;
				timeline->Changed = true;
				picTimeLine->Refresh();
			}
		}

	private:
		System::Void menuItemViewMoveToTop_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemMoveToTop_Click(sender, e);//őOʂֈړ
		}

	private:
		System::Void menuItemViewMoveToBottom_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemMoveToBottom_Click(sender, e);//Ŕwʂֈړ
		}

	private:
		System::Void menuItemDeletePattern_Click(System::Object^  sender, System::EventArgs^  e) {//p^[̍폜
			if (selectedPatterns->Count > 0) {

				Exec(gcnew Edit::PatternDelete(this, timeline, selectedPatterns));
				/*
				for (int i = 0; i < selectedPatterns->Count; i++) {
					Pattern^ pat = selectedPatterns->GetPatternAt(i);
					pat->Model->Patterns->Remove(pat);
				}
				*/

				//p^[Ỉ
				//selectedPatterns->Clear();
				this->menuItemDeletePattern->Enabled = false;
				this->menuItemEditDeletePattern->Enabled = false;
				this->menuItemCutPattern->Enabled = false;
				this->menuItemCopyPattern->Enabled = false;
				this->menuItemEditCutPattern->Enabled = false;
				this->menuItemEditCopyPattern->Enabled = false;

				selectedPattern = nullptr;
				selectedPatternIndex = 0;
				timeline->Changed = true;
				picTimeLine->Refresh();
			}
		}

	private:
		System::Void menuItemEditDeletePattern_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemDeletePattern_Click(sender, e);//p^[̍폜
		}

	private:
		System::Void menuItemSaveModelVMD_Click(System::Object^  sender, System::EventArgs^  e) {//If̃[Vf[^ۑ
			saveFileDialog1->InitialDirectory = config->Path->MMD_Motion;
			saveFileDialog1->Filter = "Vocaloid Pattern Data files|*.vmd|ׂẴt@C|*.*";
			saveFileDialog1->Title = "[Vf[^ۑ";
			saveFileDialog1->FileName = "";
			if(saveFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::OK) {
				if (selectedModelIndex == 0) {//gm[̏ꍇ
					SaveMetronomeMotion(saveFileDialog1->FileName);
				} else {//̑̃f̏ꍇ
					selectedModel->SaveVMD(saveFileDialog1->FileName);
				}
			}
		}

	private:
		System::Void menuItemFileSaveModelVMD_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemSaveModelVMD_Click(sender, e);//If[^̃[Vf[^ۑ
		}

	private:
		System::Void menuItemEditPattern_Click(System::Object^  sender, System::EventArgs^  e) {//p^[ҏW
			SMF::Position^ pos_last = gcnew SMF::Position(timeline->smf);
			pos_last->GlobalTick = timeline->smf->MaxTick - 1;

			Pattern^ old_pattern = selectedPattern->Copy();

			PoseDataDialog^ dlg = gcnew PoseDataDialog();
			dlg->timeline = timeline;
			dlg->config = config;
			dlg->pattern = selectedPattern;

			//VPDt@C
			dlg->txtVPDFileControl->Text = selectedPattern->vpd->FileName;

			//|[YJnʒu
			//
			dlg->updownBeginBeatControl->Maximum = selectedPattern->Begin->BeatInfo->dd;
			dlg->updownBeginBeatControl->Value = selectedPattern->Begin->Beat;
			//tick
			int max = timeline->smf->Header.DeltaTime * 4 / selectedPattern->Begin->BeatInfo->dd;
			dlg->updownBeginTickControl->Maximum = max - 1;
			dlg->updownBeginTickControl->Value = selectedPattern->Begin->Tick;
			dlg->lblBeginTickControl->Text = "/" + max.ToString();
			//
			dlg->updownBeginMeasureControl->Maximum = pos_last->Measure;//Ō̏
			dlg->updownBeginMeasureControl->Value = selectedPattern->Begin->Measure;
			//tick,t[炵
			dlg->txtBeginShiftTickControl->Text = selectedPattern->Begin->ShiftTick.ToString();
			dlg->txtBeginShiftFrameControl->Text = selectedPattern->Begin->ShiftFrame.ToString();

			//[
			dlg->checkNoLengthControl->Checked = selectedPattern->NoLength;

			//|[YIʒu
			//
			dlg->updownEndBeatControl->Maximum = selectedPattern->End->BeatInfo->dd;
			dlg->updownEndBeatControl->Value = selectedPattern->End->Beat;
			//tick
			max = timeline->smf->Header.DeltaTime * 4 / selectedPattern->End->BeatInfo->dd;
			dlg->updownEndTickControl->Maximum = max - 1;
			dlg->updownEndTickControl->Value = selectedPattern->End->Tick;
			dlg->lblEndTickControl->Text = "/" + max.ToString();
			//
			dlg->updownEndMeasureControl->Maximum = pos_last->Measure;//Ō̏
			dlg->updownEndMeasureControl->Value = selectedPattern->End->Measure;
			//tick,t[炵
			dlg->txtEndShiftTickControl->Text = selectedPattern->End->ShiftTick.ToString();
			dlg->txtEndShiftFrameControl->Text = selectedPattern->End->ShiftFrame.ToString();

			//JԂԊu(߁EEtickStepɁA{Beginɂ킹)
			//
			dlg->updownRepeatBeatControl->Maximum = selectedPattern->Begin->BeatInfo->dd;
			dlg->updownRepeatBeatControl->Value = selectedPattern->Step->Beat;
			//tick
			max = timeline->smf->Header.DeltaTime * 4 / selectedPattern->Begin->BeatInfo->dd;
			dlg->updownRepeatTickControl->Maximum = max - 1;
			dlg->updownRepeatTickControl->Value = selectedPattern->Step->Tick;
			dlg->lblRepeatTickControl->Text = "/" + max.ToString();
			//
			dlg->updownRepeatMeasureControl->Maximum = pos_last->Measure;//Ō̏
			dlg->updownRepeatMeasureControl->Value = selectedPattern->Step->Measure;

			//JԂ
			dlg->txtRepeatControl->Text = selectedPattern->Repeat.ToString();

			if (dlg->ShowDialog() == System::Windows::Forms::DialogResult::OK) {
				//TODO: VPDf[^\t
				Pattern^ pat = dlg->pattern;
				
				//p^[f[^̍Wݒ
				pat->Height = 30;//()

				//p^[̌JԂ݂̏Iʒu̎Zo
				pat->UpdateRectangle();

				Exec(gcnew Edit::PatternEdit(this, timeline, selectedModel, selectedPatternIndex, old_pattern, pat));
				/*
				selectedModel->Patterns[selectedPatternIndex] = pat;

				timeline->Changed = true;//()[OK]ύXƂ݂ȂB

				picTimeLine->Refresh();
				*/
			}
		}

	private:
		System::Void menuItemEditEditPattern_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemEditPattern_Click(sender, e);//p^[ҏW
		}

	private:
		System::Void menuItemCutPattern_Click(System::Object^  sender, System::EventArgs^  e) {//p^[̃Jbg
			copyBuffer->Clear();
			for (int i = 0; i < selectedPatterns->Count; i++) {
				Pattern^ pat = selectedPatterns->GetPatternAt(i);
				copyBuffer->AddPattern(pat);
				//pat->Model->Patterns->Remove(pat);
			}

			this->menuItemPastePattern->Enabled = true;
			this->menuItemEditPastePattern->Enabled = true;

			Exec(gcnew Edit::PatternCut(this, timeline, selectedPatterns));

			//p^[Ỉ
			//selectedPatterns->Clear();
			this->menuItemDeletePattern->Enabled = false;
			this->menuItemEditDeletePattern->Enabled = false;
			this->menuItemCutPattern->Enabled = false;
			this->menuItemCopyPattern->Enabled = false;
			this->menuItemEditCutPattern->Enabled = false;
			this->menuItemEditCopyPattern->Enabled = false;

			timeline->Changed = true;
			picTimeLine->Refresh();
		}

	private:
		System::Void menuItemCopyPattern_Click(System::Object^  sender, System::EventArgs^  e) {//p^[̃Rs[
			copyBuffer->Clear();
			for (int i = 0; i < selectedPatterns->Count; i++) {
				Pattern^ pat = selectedPatterns->GetPatternAt(i)->Copy();
				copyBuffer->AddPattern(pat);
			}

			this->menuItemPastePattern->Enabled = true;
			this->menuItemEditPastePattern->Enabled = true;
		}

	private:
		System::Void menuItemPastePattern_Click(System::Object^  sender, System::EventArgs^  e) {//p^[̃y[Xg
			//Rs[obt@̌̊Jnʒu̎Zo
			SMF::Position^ patPos0 = gcnew SMF::Position(timeline->smf);
			int minTick = (int)System::Math::Round((double)(copyBuffer->Right * timeline->smf->MaxTick) / (double)picTimeLine->Width);

			//fg[ʒuAсAԍ̃p^[̊Jnʒǔ
			for (int i = 0; i < copyBuffer->Count; i++) {
				Pattern^ pat = copyBuffer->GetPatternAt(i);
				if (minTick > pat->Begin->GlobalTick) {
					minTick = pat->Begin->GlobalTick;
				}
			}
			patPos0->GlobalTick = minTick;

			int moveTick = position->GlobalTick - patPos0->GlobalTick;

			bool multi_model = (copyBuffer->MultiModel() || selectedModel == nullptr);//IfȂꍇ́AfIƓɂB
			ArrayList^ patterns = gcnew ArrayList();
			for (int i = 0; i < copyBuffer->Count; i++) {
				Pattern^ pattern = copyBuffer->GetPatternAt(i)->Copy();

				/*
				pattern->Left = lastTimeLineMouseDownX + (pattern->Left - copyBuffer->Left);
				*/
				if (!multi_model) {//Pꃂf݂̂̏ꍇ̓NbNʒuɓ\tB
					pattern->Top = lastTimeLineMouseDownY + (pattern->Top - copyBuffer->Top);
				} else {//f܂܂ꍇAcʒu͌ŒB
					//ȂɂȂB
				}

				pattern->Begin->GlobalTick += moveTick;
				pattern->End->GlobalTick += moveTick;

				patterns->Add(pattern);
				/*
				if (multi_model) {//f̃p^[܂܂ꍇA܂͑IfȂꍇ
					pattern->Model->AddPattern(pattern);//̃fƓfɓ\t
				} else {//Pꃂf̃p^[̂݊܂܂ꍇ
					selectedModel->AddPattern(pattern);//Iꂽfɓ\t
				}
				*/
			}
			if (selectedModel != nullptr) {
				SelectPatternMenuUpdate(selectedModel);//ׂẴp^[Ĩj[̗L̍XV
			}

			Exec(gcnew Edit::PatternPaste(this, timeline, selectedModel, patterns, multi_model));
			/*
			timeline->Changed = true;

			picTimeLine->Refresh();
			*/
		}

	private:
		System::Void menuItemEditCutPattern_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemCutPattern_Click(sender, e);
		}

	private:
		System::Void menuItemEditCopyPattern_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemCopyPattern_Click(sender, e);
		}

	private:
		System::Void menuItemEditPastePattern_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemPastePattern_Click(sender, e);
		}

	private:
		System::Void TimeLineForm_KeyDown(System::Object^  sender, System::Windows::Forms::KeyEventArgs^  e) {//V[gJbgL[̏
			if (!txtInputName->Visible) {//f͒łȂƂ
				if (!txtPosition->Focused) {//txtPosition ɃtH[JXȂƂ
					if (menuItemCutPattern->Enabled && e->Control && e->KeyCode == Keys::X) {//Ctrl+X
						menuItemCutPattern_Click(sender, e);//p^[̃Jbg
					} else if (menuItemCopyPattern->Enabled && e->Control && e->KeyCode == Keys::C) {//Ctrl+C
						menuItemCopyPattern_Click(sender, e);//p^[̃Rs[
					} else if (menuItemPastePattern->Enabled && e->Control && e->KeyCode == Keys::V) {//Ctrl+V
						menuItemPastePattern_Click(sender, e);//p^[̃y[Xg
					} else if (menuItemDeletePattern->Enabled && e->KeyCode == Keys::Delete) {//Del
						menuItemDeletePattern_Click(sender, e);//p^[̍폜
					} else if (e->Control && e->KeyCode == Keys::M) {//Ctrl+M
						menuItemAddModel_Click(sender, e);//fǉ
					//} else if (e->Control && e->KeyCode == Keys::Z) {//Ctrl+Z(ɖ߂)
					//	Undo();
					//} else if (e->Control && e->KeyCode == Keys::Y) {//Ctrl+Y(蒼)
					//	Redo();
					} else if (e->KeyCode == Keys::Right) {//L[(ԈʒuɈړ)
						if (e->Shift) {//͈͑I
							if (selStartPosition == nullptr) {
								selStartPosition = position->Copy();
							}
						} else {
							selStartPosition = nullptr;//ShiftL[Ɣ͈͑I
						}
						if (e->Control) {//Ctrl
							if (position->Tick > 0) {
								position->Tick = 0;
							}
							position->GlobalTick += position->DeltaTime;
						} else if (this->toolBtnGrid->CheckState == System::Windows::Forms::CheckState::Checked) {//Obhɍ킹B
							int grid = (1 << this->toolCmdGrid->SelectedIndex);
							double step = (double)timeline->smf->Header.DeltaTime / (double)grid;
							double unit = (double)position->Tick / step;
							double mod = (unit - int(unit)) * step;
							//position->Tick = (int)System::Math::Round(position->Tick - mod + step);
							position->GlobalTick = (int)System::Math::Round(int(((double)position->GlobalTick + step + 1) / step) * step);
						} else {
							position->GlobalTick++;
						}
						if (position->GlobalTick > timeline->smf->MaxTick) {
							//Ȃ̒L΂
							Exec(gcnew Edit::SetSongLength(this, timeline, position->GlobalTick));
							/*
							timeline->smf->MaxTick = position->GlobalTick;
							SetPicTimeLineWidth();
							UpdateSongLength();//MIDIf[^EBhE̋Ȓ̕\̍XV
							timeline->Changed = true;
							*/
						}
						SetPosition(position);
						txtPosition->Text = position->ToString();
						SelectPatternsByCursor();
						picTimeLine->Refresh();
					} else if (e->KeyCode == Keys::Left) {//L[(ԈʒuOɈړ)
						if (e->Shift) {//͈͑I
							if (selStartPosition == nullptr) {
								selStartPosition = position->Copy();
							}
						} else {
							selStartPosition = nullptr;//ShiftL[Ɣ͈͑I
						}
						if (e->Control) {//Ctrl
							if (position->GlobalTick > 0) {
								if (position->Tick == 0) {
									position->GlobalTick--;
								}
								position->Tick = 0;
							}
						} else if (this->toolBtnGrid->CheckState == System::Windows::Forms::CheckState::Checked) {//Obhɍ킹B
							int grid = (1 << this->toolCmdGrid->SelectedIndex);
							double step = (double)timeline->smf->Header.DeltaTime / (double)grid;
							double unit = (double)position->Tick / step;
							double mod = (unit - int(unit)) * step;
							if (int(mod) == 0) {
								position->GlobalTick = (int)System::Math::Round(position->GlobalTick - step);
							}
							position->Tick = (int)System::Math::Round(position->Tick - mod);
						} else {
							if (position->GlobalTick > 0) {
								position->GlobalTick--;
							}
						}
						SetPosition(position);
						txtPosition->Text = position->ToString();
						SelectPatternsByCursor();
						picTimeLine->Refresh();
					} else if (e->KeyCode == Keys::Home) {//HomeL[(Ȃ̐擪Ɉړ)
						if (e->Shift) {//͈͑I
							if (selStartPosition == nullptr) {
								selStartPosition = position->Copy();
							}
						} else {
							selStartPosition = nullptr;//ShiftL[Ɣ͈͑I
						}
						position->GlobalTick = 0;
						SetPosition(position);
						txtPosition->Text = position->ToString();
						SelectPatternsByCursor();
						picTimeLine->Refresh();
					} else if (e->KeyCode == Keys::End) {//EndL[(Ȃ̍ŌɈړ)
						if (e->Shift) {//͈͑I
							if (selStartPosition == nullptr) {
								selStartPosition = position->Copy();
							}
						} else {
							selStartPosition = nullptr;//ShiftL[Ɣ͈͑I
						}
						position->GlobalTick = timeline->smf->MaxTick;
						SetPosition(position);
						txtPosition->Text = position->ToString();
						SelectPatternsByCursor();
						picTimeLine->Refresh();
					} else if (e->KeyCode == Keys::Up) {//L[(fI)
						if (selectedModel == nullptr) {
							selectedModelIndex = 0;
						}
						if (!e->Control) {//CtrlȂ(fI)
							if (selectedModelIndex > 0) {
								selectedModelIndex--;
							}
						}
						selectedModel = safe_cast<Model^>(timeline->Models[selectedModelIndex]);
						lastTimeLineMouseDownY = selectedModel->Top + 10;
						if (e->Control) {//Ctrl(fgύX)
							if (selectedModel->Height > 60) {
								selectedModel->Height -= 50;
								ModelLayout();
								picTimeLine->Refresh();
							}
						}
						ModelSelect(lastTimeLineMouseDownY, false, false);
					} else if (e->KeyCode == Keys::Down) {//L[
						if (selectedModel == nullptr) {
							selectedModelIndex = 0;
						}
						if (!e->Control) {//CtrlȂ(fI)
							if (selectedModelIndex < timeline->Models->Count - 1) {
								selectedModelIndex++;
							}
						}
						selectedModel = safe_cast<Model^>(timeline->Models[selectedModelIndex]);
						lastTimeLineMouseDownY = selectedModel->Top + 10;
						if (e->Control) {//Ctrl(fgύX)
							if (selectedModelIndex > 0) {
								selectedModel->Height += 50;
								ModelLayout();
								picTimeLine->Refresh();
							}
						}
						ModelSelect(lastTimeLineMouseDownY, false, false);
					} else if (e->Control && e->KeyCode == Keys::A) {//Ctrl+A ̂ƂB
						//if (this->menuItemSelectAllPattern->Enabled) {
						if (selectedModel->Patterns->Count > 0) {//Ifɉp^[݂ꍇ
							SelectAllPatterns(selectedModel, Patterns::ALL);//Ifׂ̂Ẵp^[I
						}
					}
				}
			}
		}

	private:
		System::Void SelectPatternsByCursor() {//J[\L[ɂ͈͑I
			if (selStartPosition != nullptr) {//J[\L[ɂÏ̕\
				selectedPatterns->Clear();//Ỉ
				if (selStartPosition->GlobalTick != position->GlobalTick) {//I͈͂̕[̂Ƃ͑IȂ
					//ׂẴfΏۂƂ()
					for (int i = 0; i < timeline->Models->Count; i++) {
						Model^ model = safe_cast<Model^>(timeline->Models[i]);
						for (int j = 0; j < model->Patterns->Count; j++) {
							Pattern^ pat = safe_cast<Pattern^>(model->Patterns[j]);
							int left = (int)System::Math::Round(selStartPosition->GlobalTick * timeline->PixelsPerTick());
							int right = (int)System::Math::Round(position->GlobalTick * timeline->PixelsPerTick());
							if (left > right) {
								int w = left;
								left = right;
								right = w;
							}
							//Jnʒuw͈͓̃p^[̂ݑI
							if (pat->Left >= left && pat->Left <= right) {
								selectedPatterns->AddPattern(pat);
							}
						}
					}
				}
				if (selectedPatterns->Count > 0) {//p^[IĂƂ
					this->menuItemDeletePattern->Enabled = true;
					this->menuItemEditDeletePattern->Enabled = true;
					this->menuItemCutPattern->Enabled = true;
					this->menuItemCopyPattern->Enabled = true;
					this->menuItemEditCutPattern->Enabled = true;
					this->menuItemEditCopyPattern->Enabled = true;
				} else {//p^[IĂȂƂ
					this->menuItemDeletePattern->Enabled = false;
					this->menuItemEditDeletePattern->Enabled = false;
					this->menuItemCutPattern->Enabled = false;
					this->menuItemCopyPattern->Enabled = false;
					this->menuItemEditCutPattern->Enabled = false;
					this->menuItemEditCopyPattern->Enabled = false;
				}
			}
		}

	private:
		System::Void txtPosition_KeyDown(System::Object^  sender, System::Windows::Forms::KeyEventArgs^  e) {//Position
			if (e->KeyCode == Keys::Enter) {//EnterL[͂̂Ƃ
				SMF::Position^ pos = gcnew SMF::Position(position->smf);
				array<String^>^ str = txtPosition->Text->Split(':');

				if (str[0]->Length > 0) {//
					pos->Measure = Int32::Parse(str[0]);
				}
				if (str->Length >= 2 && str[1]->Length > 0) {//
					pos->Beat = Int32::Parse(str[1]);
				}
				if (str->Length >= 3 && str[2]->Length > 0) {//tick
					pos->Tick = Int32::Parse(str[2]);
				}
				if (pos->Beat >= 1 && pos->Beat <= pos->MaxBeat && pos->Tick >= 0
							&& pos->Tick <= pos->MaxTick && pos->GlobalTick <= pos->smf->MaxTick) {
					SetPosition(pos);
					e->Handled = true;
				} else {
					MessageBox::Show(String::Format("Ԉʒu͂ԈĂ܂B{0}", pos->ToString()),
									"̓G[", System::Windows::Forms::MessageBoxButtons::OK);
				}

				txtPosition->Text = position->ToString();
				splitTimeLine->Focus();
			} else if (e->Control && e->KeyCode == Keys::A) {
				txtPosition->SelectAll();
				e->Handled = true;
			}
		}

	private:
		System::Void SetPosition(SMF::Position^ pos) {
			position = pos;

			int p = (int)System::Math::Round((double)(picTimeLine->Width * position->GlobalTick) / (double)timeline->smf->MaxTick);

			if (picTimeLine->Left + p < 0 || picTimeLine->Left + p > splitTimeLine->Panel2->ClientRectangle.Width) {//Ԉʒuʂ͈̔͊ÔƂ
				splitTimeLine->Panel2->AutoScrollPosition = Point(p - splitTimeLine->Panel2->Width / 2,
																	-splitTimeLine->Panel2->AutoScrollPosition.Y);
				picGauge->Left = picTimeLine->Left;
				picGauge->Refresh();
			}
			picTimeLine->Refresh();
		}

	private:
		System::Void txtPosition_KeyPress(System::Object^  sender, System::Windows::Forms::KeyPressEventArgs^  e) {//͕`FbN
			if (e->KeyChar != ':' && (e->KeyChar < '0' || e->KeyChar > '9')) {
				e->KeyChar = 0;
			}
		}

	private:
		System::Void txtPosition_Enter(System::Object^  sender, System::EventArgs^  e) {//tH[JX擾
			txtPosition->SelectAll();
		}

	private:
		System::Void timerTimeLineDrag_Tick(System::Object^  sender, System::EventArgs^  e) {//hbÕ^C}[Cxg
			if (patternMoving || selecting || dding || patternResizing) {
				bool doScroll = false;
				int pxl = 0;
				int pxr = 0;
				int pyt = 0;
				int pyb = 0;
				if (dding) {//D&DA}EXJ[\^CC̉ʂ̒[̕ɂƂ
					pxl = pyt = 30;//()
					pxr = pyb = 30 + 20;//()
				}
				int dx = 0;
				if (mouseMoveX < -splitTimeLine->Panel2->AutoScrollPosition.X + pxl) {//[͂ݏoƂ
					if (dding) {
						if (ddScrollCount > 0) {
							ddScrollCount--;
						}
						if (ddScrollCount == 0) {
							dx = - splitTimeLine->Panel2->Width / 10;
						}
					} else {
						dx = mouseMoveX - (-splitTimeLine->Panel2->AutoScrollPosition.X);
					}
					doScroll = true;
				} else if (mouseMoveX > -splitTimeLine->Panel2->AutoScrollPosition.X + splitTimeLine->Panel2->Width - pxr) {//E[͂ݏoƂ
					if (dding) {
						if (ddScrollCount > 0) {
							ddScrollCount--;
						}
						if (ddScrollCount == 0) {
							dx = splitTimeLine->Panel2->Width / 10;
						}
					} else {
						dx = mouseMoveX - (-splitTimeLine->Panel2->AutoScrollPosition.X + splitTimeLine->Panel2->Width);
					}
					doScroll = true;
				}
				//Ƃ肠㉺ւ̃hbOŁAp^[fgOɏô͂łȂAƂƂɂĂA
				//fg̍ƂĂLĎgƂ邩Ȃ̂ŁA㉺ւhbOŃXN[ł邱ƂɂĂB
				int dy = 0;
				if (mouseMoveY < -splitTimeLine->Panel2->AutoScrollPosition.Y + pyt) {//[͂ݏoƂ
					if (dding) {
						if (ddScrollCount > 0) {
							ddScrollCount--;
						}
						if (ddScrollCount == 0) {
							dy = - splitTimeLine->Panel2->Height / 10;
						}
					} else {
						dy = mouseMoveY - (-splitTimeLine->Panel2->AutoScrollPosition.Y);
					}
					doScroll = true;
				} else if (mouseMoveY > -splitTimeLine->Panel2->AutoScrollPosition.Y + splitTimeLine->Panel2->Height - pyb) {//[͂ݏoƂ
					if (dding) {
						if (ddScrollCount > 0) {
							ddScrollCount--;
						}
						if (ddScrollCount == 0) {
							dy = splitTimeLine->Panel2->Height / 10;
						}
					} else {
						dy = mouseMoveY - (-splitTimeLine->Panel2->AutoScrollPosition.Y + splitTimeLine->Panel2->Height);
					}
					doScroll = true;
				}

				if (doScroll) {
					splitTimeLine->Panel2->AutoScrollPosition = Point(-splitTimeLine->Panel2->AutoScrollPosition.X + dx,
																				-splitTimeLine->Panel2->AutoScrollPosition.Y + dy);
					picGauge->Left = picTimeLine->Left;
					picModelName->Top = picTimeLine->Top;
					picGauge->Refresh();
					picModelName->Refresh();
					picTimeLine->Refresh();
				} else {//XN[̕KvƂ
					if (dding) {//hbOhbv̂Ƃ
#ifdef PAINT_DEBUG
						this->SetStatusMessage(String::Format("dx={0},dy={1},count={2}",dx,dy,ddScrollCount));
#endif
						ddScrollCount = config->Edit->DnDScrollCount;
					}
				}
			} else if (panScrollDrag || panScrollFree && ScrollPic == picTimeLine) {//pXN[ŝƂ
				System::Drawing::Point p = picTimeLine->PointToScreen(Point(mouseMoveX, mouseMoveY));
				int dx = 0;
				if (p.X - (panScrollCenterPoint.X + 12) > 0) {
					dx = p.X - (panScrollCenterPoint.X + 12);
				} else if (p.X - (panScrollCenterPoint.X - 12) < 0) {
					dx = p.X - (panScrollCenterPoint.X - 12);
				}
				int dy = 0;
				if (p.Y - (panScrollCenterPoint.Y + 12) > 0) {
					dy = p.Y - (panScrollCenterPoint.Y + 12);
				} else if (p.Y - (panScrollCenterPoint.Y - 12) < 0) {
					dy = p.Y - (panScrollCenterPoint.Y - 12);
				}
				if (dy > 0) {
					if (dx > 0) {
						picTimeLine->Cursor = Cursors::PanSE;
					} else if (dx < 0) {
						picTimeLine->Cursor = Cursors::PanSW;
					} else {
						picTimeLine->Cursor = Cursors::PanSouth;
					}
				} else if (dy < 0) {
					if (dx > 0) {
						picTimeLine->Cursor = Cursors::PanNE;
					} else if (dx < 0) {
						picTimeLine->Cursor = Cursors::PanNW;
					} else {
						picTimeLine->Cursor = Cursors::PanNorth;
					}
				} else {
					if (dx > 0) {
						picTimeLine->Cursor = Cursors::PanEast;
					} else if (dx < 0) {
						picTimeLine->Cursor = Cursors::PanWest;
					} else {
						picTimeLine->Cursor = Cursors::NoMove2D;
					}
				}
				if (dx != 0 || dy != 0) {
					splitTimeLine->Panel2->AutoScrollPosition = Point(-splitTimeLine->Panel2->AutoScrollPosition.X + dx,
																				-splitTimeLine->Panel2->AutoScrollPosition.Y + dy);
					picGauge->Left = picTimeLine->Left;
					picModelName->Top = picTimeLine->Top;
					picGauge->Refresh();
					picModelName->Refresh();
					picTimeLine->Refresh();
				}
			}
		}

	private:
		System::Void picTimeLine_DragEnter(System::Object^  sender, System::Windows::Forms::DragEventArgs^  e) {
			bool dropOK = false;
			if (e->Data->GetDataPresent(DataFormats::FileDrop)) {
				ddfiles = static_cast<array<String^>^>(e->Data->GetData(DataFormats::FileDrop , false));
				for (int i = 0; i < ddfiles->Length; i++) {
					if (ddfiles[i]->ToUpper()->EndsWith(".VPD")) {
						dropOK = true;
						break;
					}
				}
			}
			if (dropOK) {//hbv\ȃt@ĈƂ
				e->Effect = DragDropEffects::Move;//Copy ƁA[+]}[NזȂ̂ŁB
				dding = true;
				this->timerTimeLineDrag->Enabled = true;
				ddScrollCount = config->Edit->DnDScrollCount;
			} else {//hbv\ȃt@C܂܂ȂƂ
				e->Effect = DragDropEffects::None;
			}
		}

	private:
		System::Void picTimeLine_DragLeave(System::Object^  sender, System::EventArgs^  e) {
			dding = false;
			ddfiles = nullptr;
			this->timerTimeLineDrag->Enabled = false;
			picTimeLine->Refresh();
		}

	private:
		System::Void picTimeLine_DragDrop(System::Object^  sender, System::Windows::Forms::DragEventArgs^  e) {
			if(e ->Data ->GetDataPresent(DataFormats::FileDrop)) // t@Chbv̂Ƃ
			{
				Keys key = Control::ModifierKeys;

				dding = false;
				this->timerTimeLineDrag->Enabled = false;

				//}EXJ[\ʒũ|WVʒu\
				Point clientPoint = picTimeLine->PointToClient(Point(e->X, e->Y));
				if (clientPoint.X < 0) {//clientPoint.X }CiXɂȂꍇ̑΍
					clientPoint.X = 0;
				}
				SMF::Position^ pos = gcnew SMF::Position(timeline->smf);
				pos->GlobalTick = (int)System::Math::Round((double)timeline->smf->MaxTick * (double)(clientPoint.X) / (double)picGauge->Width);
				if ((key & Keys::Control) == Keys::Control) {//Ctrl+NbN̂Ƃ
					pos->Tick = 0;//tick𔏂̓ɂB
				} else if (this->toolBtnGrid->CheckState == System::Windows::Forms::CheckState::Checked) {//Obhɍ킹
					int grid = (1 << this->toolCmdGrid->SelectedIndex);
					double step = (double)timeline->smf->Header.DeltaTime / (double)grid;
					if (config->Edit->GridClickOnLine) {
						pos->Tick = (int)System::Math::Round((int)System::Math::Round(pos->Tick / step) * step);
					} else {
						pos->Tick = (int)System::Math::Round(int(pos->Tick / step) * step);
					}
				}
				lastTimeLineMouseDownX = clientPoint.X;
				lastTimeLineMouseDownY = clientPoint.Y;

				//fIB
				ModelSelect(clientPoint.Y);

				//ddfiles = static_cast<array<String^>^>(e->Data->GetData(DataFormats::FileDrop , false));
				//MessageBox::Show(String::Join(", ", files));
				Pattern^ pat;
				if (ddfiles->Length == 1 && ddfiles[0]->ToUpper()->EndsWith(".VPD")
							&& (pat = PatternOver(Patterns::POSE, mouseMoveX, mouseMoveY)) != nullptr) {//|[Yf[^u
					MMD::VPD::Item^ old_vpd = pat->vpd->Copy();
					pat->vpd->FileName = ddfiles[0];
					pat->vpd->Open();

					Exec(gcnew Edit::ReplaceVPD(this, timeline, pat, old_vpd, pat->vpd));
				} else {//|[Yf[^Ǎ
					for (int i = 0; i < ddfiles->Length; i++) {
						if (ddfiles[i]->ToUpper()->EndsWith(".VPD")) {
							OpenVPD(sender, e, pos, ddfiles[i]);
						}
					}
				}
				ddfiles = nullptr;
				picTimeLine->Refresh();
			}
		}

	private:
		System::Void picTimeLine_DragOver(System::Object^  sender, System::Windows::Forms::DragEventArgs^  e) {
			//}EXJ[\ʒũ|WVʒu\
			ddPoint = picTimeLine->PointToClient(Point(e->X, e->Y));
			mouseMoveX = ddPoint.X;
			mouseMoveY = ddPoint.Y;
			ddPos = gcnew SMF::Position(timeline->smf);
			ddPos->GlobalTick = (int)System::Math::Round((double)timeline->smf->MaxTick * (double)(ddPoint.X) / (double)picGauge->Width);
			SetStatusPosition(ddPos->ToString());
			if (dding) {
				if (ddPoint.Y <= safe_cast<Model^>(timeline->Models[0])->Bottom) {//gm[̂Ƃ
					e->Effect = DragDropEffects::None;
				} else {//gm[ȊÔƂ
					if (ddfiles->Length == 1 && ddfiles[0]->ToUpper()->EndsWith(".VPD") && PatternOver(Patterns::POSE, mouseMoveX, mouseMoveY) != nullptr) {
						e->Effect = DragDropEffects::Copy;
					} else {
						e->Effect = DragDropEffects::Move;
					}
				}
			}
			picTimeLine->Refresh();
		}

	private:
		System::Void SelectAllPatterns(Model^ model, Patterns::Type type) {//Ifׂ̂Ẵp^[I
			selectedPatterns->Clear();//I
			for (int i = 0; i < model->Patterns->Count; i++) {
				Pattern^ pat = safe_cast<Pattern^>(model->Patterns[i]);
				if (type == Patterns::ALL || type == pat->Type) {//^Cv=ŵƂA܂́Aw肳ꂽ^Cv̂Ƃ
					selectedPatterns->AddPattern(pat);
				}
			}
			if (selectedPatterns->Count > 0) {//p^[IꂽƂ
				this->menuItemDeletePattern->Enabled = true;
				this->menuItemEditDeletePattern->Enabled = true;
				this->menuItemCutPattern->Enabled = true;
				this->menuItemCopyPattern->Enabled = true;
				this->menuItemEditCutPattern->Enabled = true;
				this->menuItemEditCopyPattern->Enabled = true;
			} else {//p^[IȂƂ
				this->menuItemDeletePattern->Enabled = false;
				this->menuItemEditDeletePattern->Enabled = false;
				this->menuItemCutPattern->Enabled = false;
				this->menuItemCopyPattern->Enabled = false;
				this->menuItemEditCutPattern->Enabled = false;
				this->menuItemEditCopyPattern->Enabled = false;
			}
			picTimeLine->Refresh();
		}

	private:
		System::Void menuItemSelectAllPattern_Click(System::Object^  sender, System::EventArgs^  e) {
			SelectAllPatterns(selectedModel, Patterns::ALL);//Ifׂ̂Ẵ^Cṽp^[I
		}

	private:
		System::Void menuItemSelectPosePattern_Click(System::Object^  sender, System::EventArgs^  e) {
			SelectAllPatterns(selectedModel, Patterns::POSE);//Ifׂ̂Ẵ|[Yp^[I
		}

	private:
		System::Void menuItemSelectMotionPattern_Click(System::Object^  sender, System::EventArgs^  e) {
			SelectAllPatterns(selectedModel, Patterns::MOTION);//Ifׂ̂Ẵ[Vp^[I
		}

	private:
		System::Void menuItemSelectPatternContainer_Click(System::Object^  sender, System::EventArgs^  e) {
			SelectAllPatterns(selectedModel, Patterns::CONTAINER);//Ifׂ̂Ă̕p^[I
		}

	private:
		System::Void menuItemSelectLipPattern_Click(System::Object^  sender, System::EventArgs^  e) {
			SelectAllPatterns(selectedModel, Patterns::LIPSYNC);//Ifׂ̂Ẵbvp^[I
		}

	private:
		System::Void menuItemSelectMIDIPattern_Click(System::Object^  sender, System::EventArgs^  e) {
			SelectAllPatterns(selectedModel, Patterns::MIDI);//Ifׂ̂Ẳtp^[I
		}

	private:
		System::Void menuItemSelectShortcutPattern_Click(System::Object^  sender, System::EventArgs^  e) {
			SelectAllPatterns(selectedModel, Patterns::SHORTCUT);//Ifׂ̂ẴV[gJbgI
		}

	private:
		System::Void menuItemSelectCommentPattern_Click(System::Object^  sender, System::EventArgs^  e) {
			SelectAllPatterns(selectedModel, Patterns::COMMENT);//Ifׂ̂ẴRgI
		}

	private:
		System::Void menuItemEditSelectAllPattern_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemSelectAllPattern_Click(sender, e);
		}

	private:
		System::Void menuItemEditSelectPosePattern_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemSelectPosePattern_Click(sender, e);
		}

	private:
		System::Void menuItemEditSelectMotionPattern_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemSelectMotionPattern_Click(sender, e);
		}

	private:
		System::Void menuItemEditSelectPatternContainer_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemSelectPatternContainer_Click(sender, e);
		}

	private:
		System::Void menuItemEditSelectLipPattern_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemSelectLipPattern_Click(sender, e);
		}

	private:
		System::Void menuItemEditSelectMIDIPattern_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemSelectMIDIPattern_Click(sender, e);
		}

	private:
		System::Void menuItemEditSelectShortcutPattern_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemSelectShortcutPattern_Click(sender, e);
		}

	private:
		System::Void menuItemEditSelectCommentPattern_Click(System::Object^  sender, System::EventArgs^  e) {
			menuItemSelectCommentPattern_Click(sender, e);
		}

	private:
		System::Void toolCmdGrid_TextChanged(System::Object^  sender, System::EventArgs^  e) {
			this->Activate();
			splitTimeLine->Focus();
			picTimeLine->Refresh();
		}

	private:
		System::Void TimeLineForm_Shown(System::Object^  sender, System::EventArgs^  e) {
			this->toolCmdGrid->SelectedIndex = config->Edit->Grid;
			if (config->Edit->OnGrid) {
				this->toolBtnGrid->CheckState = System::Windows::Forms::CheckState::Checked;
			} else {
				this->toolBtnGrid->CheckState = System::Windows::Forms::CheckState::Unchecked;
			}
		}

	private:
		System::Void toolBtnGrid_CheckStateChanged(System::Object^  sender, System::EventArgs^  e) {
			picTimeLine->Refresh();
		}

	public:
		System::Void UpdateEditMenu() {
			if (selectedPatterns->Count > 0) {//Iꂽp^[݂Ƃ
				this->menuItemCutPattern->Enabled = true;
				this->menuItemCopyPattern->Enabled = true;
				this->menuItemEditCutPattern->Enabled = true;
				this->menuItemEditCopyPattern->Enabled = true;
				this->menuItemDeletePattern->Enabled = true;
				this->menuItemEditDeletePattern->Enabled = true;
			} else {//Iꂽp^[݂ȂƂ
				this->menuItemCutPattern->Enabled = false;
				this->menuItemCopyPattern->Enabled = false;
				this->menuItemEditCutPattern->Enabled = false;
				this->menuItemEditCopyPattern->Enabled = false;
				this->menuItemDeletePattern->Enabled = false;
				this->menuItemEditDeletePattern->Enabled = false;
			}
			if (copyBuffer->Count > 0) {//Rs[obt@Ƀp^[݂Ƃ
				this->menuItemPastePattern->Enabled = true;
				this->menuItemEditPastePattern->Enabled = true;
			} else {//Rs[obt@Ƀp^[݂ȂƂ
				this->menuItemPastePattern->Enabled = false;
				this->menuItemEditPastePattern->Enabled = false;
			}
			SelectPatternMenuUpdate(selectedModel);
		}

	private:
		System::Void menuTimeLine_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void toolTimeLine_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void toolBtnZoomOut_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void toolBtnZoomIn_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void toolBtnGrid_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void toolCmdGrid_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void splitTimeLine_Panel2_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void splitModelName_Panel2_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void splitTimeLine_Panel1_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void picGauge_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void splitModelName_Panel1_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void lblDeltaTime_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void txtPosition_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void txtInputName_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void TimeLineForm_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void TimeLineForm_Resize(System::Object^  sender, System::EventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void TimeLineForm_Move(System::Object^  sender, System::EventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void splitTimeLine_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void splitModelName_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void splitParent_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}
};
}
