#include "StdAfx.h"
#include "SMF.h"
#include "SMF_Position.h"

namespace SMF {

	File::File(void)
	{
		beat_1st = gcnew Beat();
		BeatChanges = gcnew ArrayList();
		TempoChanges = gcnew ArrayList();
		m_MaxTick = -1;//`

	}

	System::Void File::Open(String^ strFilename) {
		int i;//[vpϐ
		int t;//gbN[vpϐ

		BeatChanges = gcnew ArrayList();
		TempoChanges = gcnew ArrayList();


		Filename = strFilename;

		//
		// t@Cf[^ǂݍ
		//


		FileInfo^ fi = gcnew FileInfo(strFilename);
		FileStream^ fs = fi->OpenRead();

		//MessageBox::Show(fi->Length.ToString(), "length");

		try {

			if (fi->Length > 0xffffffff) {
				throw(String::Concat("t@CTCY傫܂B"));
			} else {
				int nBytes = int(fi->Length & 0xffffffff);

				beat_1st->nn = beat_1st->dd = 0;

				
				m_bytData = gcnew array<Byte>(nBytes);
				m_nBytesRead = fs->Read(m_bytData, 0, nBytes);

				m_nPos = (m_nBytesRead == 0 ? 1 : 0); //ǂݍ񂾃oCg0̏ꍇ͓ǂݏoʒu1ɂEOF()=TRUEɂȂ悤ɂB

				try {
					if (EOF()) {
						throw(String::Concat("X^_[hMIDIt@Cł͂܂B"));
					} else {
						//wb_̓ǂ݂

						//`N^Cṽ`FbN
						for (i = 0; i < 4; i++, m_nPos++) {
							if (EOF()) {
								throw(String::Concat("X^_[hMIDIt@Cł͂܂B"));
							} else {
								if (Header.Type[i] != m_bytData[m_nPos]) {
									throw(String::Concat("X^_[hMIDIt@Cł͂܂B"));
								}
							}
						}

						//f[^TCỸ`FbN
						int nHeaderSize = 0;
						for (i = 0; i < 4; i++, m_nPos++) {
							if (EOF()) {
								throw(String::Concat("X^_[hMIDIt@Cł͂܂B"));
							} else {
								nHeaderSize = (nHeaderSize << 8) + m_bytData[m_nPos];
							}
						}
						if (nHeaderSize != Header.Length) {
							throw(String::Concat("X^_[hMIDIt@Cł͂܂B"));
						}

						//tH[}bg̓ǂ݂
						Header.Format = 0;
						for (i = 0; i < 2; i++, m_nPos++) {
							if (EOF()) {
								throw(String::Concat("X^_[hMIDIt@Cł͂܂B"));
							} else {
								Header.Format = (Header.Format << 8) + m_bytData[m_nPos];
							}
						}
						if (Header.Format != 0 && Header.Format != 1) {//tH[}bg0,1̂ݑΉ
							throw(String::Concat("Ή̃tH[}bgłB"));
						}

						//gbN̓ǂ݂
						Header.Tracks = 0;
						for (i = 0; i < 2; i++, m_nPos++) {
							if (EOF()) {
								throw(String::Concat("X^_[hMIDIt@Cł͂܂B"));
							} else {
								Header.Tracks = (Header.Tracks << 8) + m_bytData[m_nPos];
							}
						}
						if (Header.Tracks == 0) {
							throw(String::Concat("gbN݂܂B"));
						} else if (Header.Format == 0 && Header.Tracks > 1) {
							throw(String::Concat("tH[}bg0̃gbNsłB"));
						}

						//gbN̍쐬
						Tracks = gcnew array<Track^>(Header.Tracks);

						//gbNʓǂݏoʒu̍쐬
						m_nTrackPos = gcnew array<int>(Header.Tracks);


						//ԒPʂ̓ǂ݂݁il̃f^^ĈݑΉ)
						Header.DeltaTime = 0;
						for (i = 0; i < 2; i++, m_nPos++) {
							if (EOF()) {
								throw(String::Concat("X^_[hMIDIt@Cł͂܂B"));
							} else {
								Header.DeltaTime = (Header.DeltaTime << 8) + m_bytData[m_nPos];
							}
						}
						if (Header.DeltaTime & 0x8000) {//l̃f^^ĈݑΉ
							throw(String::Concat("Ή̃tH[}bgłB"));
						}

						//gbN̓ǂ݂
						for (t = 0; t < Header.Tracks; t++) {
							//CX^X̍쐬
							Tracks[t] = gcnew Track();

							//`N^Cṽ`FbN
							for (i = 0; i < 4; i++, m_nPos++) {
								if (EOF()) {
									throw(String::Concat("X^_[hMIDIt@Cł͂܂B"));
								} else {
									if (Tracks[t]->Type[i] != m_bytData[m_nPos]) {
										throw(String::Concat("X^_[hMIDIt@Cł͂܂B"));
									}
								}
							}

							//f[^TCY̓ǂ݂
							Tracks[t]->Length = 0;
							for (i = 0; i < 4; i++, m_nPos++) {
								if (EOF()) {
									throw(String::Concat("X^_[hMIDIt@Cł͂܂B"));
								} else {
									Tracks[t]->Length = (Tracks[t]->Length << 8) + m_bytData[m_nPos];
								}
							}

							//Cxgf[^Jnʒu
							Tracks[t]->Pos = m_nPos;
							m_nTrackPos[t] = m_nPos;

							//ǂݍ݈ʒũgbNɐi߂
							m_nPos += Tracks[t]->Length;
							//MessageBox::Show(String::Format("TRK:{0}; Length={1}", t, Tracks[t]->Length), "info");
						}
					}

				} catch(String^ strError) {
					//delete [] m_bytData;
					MessageBox::Show(strError, "error");
					return;
				}
			}

		} catch(String^ strError) {
			MessageBox::Show(strError, "error");
			return;
		}

		//
		// MIDICxgf[^̒o
		//

		int max_tr = 0;

		m_MaxTick = 0;
		MinTick = 0x7fffffff;

		for (t = 0; t < Header.Tracks; t++) {
			//MessageBox::Show(String::Format("{0}/{1}", t, smf->Header.Tracks), "track");
			int tick = 0;
			int status_bak = 0;
			while (!EOF(t)) {
				Event^ ev = GetEvent(t);
				tick += ev->DeltaTime;
				if (tick > m_MaxTick) {
					m_MaxTick = tick;
					max_tr = t;
				}
				if (ev->status == 0) {
					ev->status = status_bak;
				}
				if ((ev->status & 0xf0) == 0x90) {//m[gICxĝƂ
					if (tick < MinTick) {
						MinTick = tick;
					}
				}
				if (0x80 <= ev->status && ev->status <= 0xef) {//`lbZ[W
					status_bak = ev->status;
				}
				ev->GlobalTick = tick;
				Tracks[t]->Events->Add(ev);


				if (ev->status == 0x51) {//e|f[^TempoChangesRNVɊi[B
					
					//̂̃f[^Ae|f[^gbNɂ܂Ăꍇ̑Ώ
					int c = TempoChanges->Count;
					for (i = 0; i < c; i++) {
						if (safe_cast<TempoChange^>(TempoChanges[i])->Tick > tick) {//tick傫ꍇ
							//̑OinsertB
							TempoChange^ tc = gcnew TempoChange();
							tc->Tick = tick;
							tc->Track = t;
							tc->Tempo = CalcTempo(ev->Data);
							TempoChanges->Insert(i, tc);
							break;
						}
					}
					if (c == TempoChanges->Count) {//L[vinsertȂꍇ
						//ǉ
						TempoChange^ tc = gcnew TempoChange();
						tc->Tick = tick;
						tc->Track = t;
						tc->Tempo = CalcTempo(ev->Data);
						TempoChanges->Add(tc);
					}
				}

				if (ev->status == 0x58) {//qύXBeatChangesRNVɊi[B
					Beat^ beat = gcnew Beat();
					beat->SetBeat(ev->Data[0], 1 << ev->Data[1], ev->Data[2], ev->Data[3]);
					BeatChanges->Add(gcnew BeatChange(beat, tick));
				}
			}
		}

		//ԍŌ̃f[^
		TempoChange^ tc = gcnew TempoChange();
		tc->Tick = m_MaxTick;
		tc->Track = max_tr;
		tc->Tempo = safe_cast<TempoChange^>(TempoChanges[TempoChanges->Count - 1])->Tempo;
		TempoChanges->Add(tc);

		//e|Ƀt[ǉB
		CalcFrameAtTempoTable();
		//qύXɏߏǉB
		CalcMeasureAtBeatTable();
	}

	System::Void File::CalcFrameAtTempoTable() {//e|e[ũt[ČvZB
		if (TempoChanges->Count > 0) {//e|񂪑݂ꍇ(ꉞe|͂Ȃ΂Ȃ炵)
			double time = 0.0;
			int tick_bak = safe_cast<TempoChange^>(TempoChanges[0])->Tick;
			double tempo_bak = safe_cast<TempoChange^>(TempoChanges[0])->Tempo;
			double frame_bak = 0.0;
			safe_cast<TempoChange^>(TempoChanges[0])->Frame = frame_bak;
			for (int i = 1; i < TempoChanges->Count; i++) {
				int tick = safe_cast<TempoChange^>(TempoChanges[i])->Tick;
				double tempo = (i < TempoChanges->Count - 1 ? safe_cast<TempoChange^>(TempoChanges[i])->Tempo : tempo_bak);
				double frame = frame_bak + (tick - tick_bak) * 60.0 * 30.0 / (Header.DeltaTime * tempo_bak);
				safe_cast<TempoChange^>(TempoChanges[i])->Frame = frame;
				tick_bak = tick;
				tempo_bak = tempo;
				frame_bak = frame;
			}
		}
	}

	System::Void File::CalcTickAtBeatTable() {//߈ʒuƂɂĔqύXe[uTickČvZB
		safe_cast<BeatChange^>(BeatChanges[0])->Measure = 1;//ԍŏ̔qύX̏߂1ߖځB
		SMF::Position^ pos = gcnew SMF::Position(this);
		for (int i = 0; i < BeatChanges->Count; i++) {
			SMF::BeatChange^ bc = safe_cast<BeatChange^>(BeatChanges[i]);
			pos->BeatInfo = bc->BeatInfo->Copy();
			pos->Measure = bc->Measure;
			pos->Beat = 1;
			pos->Tick = 0;
			bc->Tick = pos->GlobalTick;
		}
	}

	System::Void File::CalcMeasureAtBeatTable() {//TickƂɂĔqύXe[ȕ߂ČvZB
		safe_cast<BeatChange^>(BeatChanges[0])->Measure = 1;//ԍŏ̔qύX̏߂1ߖځB
		SMF::Position^ pos = gcnew SMF::Position(this);
		for (int i = 0; i < BeatChanges->Count; i++) {
			SMF::BeatChange^ bc = safe_cast<BeatChange^>(BeatChanges[i]);
			pos->BeatInfo = bc->BeatInfo->Copy();
			pos->GlobalTick = bc->Tick;
			bc->Measure = pos->Measure;
		}
	}

	Event^ File::GetEvent(int t) {
		Event^ ev = gcnew Event;

		try {

			if (EOF(t)) throw(String::Concat("f[^ُłB"));
			//f^^C̓ǂݏoB
			ev->DeltaTime = ReadVariableLengthData(t);

			//Cxgf[^̓ǂݏo
			int nBytes;
			if (EOF(t)) throw(String::Concat("f[^ُłB"));
			ev->status = m_bytData[m_nTrackPos[t]++];
			if (0x80 <= ev->status && ev->status <= 0xef) {//`lbZ[W
				if (0xc0 <= ev->status && ev->status <= 0xdf) {
					nBytes = 1;
				}else {
					nBytes = 2;
				}
				ev->Data = gcnew array<Byte>(nBytes);
				for (int i = 0; i < nBytes; i++) {
					if (EOF(t)) throw(String::Concat("f[^ُłB"));
					ev->Data[i] = m_bytData[m_nTrackPos[t]++];
				}
			} else if (0x00 <= ev->status && ev->status <= 0x7f) {//jOXe[^X
				nBytes = 2;
				ev->Data = gcnew array<Byte>(nBytes);
				ev->Data[0] = ev->status;
				if (EOF(t)) throw(String::Concat("f[^ُłB"));
				ev->Data[1] = m_bytData[m_nTrackPos[t]++];
				ev->status = 0;
			} else if (ev->status == 0xf0 || ev->status == 0xf7) {//SysExbZ[W
				nBytes = ReadVariableLengthData(t);
				ev->Data = gcnew array<Byte>(nBytes);
				for (int i = 0; i < nBytes; i++) {
					if (EOF(t)) throw(String::Concat("f[^ُłB"));
					ev->Data[i] = m_bytData[m_nTrackPos[t]++];
				}
			} else if (ev->status == 0xff) {//^Cxg
				if (EOF(t)) throw(String::Concat("f[^ُłB"));
				ev->status = m_bytData[m_nTrackPos[t]++];
				nBytes = ReadVariableLengthData(t);
				ev->Data = gcnew array<Byte>(nBytes);
				for (int i = 0; i < nBytes; i++) {
					if (EOF(t)) throw(String::Concat("f[^ُłB"));
					ev->Data[i] = m_bytData[m_nTrackPos[t]++];
				}
			} else {//̑
				//łȂB
				throw(String::Concat("f[^ُłB"));
			}
		} catch(String^ strError) {
			MessageBox::Show(strError, "error");
		}

		return ev;
	}

	int File::ReadVariableLengthData(int t) {
		int ret = 0;

		while (true) {
			ret = (ret << 7) + (m_bytData[m_nTrackPos[t]] & 0x7f);
			if (EOF(t)) throw(String::Concat("f[^ُłB"));
			if ((m_bytData[m_nTrackPos[t]] & 0x80) == 0) {
				m_nTrackPos[t]++;
				break;
			} else {
				m_nTrackPos[t]++;
			}
		};

		return ret;
	}

	int File::GetBytesRead() {
		return m_nBytesRead;
	}

	bool File::EOF() {
		return m_nPos >= m_nBytesRead;
	}

	bool File::EOF(int t) {
		return m_nTrackPos[t] >= Tracks[t]->Pos + Tracks[t]->Length;
	}

	void File::MoveFirst() {
		m_nPos = 0;
	}

	void File::MoveFirst(int t) {
		m_nTrackPos[t] = Tracks[t]->Pos;
	}

	String^ File::ComposeHexDump(array<Byte>^ bytData) {//16i_vXg̍쐬
		String^ ret = "";

		for (int i = 0; i < bytData->Length; i++) {
			ret += String::Format(CultureInfo::CurrentCulture, "{0,2:X2}", bytData[i]);
			//ret = ret + bytData[i].ToString("X")->PadLeft(2, "0");//ł[Ŗ܂炵ARpCŃG[ɂȂB
			//PadLeft(2, '0')炵B
			if (i < bytData->Length - 1) {
				ret += " ";
			}
		}

		return ret;
	}

	double File::CalcTempo(array<Byte>^ bytData) {
		int tempo_data = 5000000;
		try {
			if (bytData->Length != 3) {
				throw(String::Format("e|f[^̃TCYُ({0:D}oCg)łB", bytData->Length));
			}
			tempo_data = (((bytData[0] <<  8) + bytData[1]) << 8) + bytData[2];
		} catch (String^ strError) {
			MessageBox::Show(strError, "tempo error");
		}
		return 60.0 * 1000.0 * 1000.0 / tempo_data;//1(=60b=60*1000mb=60*1000*1000ʕb)/l̒(ʕb)
	}

	System::Void File::SetMaxTick(int new_maxTick) {
		int old_maxTick = m_MaxTick;
		m_MaxTick = new_maxTick;

		//e|`FWe[u̍XV
		TempoChange^ tc = safe_cast<TempoChange^>(TempoChanges[TempoChanges->Count - 1]);// ԍŌ̃e|
		tc->Tick = new_maxTick;//e|`FWe[űȒXV
		CalcFrameAtTempoTable();//e|e[ũt[ČvZB

		int tr = tc->Track;//ԍŌ̃Cxg݂̑gbN

		//MIDICxge[u̍XV
		Event^ ev = safe_cast<Event^>(Tracks[tr]->Events[Tracks[tr]->Events->Count - 1]);//ԍŌ̃Cxg
		ev->GlobalTick = new_maxTick;//MIDICxge[űȒXV
	}
} //SMF
