#pragma once


using namespace System;
using namespace System::IO;
using namespace System::Windows::Forms;
using namespace System::Globalization;
using namespace System::Collections;
using namespace System::Text;

#include "SMF_Header.h"
#include "SMF_Track.h"
#include "SMF_Event.h"
#include "SMF_Beat.h"
#include "SMF_BeatChange.h"
#include "SMF_TempoChange.h"

namespace SMF {

	public ref class File
	{
	public:
		File(void);
		void Open(String^);
		int GetBytesRead();//ǂݍ܂ꂽf[^̃oCgԂ
		bool EOF();//true=ǂݍ݃f[^I
		bool EOF(int);//true=gbNf[^I
		void MoveFirst();//ǂݍ݃f[^ǂݏoʒu擪ɈړB
		void MoveFirst(int);//gbNf[^ǂݏoʒu擪ɈړB
		Event^ GetEvent(int);//Cxg1oāAǂݏoʒu1ɐi߂B
		int ReadVariableLengthData(int);//gbN̉ϒf[^ǂݏoB
		static double CalcTempo(array<Byte>^);//e|̌vZ
		String^ ComposeHexDump(array<Byte>^);//16i_vXg̍쐬
		System::Void CalcFrameAtTempoTable();//e|e[ũt[ČvZB
		System::Void CalcTickAtBeatTable();//߈ʒuƂɂĔqύXe[uTickČvZB
		System::Void CalcMeasureAtBeatTable();//TickƂɂĔqύXe[ȕ߂ČvZB

		//ϐ
		Header Header;//SMFwb_ (RpCŃG[oȂAƓǁAȏOKȂ̂ǂsSMF::Header SMF::File::Header Ȃ̂ł炵)
		array<Track^>^ Tracks;//SMFgbN
		static array<String^, 2>^ key = {
									{"σn", "σCZ"},
									{"σg", "σzZ"},
									{"σj", "σZ"},
									{"σC", "wZ"},
									{"σz", "nZ"},
									{"σ", "gZ"},
									{"w", "jZ"},
									{"n", "CZ"},
									{"g", "zZ"},
									{"j", "Z"},
									{"C", "d֒Z"},
									{"z", "dnZ"},
									{"", "dgZ"},
									{"d֒", "dZ"},
									{"dn", "dCZ"}};
		property int MaxTick {//Cxg̍őTick
			int get() {
				return m_MaxTick;
			}
			void set(int new_MaxTick) {
				SetMaxTick(new_MaxTick);
			}
		}
		int MinTick;//Cxg̍ŏ̃m[gONTick
		Beat^ beat_1st;//Ԃ̔q(qύXɑΉp~邩)
		ArrayList^ BeatChanges;//qύX̃Xg
		ArrayList^ TempoChanges;//e|`FW̃Xg
		String^ Filename;//ǂݍSMF̃t@Cl[

	private:
		array<Byte>^ m_bytData;//ǂݍ܂ꂽf[^̔z
		int m_nBytesRead;//ǂݍ܂ꂽf[^̃oCg
		int m_nPos;//f[^̓ǂݏoʒu
		array<int>^ m_nTrackPos;//gbNf[^̓ǂݏoʒu
		int m_MaxTick;
		System::Void SetMaxTick(int);
	};

} //SMF
