#pragma once

#include "SMF.h"

/*
	^CCł̈ʒuB
	smf SMF̃f[^ݒ肵ĂƂŁAʂTick(GlobalTick)ݒ肷ƁA
	(Measure)E(Beat)Etick(Tick,RegularTick)vZA
	tɁA(Measure)E(Beat)Etick(Tick ܂ RegularTick)ݒ肷ƁA
	ʂTick(GlobalTick)vZ悤ɂB
	smf ւāAqƂ\ςƂ́AGlobalTick珬߁EEtick
	vZȂ悤ɂB
	t[ԍƂ̊Z@\B
*/

namespace SMF {

	public enum CalcPositionMode {//CalcPosition()ł̎Ԃ̍ČvZ̃[h
		FROM_FRAME = 0,//t[ԍA߁EEtick ƁAʂTickvZB
		FROM_GLOBAL_TICK,//ʂTickAt[ԍƁA߁EEtickvZB
		FROM_MEASURE//߁EEtickAt[ԍƁAʂTickvZB
	};

	public ref class Position
	{
	public:
		Position(void);
		Position(SMF::File^);
		Position^ Copy();//g̕쐬B

		virtual System::String^ ToString(void) override;//JE^[񐶐
		System::Void Add(SMF::Position^);//߂ƂƂB

		//ϐ
		int ShiftTick;//ۂ̃^C~Otick炷AwB
		int ShiftFrame;//ۂ̃^C~Ot[炷A̎wB
		property SMF::File^ smf {//SMF̃f[^
			SMF::File^ get() {
				return m_smf;
			}
			void set(SMF::File^ new_smf) {
				//TODO: new_smf ɊÂGlobalTick珬߁EEtickvZȂB
				m_smf = new_smf;
			}
		}
		property int Frame {//t[ԍ
			int get() {
				return m_Frame;
			}
			void set(int new_Frame) {
				m_Frame = new_Frame;
				if (m_Frame < 0) m_Frame = 0;//G[΍
				if (smf != nullptr) {//MIDIf[^ݒ肳Ăꍇ
					CalcPosition(FROM_FRAME);
				}
			}
		}
		property int GlobalTick {//ʂTickʒu
			int get() {
				return m_GlobalTick;
			}
			void set(int new_GlobalTick) {
				m_GlobalTick = new_GlobalTick;
				if (m_GlobalTick < 0) m_GlobalTick = 0;//G[΍
				if (smf != nullptr) {//MIDIf[^ݒ肳Ăꍇ
					CalcPosition(FROM_GLOBAL_TICK);
				}
			}
		}
		property int Measure {//
			int get() {
				return m_Measure;
			}
			void set(int new_Measure) {
				m_Measure = new_Measure;
				if (smf != nullptr) {//MIDIf[^ݒ肳Ăꍇ
					if (m_Measure < 1) m_Measure = 1;//G[΍
					CalcPosition(FROM_MEASURE);
				} else {
					if (m_Measure < 0) m_Measure = 0;//G[΍
				}
			}
		}
		property int Beat {//
			int get() {
				return m_Beat;
			}
			void set(int new_Beat) {
				m_Beat = new_Beat;
				if (smf != nullptr) {//MIDIf[^ݒ肳Ăꍇ
					if (m_Beat < 1) m_Beat = 1;//G[΍
					CalcPosition(FROM_MEASURE);
					if (Beat > MaxBeat) {
						CalcPosition(FROM_GLOBAL_TICK);//BeatMaxBeat𒴂ꍇ̕␳
					}
				} else {
					if (m_Beat < 0) m_Beat = 0;//G[΍
				}
			}
		}
		property int Tick {//Płtickʒu
			int get() {
				return m_Tick;
			}
			void set(int new_Tick) {
				m_Tick = new_Tick;
				if (m_Tick < 0) m_Tick = 0;//G[΍
				if (smf != nullptr) {//MIDIf[^ݒ肳Ăꍇ
					CalcPosition(FROM_MEASURE);
					//System::Diagnostics::Debug::Assert(this->BeatInfo->dd != 0, "smf != nullptr ̂ƂAq̕ꂪ[ɂȂ̂͂B");
					if (Tick > MaxTick) {
						CalcPosition(FROM_GLOBAL_TICK);//TickMaxTick𒴂ꍇ̕␳
					}
				}
			}
		}
		property double RegularTick {//1̈ʒu̔̓̊(0.0 ` 1.0; smf->Header.DeltaTime ɂȂ)
			double get() {
				return m_RegularTick;
			}
			void set(double new_RegularTick) {
				m_RegularTick = new_RegularTick;
				if (smf != nullptr) {//MIDIf[^ݒ肳Ăꍇ
					CalcPosition(FROM_MEASURE);
				}
			}
		}
		property int MaxBeat {//(QƂ̂)݂̏߂ł̍ő唏=q̕q
			int get() {
				return BeatInfo->nn;
			}
		}
		property int DeltaTime {//(QƂ̂)݂̏߂ł1̕\
			int get() {
				if (BeatInfo->dd > 0) {//qݒ肳ĂƂ
					return smf->Header.DeltaTime * 4 / BeatInfo->dd;//q̉̃̕f^^CԂB
				} else {//qݒ肳ĂȂƂ
					return smf->Header.DeltaTime;//4̃f^^CԂB
				}
			}
		}
		property int MaxTick {//(QƂ̂)݂̏߂ł1tick̍ől(\-1)
			int get() {
				return DeltaTime - 1;
			}
		}
		SMF::Beat^ BeatInfo;

	protected:
		void CalcPosition(CalcPositionMode);//߁EEtickA邢͒ʂTickA邢̓t[ԍZoB
		int GetTickFromFrame(double);//t[ԍAʂTick𓾂B
		double GetFrameFromTick(int);//ʂTickAt[ԍ𓾂B

		//ϐ
		SMF::File^ m_smf;
		int m_Frame;
		int m_GlobalTick;
		int m_Measure;
		int m_Beat;	
		int m_Tick;
		double m_RegularTick;
	};

}//SMF
